﻿/*DifferenceTool berechnet ein Differenz bild aus auf den Flächen abgelegten Bildern.*/

package  com.tools {
	
import com.events.SatCalcEvent;
import flash.display.Sprite;
import flash.display.*;
import flash.geom.*;
import flash.text.*;
import flash.events.*;
import FISEvents;
import com.utilities.*;
import flash.ui.Mouse;
import flash.utils.*;
import flash.net.*;


	public class DifferenceTool extends SatCalcDisplay {
	
	public var OutAt_X:int;					// an welche Stage Koordinaten werden die Overlays ausgegeben
	public var OutAt_Y:int;
	public var VectTool_mc:MovieClip; 
	public var HasDropFields:Boolean;
	public var HasGhosts:Boolean;
	public var DropFields:Array;
	public var A_Image_koord:Point;
	public var B_Image_koord:Point;
	public var ToolDims:Array;				// Die Abmessungen der Tools. Wird im SatCalculator benötigt um die Positionierung vorzunehmen
	public var Ident:String;				// Gleicht dem Namen des Objektes im Satcalculator
	
	private var MessageTimer:Timer;		// Die Rückmeldung wenn NDVI berechnet wird braucht ein wenig Vorsprung, weil sie sonst nicht angezeigt wird
	
	private var Data_A:Array;			// Array mit den Daten des A_Bildes
	private var Data_B:Array;			// Array mit den Daten des B_Bildes
	public var DiffTool:MovieClip; 
	public var NameOfData:Array;			// Die Namen der in der Rechung verwendeten Clips kommen hier rein

	private var DataWidth_:int;
	private var DataHeight_:int;
	
	private var AllocationStatus:Array;		// Zwiestellliges Array in dem abglegt ist ob Data_A oder B belegt sind
	
	private var A_MetaData:Array;	// MetaDaten zum A_BILD
	private var B_MetaData:Array;	// MetaDaten zum B_BILD
	private var AB_MetaData:Array;	// MetaDaten zum erzeugeten BILD
	
		public function DifferenceTool(outX:int,outY:int,varArr:Array,ID:String){
			
			Ident = ID;
			
			// Die Positionen der Dropflächen im Lokalen Objekt
			
			A_Image_koord = new Point(30,2);
			B_Image_koord = new Point(100,2);
			
			
			
			trace ("LOCALLLLLLLLLLLLLLLLLLLLRUNDE " +localToGlobal(A_Image_koord))
			
			// Das Array in dem alle relevanten Daten zu den DropFields gespeichert sind
			
			trace ("Variablen im Difference Tool "+varArr);
			
			DropFields = new Array();
			
			NameOfData = new Array();
			
			HasDropFields = true;
			HasGhosts	= false;
			trace ("DifferenceTool INVOKED");
			
			OutAt_X=outX;
			OutAt_Y=outY;
			
			this.addEventListener(SatCalcEvent.DATA_DROP,dataDropped);
			this.addEventListener(SatCalcEvent.DATA_DELETE,removeData);
			
			DiffTool = new DifferenceTool_mc;
			addChild(DiffTool);
			DiffTool.Subst_mc.visible = false;
			DiffTool.Subst_mc.gotoAndStop(1);
			DiffTool.Subst_mc.buttonMode = true;
			ToolDims = new Array();
			ToolDims[0] =[DiffTool.width,DiffTool.height];
			
			DiffTool.Subst_mc.addEventListener(MouseEvent.MOUSE_DOWN,messageAndStart);
			
			DropFields[0] = [Ident,"A_Image",A_Image_koord];
			DropFields[1] = [Ident,"B_Image",B_Image_koord];
			
			DiffMetaData = new Array("Image_A","Image_B")
			
			
			AllocationStatus = new Array();
			AllocationStatus =[false,false];
			
			
			
		}// Constructor close
		
		
		// Das e.data array beinhaltet: Name des getroffenen Dropfields(HotDropField),DatenArray(recentArray),recentButton.Ghost_mc,recentButton.name,recentButton.DataWidth,recentButton.DataHeight,recentButton.kanal,recentButton.Resolution,recentButton.Unit,recentButton.datum]
		//															0						1							2				3					4						5							6					7					8				9				
		private function dataDropped(e:SatCalcEvent){
		
		var DroppedOn:String = e.data[0];
		// Erst wird überprüft ob das Dropfield für dieses Tool überhaupt relevant ist
		var isRelevant:Boolean = checkDropfields(e.data[0]);
			if (isRelevant == true){
				trace ("erhalte daten für: "+e.data[0]);
				trace ("Testdaten: "+e.data[1][1599]);
				trace ("erhalte daten für: "+e.data[0]);
				switch (DroppedOn){
					
					case "A_Image":
					Data_A = e.data[1];
					AllocationStatus[0] = true;
					NameOfData.push([e.data[3],DroppedOn]);
					trace ("A_ImageData wurde bestückt :"+ Data_A[1599] + " von " +NameOfData + " WH "+e.data[4]+" "+e.data[5]);
					DataWidth_=e.data[4];
					DataHeight_=e.data[5];
					A_MetaData = new Array(e.data[3],e.data[4],e.data[5],e.data[6],e.data[7],e.data[8],e.data[9]);
					break;
					
					case "B_Image":
					Data_B = e.data[1];
					AllocationStatus[1] = true;
					NameOfData.push([e.data[3],DroppedOn]);
					trace ("B_ImageData wurde bestückt :"+ Data_A[1599] + " von " +NameOfData + " WH "+e.data[4]+" "+e.data[5]);
					DataWidth_=e.data[4];
					DataHeight_=e.data[5];
					B_MetaData = new Array(e.data[3],e.data[4],e.data[5],e.data[6],e.data[7],e.data[8],e.data[9]);
					break;
				}
				
				trace ("A_Image: "+ A_MetaData);
				trace ("B_Image: "+ B_MetaData);
				checkCalcButton();
			}
		}
	
	
	// Ist der Calc Button in abhängigkeit vom Allocation Status Array sichtbar oder nicht
		
		private function checkCalcButton(){
			trace ("Zustand vonn Allocation "  + AllocationStatus);
			if (AllocationStatus[0]==true && AllocationStatus[1] == true){
				DiffTool.Subst_mc.visible = true;
			}
			else {DiffTool.Subst_mc.visible = false};
		}
	
	
	// Kombiniert die Metadatenarrays der eingangsdaten zu einem MetadatenArray ders Ergebnisbildes
		private function mergeMetaArray():Array{
			
			var returnArray:Array = new Array();
					
					// Prüfen auf Bildbreite
					if (A_MetaData[1] == B_MetaData[1]){
						returnArray.push(A_MetaData[1])
					}
						else if (A_MetaData[1] > B_MetaData[1])
						{returnArray.push(A_MetaData[1])}
							
						else if (A_MetaData[1] < B_MetaData[1])
						{returnArray.push(B_MetaData[1])};
					
					// Prüfen auf Bildhöhe
					
					if (A_MetaData[2] == B_MetaData[2]){
						returnArray.push(A_MetaData[2])
					}
						else if (A_MetaData[2] > B_MetaData[2])
						{returnArray.push(A_MetaData[2])}
							
						else if (A_MetaData[2] < B_MetaData[2])
						{returnArray.push(B_MetaData[2])};
					
					// Prüfen auf Namen
					
					//if (RMetaData[0] == IRMetaData[0]){
						var combineNames:String = "A:"+A_MetaData[0] +"\n"+"B:"+B_MetaData[0];
						returnArray.push(combineNames)
					//}
					//	else{returnArray.push("mismatch")}
					
					
					// Kanal kommt raus ist jetzt NDVI
					
					returnArray[3] = "DIFF";
					
					// Prüfen auf Auflösung
					if (A_MetaData[4] == B_MetaData[4]){
						returnArray.push(A_MetaData[4])
					}
						else{returnArray.push("mismatch")}
					
					// Prüfen auf Einheit
					
					if (A_MetaData[5] == B_MetaData[5]){
						returnArray.push(A_MetaData[5])
					}
						else{returnArray.push("mismatch")}
						
						// Prüfen auf Datum
					
					if (A_MetaData[6] == B_MetaData[6]){
						returnArray.push(A_MetaData[6])
					}
						else{returnArray.push("mismatch")}
						
				return returnArray;
	
	}
	
	
	private function messageAndStart(e:MouseEvent){
			dispatchEvent(new SatCalcEvent(SatCalcEvent.AIR_MESSAGE,[true,"Differenzbild"+"\n"+"wird berechnet"]));
			MessageTimer = new Timer(100,1);
			MessageTimer.addEventListener(TimerEvent.TIMER_COMPLETE,calcDifference);
			MessageTimer.start();
	}
	
	private function calcDifference(e:TimerEvent){
			MessageTimer.removeEventListener(TimerEvent.TIMER_COMPLETE,calcDifference);
			// Das Array welches an den SatCalc weitergegeben wird mit DatenArray und Metadaten und 
			var outArray:Array = new Array();
			trace ("Länge des DatenArray: "+Data_A.length);
			 var DIFF_Calc:ImageCalc = new ImageCalc(Data_A,Data_B,DataWidth_,DataHeight_);
			 DIFF_Calc.substAB();
			 outArray =  mergeMetaArray();
			 trace ("OUTARRAY: " +  outArray);
			 //outArray.push(Array(NDVI_Calc.NDVIDataArray));
			 this.dispatchEvent(new SatCalcEvent(SatCalcEvent.DATA_DISPLAY,[DIFF_Calc.SUBSTDataArray,outArray[0],outArray[1],outArray[2],outArray[3],outArray[4],outArray[5],outArray[6]]));
														//							Daten				width		height		Name		NDVI	Auflösung	 Einheit		Datum						
			clearData("A_Image");
			clearData("B_Image");
			checkCalcButton();
			dispatchEvent(new SatCalcEvent(SatCalcEvent.AIR_MESSAGE,[false,""]));
	}
		
		
		private function removeData(e:SatCalcEvent){
			var toRemove:String = e.data;
			trace (toRemove + " soll fliegen");
			trace (NameOfData);
			for(var i=0;i<NameOfData.length;i++){
				if (NameOfData[i][0]==toRemove){
				trace (NameOfData[i][0] +" fliegt");
				clearData(NameOfData[i][1]);
				NameOfData.splice(i,1);
				}
			}
		}
		
		// Die Datenarrays werden zurückgesetzt  
		private function clearData(rem:String){
			switch (rem){
				case "A_Image":
				Data_A = new Array();
				AllocationStatus[0] = false;
				break;
				
				case "B_Image":
				Data_B = new Array();
				AllocationStatus[1] = false;
				break;
				
			}
			checkCalcButton();
	
		}
		
			// Überprüft, ob das aktivierte Dropfield Teil des Tools ist
		private function checkDropfields(Dropfield:String){
			var returnVar:Boolean = false;
			var i:int
			while (i<DropFields.length){
				if (DropFields[i][1] == Dropfield){
					returnVar = true;
					break;
				}
				i++;
			}
			
			return returnVar;
		};
	
			
	} // Class Close

}//Package close
	

	
