﻿// Soll Fehlermeldungen oder Text ausgeben

package com.utilites {
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.text.*;
	
	
	public class ExtWindow extends Sprite{
		
		public var Group:Sprite// Container für Alles
		var ButtonSTOP:Shape// StopButton
		var ButtonSTOP_mc:MovieClip
		public var Xsize:int // Textgrösse
		public var Ysize:int // Textgrösse
		public var Xpos:int // XPosition
		public var Ypos:int // YPosition
		public var Color:uint // Textfarbe
		public var Text:String // Der Text
		public var TextArray:Array;
		private var TextF:TextField//Textfeld
		public var StopMode:Boolean// Ist der StopMode true hält die Textausgabe an
		
		
		public function ExtWindow(...args){	
			TextF = new TextField();
			TextArray = new Array();
			Group=new Sprite();
			addChild(Group);
			StopMode=false;
			ButtonSTOP_mc = new MovieClip();
			ButtonSTOP= new Shape();
			
			
			if (args[0]){
				Text = args[0];
			}
				else {
					Text = "NEED INPUT";
				};
			if (args[1]){
				Xpos = args[1];
			}
				else {
					Xpos = 0;
				};
			if (args[2]){
				Ypos = args[2];
			}
				else {
					Ypos = 015;
				};
			if (args[3]){
				Xsize = args[3];
			}
				else {
					Xsize = 100;
				}
			if (args[4]){
				Ysize = args[4];
			}
				else {
					Ysize = 100;
				}
			if (args[5]){
				Color = args[5];
			}
				else {
					Color = 0x000000;
				}
				
			initBox();
			initButtons();
			initText();
		}
				//Hintergrund
			private function initBox(){
				
				var Background:Shape = new Shape();
				Background.graphics.beginFill(0x000000,0.5);
				Background.graphics.lineStyle(1,Color);
				Background.graphics.drawRect(0,0,Xsize,Ysize);
				Group.addChild(Background);
				
				var Relocate_mc:MovieClip = new MovieClip();
				var Relocate:Shape = new Shape();
				Relocate.graphics.lineStyle(1,Color);
				Relocate.graphics.beginFill(0xFFFFFF,0.5);
				Relocate.graphics.drawRect(0,0,Xsize,-10);
				Relocate_mc.buttonMode=true;
				Group.addChild(Relocate_mc);
				Relocate_mc.addChild(Relocate);
				Relocate_mc.addEventListener(MouseEvent.MOUSE_DOWN, function(){Group.startDrag()});
				Relocate_mc.addEventListener(MouseEvent.MOUSE_UP, function(){Group.stopDrag()});
				
				Group.x=Xpos;
				Group.y=Ypos;
				
			}
			
			// legt die Buttons zum Scrollen an
			private function initButtons(){
				var ButtonUP_mc:MovieClip = new MovieClip();
				var ButtonUp:Shape = new Shape();
				ButtonUp.graphics.beginFill(0x000000,0.5);
				ButtonUp.graphics.lineStyle(1,Color);
				ButtonUp.graphics.drawRect(0,0,Xsize*0.1,Ysize*0.5);
				ButtonUp.graphics.moveTo((Xsize*0.1)/2,0);
				ButtonUp.graphics.lineTo(Xsize*0.1,Ysize*0.5);
				ButtonUp.graphics.moveTo((Xsize*0.1)/2,0);
				ButtonUp.graphics.lineTo(0,Ysize*0.5);
				Group.addChild(ButtonUP_mc);
				ButtonUP_mc.addChild(ButtonUp);
				ButtonUP_mc.x=Xsize;
				ButtonUP_mc.y=0;
				ButtonUP_mc.buttonMode=true;
				ButtonUP_mc.addEventListener(MouseEvent.MOUSE_DOWN, function(){TextF.scrollV--;});
				
				var ButtonDown_mc:MovieClip = new MovieClip();
				var ButtonDown:Shape = new Shape();
				ButtonDown.graphics.beginFill(0x000000,0.5);
				ButtonDown.graphics.lineStyle(1,Color);
				ButtonDown.graphics.drawRect(0,0,Xsize*0.1,Ysize*0.5);
				ButtonDown.graphics.moveTo((Xsize*0.1)/2,Ysize*0.5);
				ButtonDown.graphics.lineTo(0,0);
				ButtonDown.graphics.moveTo((Xsize*0.1)/2,Ysize*0.5);
				ButtonDown.graphics.lineTo(Xsize*0.1,0);
				Group.addChild(ButtonDown_mc);
				ButtonDown_mc.addChild(ButtonDown);
				ButtonDown_mc.x=Xsize;
				ButtonDown_mc.y=Ysize*0.5;
				ButtonDown_mc.buttonMode=true;
				ButtonDown_mc.addEventListener(MouseEvent.MOUSE_DOWN, function(){TextF.scrollV++;});
				
				ButtonSTOP.graphics.beginFill(0xFF0000,0.5);
				ButtonSTOP.graphics.drawRect(0,0,-10,Ysize);
				Group.addChild(ButtonSTOP_mc);
				ButtonSTOP_mc.buttonMode=true;
				ButtonSTOP_mc.addChild(ButtonSTOP);
				ButtonSTOP_mc.addEventListener(MouseEvent.MOUSE_DOWN, changeStopMode);
				
			
			}
			
			private function initText(){
				
				TextF.textColor= Color;
				TextF.text = Text;
				Group.addChild(TextF); 
				TextF.height=Ysize;
				TextF.width=Xsize;
			}
			
			
			public function addText(i:String){
				if (StopMode==true){
				}
				else if (StopMode==false){
				TextArray.push("\n"+TextArray.length.toString()+": "+(i));
				//TextF.scrollV++;
				TextF.text = TextArray.toString();
				TextF.scrollV++;
				}
				
			}
			
			private function changeStopMode(e:Event){
				switch (StopMode){
					case true:
					StopMode=false
					
					ButtonSTOP.graphics.beginFill(0x000000,0.5);
					ButtonSTOP_mc.addChild(ButtonSTOP);
					break;
					case false:
					ButtonSTOP.graphics.endFill();
					ButtonSTOP.graphics.beginFill(0xFF0000,0.5);
					StopMode = true;
					break;
				}
			}
				

		
	}// Class close
}// Package close