﻿// VORLAGE FÜR TOOLS//

package  com.tools {
	
import com.events.SatCalcEvent;
import flash.display.Sprite;
import flash.display.*;
import flash.geom.*;
import flash.text.*;
import flash.events.*;
import FISEvents;
import com.utilities.*;
import flash.ui.Mouse;
import flash.utils.*;
import flash.net.*;


	public class StatFilterTool extends SatCalcDisplay {
	
	private var FilterChoice:FISDropDown;
	private var MainToolActive:Boolean = false;
	public var StageZero:Point;
	private var Filter:Filters;
	private var Matrix_BMP_s:Bitmap;
	private var Matrix_BMP:Bitmap;
	private var Image_BMP:Bitmap;
	private var FilterImage:Bitmap;
	private var MatrixContainer:Sprite;
	public var OutAt_X:int;					// an welche Stage Koordinaten werden die Overlays ausgegeben
	public var OutAt_Y:int;
	private var orgBild:BitmapData;
	public var StatFilter_mc:MovieClip; 
	private var MatrixPik_mc:MovieClip;
	private var ValueRaster_mc:MovieClip;
	public var HasDropFields:Boolean;
	public var HasGhosts:Boolean;
	public var DropFields:Array;
	public var IRZaehl_koord:Point;
	public var IRNenn_koord:Point;
	public var RZaehl_koord:Point;
	public var RNenn_koord:Point;
	public var ToolDims:Array;				// Die Abmessungen der Tools. Wird im SatCalculator benötigt um die Positionierung vorzunehmen
	public var Ident:String;				// Gleicht dem Namen des Objektes im Satcalculator
	private var Version:String;
	private var CalcTool:ClassifierBase;
	public var MetaOfCurrentData:Array;		// Metadaten Array des Momentan angezeigten Bildes(welches das Tool bearbeitet);;
	private var MessageTimer:Timer;		// Die Rückmeldung wenn berechnet wird braucht ein wenig Vorsprung, weil sie sonst nicht angezeigt wird
	private var DataWidth_:int;
	private var DataHeight_:int;
	
	private var W:int;						// Höhe des auszuwertenden Bildes
	private var H:int;						// Breite des auszuwertenden Bildes

	
		public function StatFilterTool(outX:int,outY:int,varArr:Array,ID:String){
			
			Ident = ID;
			
			Version = "20130901"
			
			// Das Array in dem alle relevanten Daten zu den DropFields gespeichert sind
			
			DropFields = new Array();

			HasDropFields = false;
			HasGhosts	= false;
			trace ("StatFilterTool INVOKED: "+Version);
			
			OutAt_X=outX;
			OutAt_Y=outY;
			
			StatFilter_mc = new StatFilter();
			addChild(StatFilter_mc);
			
			Filter = new Filters();
			ValueRaster_mc = new ValueRaster();
			ValueRaster_mc.name = "ValueRaster_mc";
			
			 
			
			FilterChoice = new FISDropDown(["Mittelwert","Median"]);
			this.addChild(FilterChoice);
			FilterChoice.y = 98;
			FilterChoice.x = 55;
			FilterChoice.DropBox.drpText.text = "Filter wählen!";
			FilterChoice.addEventListener(FISEvents.DATA_READY,switchFormula);
			
			MatrixPik_mc = new MatrixPik();
			MatrixPik_mc.name = "MatrixPik_mc";
			addChild(MatrixPik_mc);
			MatrixPik_mc.visible = false;

			
			ToolDims = new Array();
			ToolDims[0] =[StatFilter_mc.width,StatFilter_mc.height];
			MetaOfCurrentData = new Array()
			this.addEventListener(Event.ADDED_TO_STAGE, initListeners);
			
			MatrixContainer = new Sprite();
			this.addChild(MatrixContainer);
			MatrixContainer.x =30 ;
			MatrixContainer.y =-4 ;
			MatrixContainer.scaleX = 1.02;
			MatrixContainer.scaleY = 1.02;
			StageZero = this.globalToLocal(new Point(OutAt_X,OutAt_Y)); 
			trace ("Position: " +StageZero);
			
			
			StatFilter_mc.StartMatrixFilter_mc.gotoAndStop(3);
			StatFilter_mc.StartFilter_mc.gotoAndStop(3);
			StatFilter_mc.Formel_mc.gotoAndStop(3);
			
			CalcTool = new ClassifierBase();
		}// Constructor close
		
		
		private function initListeners(e:Event){
			stage.addEventListener(MouseEvent.MOUSE_DOWN,getColorMatrix,false,0,true);
			this.addEventListener(SatCalcEvent.DISPLAY_UPDATE,initImage)
			stage.addEventListener(MouseEvent.MOUSE_MOVE, showPiker);
			//this.addEventListener(SatCalcEvent.TOOL_ENABLED, disablePiker);
			stage.addEventListener(SatCalcEvent.TOOL_STATUS,disablePiker);
		}
		
		private function messageAndStart(e:MouseEvent){
			dispatchEvent(new SatCalcEvent(SatCalcEvent.AIR_MESSAGE,[true,FilterChoice.CurrentChoice+" Filter"+"\n"+"wird angewendet"]));
			MessageTimer = new Timer(100,1);
			MessageTimer.addEventListener(TimerEvent.TIMER_COMPLETE,filterImage);
			MessageTimer.start();
		}
		
		private function getColorMatrix(e:MouseEvent){
				
				var Position:Point;
				Position = new Point();
				Position.x = stage.mouseX - StageZero.x;
				Position.y = stage.mouseY - StageZero.y;
				
				
				if (Position.x <=  W && Position.y <=  H && MainToolActive ==false){
					Matrix_BMP = new Bitmap(new BitmapData(3,3,false,0x555555));
					Matrix_BMP_s = new Bitmap(new BitmapData(3,3,false,0x555555));
					MatrixContainer.addChild(Matrix_BMP);
					MatrixContainer.addChild(ValueRaster_mc);
					
					
					Matrix_BMP_s.bitmapData.copyPixels(Image_BMP.bitmapData,new Rectangle(Position.x -1, Position.y -1,3,3),new Point(0,0));
					Matrix_BMP.bitmapData = Matrix_BMP_s.bitmapData;
					Matrix_BMP.scaleX = 30;
					Matrix_BMP.scaleY = 30;
					updateValueRaster();
					trace ("Position: " +Position);
				
				}
				
		}
		
		private function initImage(e:SatCalcEvent){
			MetaOfCurrentData =  e.data[1];
			
			trace ("METADATA IN STATFILTER :"+MetaOfCurrentData);
			W=MetaOfCurrentData[7][0];
			H=MetaOfCurrentData[7][1];
			//trace ("WH :"+W+" "+H)
			if (e.data[0] instanceof Bitmap){
				 trace ("IMAAAAAAAAGGGGGGGGGGGGGEEEEEEEEEEEEEEE");
				  Image_BMP = new Bitmap(Bitmap(e.data[0]).bitmapData.clone());
			}
			if (e.data[0] instanceof Array){
				  
				 	//Image_BMP = new Bitmap(new BitmapData(W,H));
					//var tempArray:Array = new Array();
					//tempArray = CalcTool.returnStretchedArray(e.data[0]);
				  	Image_BMP=CalcTool.returnBitmapFromArray(e.data[0],W,H);
					
				   
			}

			StatFilter_mc.StartFilter_mc.addEventListener(MouseEvent.MOUSE_DOWN,messageAndStart);
			StatFilter_mc.StartMatrixFilter_mc.addEventListener(MouseEvent.MOUSE_DOWN,filterMatrix);
			StatFilter_mc.StartFilter_mc.gotoAndStop(1);
			StatFilter_mc.StartMatrixFilter_mc.gotoAndStop(1);
		}
		
		private function updateValueRaster(){
			var AA_Value:int = CalcTool.returnIntValue(Matrix_BMP.bitmapData.getPixel(0,0),0xff);
			var AB_Value:int = CalcTool.returnIntValue(Matrix_BMP.bitmapData.getPixel(1,0),0xff);
			var AC_Value:int = CalcTool.returnIntValue(Matrix_BMP.bitmapData.getPixel(2,0),0xff);
			var BA_Value:int = CalcTool.returnIntValue(Matrix_BMP.bitmapData.getPixel(0,1),0xff);
			var BB_Value:int = CalcTool.returnIntValue(Matrix_BMP.bitmapData.getPixel(1,1),0xff);
			var BC_Value:int = CalcTool.returnIntValue(Matrix_BMP.bitmapData.getPixel(2,1),0xff);
			var CA_Value:int = CalcTool.returnIntValue(Matrix_BMP.bitmapData.getPixel(0,2),0xff);
			var CB_Value:int = CalcTool.returnIntValue(Matrix_BMP.bitmapData.getPixel(1,2),0xff);
			var CC_Value:int = CalcTool.returnIntValue(Matrix_BMP.bitmapData.getPixel(2,2),0xff);
			
			MatrixContainer.getChildByName("ValueRaster_mc").AA_txt.text = AA_Value.toString();
			MatrixContainer.getChildByName("ValueRaster_mc").AB_txt.text = AB_Value.toString();
			MatrixContainer.getChildByName("ValueRaster_mc").AC_txt.text = AC_Value.toString();
			MatrixContainer.getChildByName("ValueRaster_mc").BA_txt.text = BA_Value.toString();
			MatrixContainer.getChildByName("ValueRaster_mc").BB_txt.text = BB_Value.toString();
			MatrixContainer.getChildByName("ValueRaster_mc").BC_txt.text = BC_Value.toString();
			MatrixContainer.getChildByName("ValueRaster_mc").CA_txt.text = CA_Value.toString();
			MatrixContainer.getChildByName("ValueRaster_mc").CB_txt.text = CB_Value.toString();
			MatrixContainer.getChildByName("ValueRaster_mc").CC_txt.text = CC_Value.toString();
		}
		
		private function filterImage(e:TimerEvent){
			MessageTimer.removeEventListener(TimerEvent.TIMER_COMPLETE,filterImage);
			var outArray:Array = new Array();
			var ourDataArray:Array = new Array();
			outArray =  mergeMetaArray();
			FilterImage = new Bitmap(new BitmapData(Image_BMP.width,Image_BMP.height));
			switch(FilterChoice.CurrentChoice){
				case "Mittelwert" :
				trace ("Mittelwert Filter");
				FilterImage = Filter.meanFilter(Image_BMP,false);
				break;
				case "Median":
				trace ("Median Filter");
				FilterImage = Filter.medianFilter(Image_BMP);
				break;
				
				
			}
			// Das Array welches an den SatCalc weitergegeben wird mit DatenArray und Metadaten und 
			
			//ourDataArray = CalcTool.returnBitmapToArray(FilterImage);
			
			this.dispatchEvent(new SatCalcEvent(SatCalcEvent.DATA_DISPLAY,[FilterImage,outArray[0],outArray[1],outArray[2],outArray[3],outArray[4],outArray[5],outArray[6]]));
														//					Daten			width		height		Name		NDVI	Auflösung	 Einheit		Datum				
			dispatchEvent(new SatCalcEvent(SatCalcEvent.AIR_MESSAGE,[false,""]));
		}
	
		// Kombiniert die Metadatenarrays der eingangsdaten zu einem MetadatenArray ders Ergebnisbildes
		private function mergeMetaArray():Array{
			
			var returnArray:Array = new Array();
			returnArray[0] = Image_BMP.width;
			returnArray[1] = Image_BMP.height;
			returnArray[2] = MetaOfCurrentData[0];
			
			returnArray[3] = FilterChoice.CurrentChoice;
			returnArray[4] = MetaOfCurrentData[3];
			returnArray[5] = MetaOfCurrentData[4];
			returnArray[6] = MetaOfCurrentData[2];
			return returnArray;
	
		}
		
		private function filterMatrix(e:MouseEvent){
			
			var MatrixArray:Array;
			var calcValue:Number;
			
			switch(FilterChoice.CurrentChoice){
				case "Mittelwert" :
				MatrixArray = CalcTool.returnBitChannelToIntArray(Matrix_BMP_s,0xff);
				//MatrixArray = [1,2,3,4,5,6,7,8];
				calcValue = CalcTool.returnMean(MatrixArray);
				Matrix_BMP_s.bitmapData.setPixel(1,1,CalcTool.colRGBToValue([calcValue,calcValue,calcValue]));
				Matrix_BMP.bitmapData = Matrix_BMP_s.bitmapData;
				trace ("VALUE IS "+calcValue);
				updateValueRaster();
				break;
				case "Median":
				MatrixArray = CalcTool.returnBitChannelToIntArray(Matrix_BMP_s,0xff);
				//MatrixArray = [1,2,3,4,5,6,7,8];
				calcValue = CalcTool.returnMedian(MatrixArray);
				Matrix_BMP_s.bitmapData.setPixel(1,1,CalcTool.colRGBToValue([calcValue,calcValue,calcValue]));
				Matrix_BMP.bitmapData = Matrix_BMP_s.bitmapData;
				trace ("VALUE IS "+calcValue);
				updateValueRaster();
				break;
			}
			
		}
		private function switchFormula(e:FISEvents){
			switch (e.data){
				case "Median":
				StatFilter_mc.Formel_mc.gotoAndStop(2);
				break;
				case "Mittelwert":
				StatFilter_mc.Formel_mc.gotoAndStop(1);
				break;
			}
			
		}
		
		private function showPiker(e:MouseEvent){
			
			var Position:Point;
				Position = new Point();
				Position.x = stage.mouseX - StageZero.x;
				Position.y = stage.mouseY - StageZero.y;
				
				
				if (Position.x <=  W && Position.x >=0 && Position.y <=  H && MainToolActive == false){
					
					MatrixPik_mc.visible =true;
					MatrixPik_mc.mouseEnabled=false; 
					Mouse.hide();
					MatrixPik_mc.x = mouseX;
					MatrixPik_mc.y = mouseY;
				}
				else {
					MatrixPik_mc.visible =false;
					
					Mouse.show();
					
				}
			}
	
	private function disablePiker(e:SatCalcEvent){
		trace("TOOLS ENABLED");
		if (e.data == true){
		MatrixPik_mc.visible =false;
		Mouse.show();
		MainToolActive = true;
		}
		else if (e.data == false){
			MainToolActive = false; 
		 }
	}
	
	
		
			
	} // Class Close

}//Package close
	

	
