﻿package com.tools{

	import flash.display.MovieClip;
	import flash.display.Bitmap;
	import flash.display.*;
	import flash.net.*;
	import flash.display.*;
	import flash.filters.*;
	import flash.sampler.NewObjectSample;
	import flash.events.Event;
	import flash.events.*;
	import flash.geom.*;
	import flashx.textLayout.formats.Float;
	
	public class edgeDetect extends Sprite
	{
		public var hPos:int;
		public var rCplusPos:int;
		public var rCminusPos:int;
		public var rMinuscPlusPos:int;
		public var rPluscMinusPos:int;
		public var rMinusCPos:int;
		public var rPlusCPos:int;
		public var rMinusCminusPos:int;
		public var rPlusCplusPos:int;
				
		public	var inputImage:BitmapData;
			
		public	var greyScaleImage: BitmapData;
			
		public	var blurredImage: BitmapData;
			
		public	var horizontalEdge:BitmapData;
		public	var horizontalEdge_2:BitmapData;
			
		public	var verticalEdge:BitmapData;	
		public	var verticalEdge_2:BitmapData;
			
		public	var outputEdge:BitmapData;
			
		public	var threshold:int = 100;
		
		public var max_hysteresis_thresh:Number = 1.0;
			
		public var min_hysteresis_thresh:Number = 0.04;
	
		public	var blueScaleArray:Array = [0.3, 0.59, 0.11, 0, 0,
		
										0.3, 0.59, 0.11, 0, 0,
		
										0.3, 0.59, 0.11, 0, 0,
			
										0, 0, 0, 1, 0];

		public const blueScaleFilter:ColorMatrixFilter = new ColorMatrixFilter(blueScaleArray);
			
		public const GAUSSIAN_3BY3:ConvolutionFilter = new ConvolutionFilter(3,3,[  1,2,1,
																				 2,4,2,
																				 1,2,1], 16);
		public const VERTICAL_SOBEL:ConvolutionFilter = new ConvolutionFilter(3,3,
																			  [ -1, 0, 1,
																			    -2, 0, 2,
																			    -1, 0, 1], 1,25);
		public const VERTICAL_SOBEL_2:ConvolutionFilter = new ConvolutionFilter(3,3,
																			  [ 1, 0, -1,
																			    2, 0, -2,
																			    1, 0, -1], 1,25);
 
		public const HORIZONTAL_SOBEL:ConvolutionFilter = new ConvolutionFilter(3,3,
																			  [ 1, 2, 1,
																				 0, 0, 0,
																				 -1, -2, -1], 1,25);
			
		public const HORIZONTAL_SOBEL_2:ConvolutionFilter = new ConvolutionFilter(3,3,
																			  [ -1, -2, -1,
																			     0, 0, 0,
																			     1, 2, 1], 1,25);																		 
																				 
		
		public function edgeDetect()
		{
			
		}
		
		public function sobelVerticalEdges(img:Bitmap):Bitmap
		{
			
			inputImage = Bitmap(img).bitmapData;
			
			greyScaleImage = new BitmapData(inputImage.width, inputImage.height);
			
			blurredImage = new BitmapData(inputImage.width, inputImage.height);
			
			outputEdge = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			
			verticalEdge = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			verticalEdge_2 = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
	
			threshold = 100;
			
			greyScaleImage.applyFilter(inputImage, inputImage.rect, new Point(),blueScaleFilter);
						
			blurredImage.applyFilter(greyScaleImage, greyScaleImage.rect, new Point(), GAUSSIAN_3BY3);
	
			verticalEdge.applyFilter(blurredImage, blurredImage.rect, new Point(), VERTICAL_SOBEL);
			verticalEdge_2.applyFilter(blurredImage, blurredImage.rect, new Point(), VERTICAL_SOBEL_2);

			//verticalEdge_2.threshold(verticalEdge, verticalEdge.rect, new Point(), ">", threshold, 0, 0xff, true);

			//outputEdge.draw(verticalEdge, null, null , BlendMode.ADD);
			outputEdge.draw(verticalEdge_2, null, null , BlendMode.ADD);

			var hold:Bitmap= new Bitmap(outputEdge);
			
			return hold;
			
		}
		
		public function sobelHorizontalEdges(img:Bitmap):Bitmap
		{
			
			inputImage = Bitmap(img).bitmapData;
			
			greyScaleImage = new BitmapData(inputImage.width, inputImage.height);
			
			blurredImage = new BitmapData(inputImage.width, inputImage.height);
			
			horizontalEdge = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			horizontalEdge_2 = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			
			outputEdge = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			
			threshold = 100;
			
			greyScaleImage.applyFilter(inputImage, inputImage.rect, new Point(),blueScaleFilter);
						
			blurredImage.applyFilter(greyScaleImage, greyScaleImage.rect, new Point(), GAUSSIAN_3BY3);
			
			horizontalEdge.applyFilter(blurredImage, blurredImage.rect, new Point(), HORIZONTAL_SOBEL);
			horizontalEdge_2.applyFilter(blurredImage, blurredImage.rect, new Point(), HORIZONTAL_SOBEL_2);
			
			//outputEdge.threshold(horizontalEdge, horizontalEdge.rect, new Point(), ">", threshold,0,0xff,true);
			
			//outputEdge.draw(horizontalEdge, null, null , BlendMode.ADD);
			outputEdge.draw(horizontalEdge_2, null, null , BlendMode.ADD);

		
			var hold:Bitmap= new Bitmap(outputEdge);
			
			return hold;
			
		}
		
		public function convolutionEdges(img:Bitmap):Bitmap
		{
			inputImage = Bitmap(img).bitmapData;
			
			greyScaleImage = new BitmapData(inputImage.width, inputImage.height);
			
			blurredImage = new BitmapData(inputImage.width, inputImage.height);
	
			greyScaleImage.applyFilter(inputImage, inputImage.rect, new Point(),blueScaleFilter);
			
			blurredImage.applyFilter(greyScaleImage, greyScaleImage.rect, new Point(), GAUSSIAN_3BY3);
			//image.filters = [grayscaleFilter];
			var hold:Bitmap= new Bitmap(blurredImage);
			
			hold.filters = [new ConvolutionFilter(3, 3, [0, 1, 0, 1, -3, 1, 0, 1, 0])];
				
			return hold;
		}
		
		public function meanFilter(img:Bitmap,bool:Boolean):Bitmap
		{
			inputImage = Bitmap(img).bitmapData;
			
			greyScaleImage = new BitmapData(inputImage.width, inputImage.height);
			
			blurredImage = new BitmapData(inputImage.width, inputImage.height);
	
			greyScaleImage.applyFilter(inputImage, inputImage.rect, new Point(),blueScaleFilter);
			
			const Kernal:ConvolutionFilter = new ConvolutionFilter(3,3,[  1/9,1/9,1/9,
																		  1/9,1/9,1/9,
																		  1/9,1/9,1/9], 0);
			var hold:Bitmap;
			
			if(bool)
			{
				blurredImage.applyFilter(greyScaleImage, greyScaleImage.rect, new Point(), Kernal);
				hold = new Bitmap(blurredImage);
			}
			else
			{
				blurredImage.applyFilter(inputImage, inputImage.rect, new Point(), Kernal);
				hold = new Bitmap(blurredImage);
			}
			return hold;
		}
		
		public function medianFilter(img:Bitmap):Bitmap
		{
			inputImage = Bitmap(img).bitmapData;
			
			greyScaleImage = new BitmapData(inputImage.width, inputImage.height);
			
			blurredImage = new BitmapData(inputImage.width, inputImage.height);
	
			greyScaleImage.applyFilter(inputImage, inputImage.rect, new Point(),blueScaleFilter);
			
			var sample:BitmapData= new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			
			var ImageCalc:ClassifierBase = new ClassifierBase();
			
			// At first one Channel of the BitmapData Object is translated into an ordinary Array. Which channel doesn't matter since its already a greyscale Image
			var orignalImage_Array:Array = ImageCalc.returnBitDataChannelToIntArray(inputImage,0xff,inputImage.width,inputImage.height);
			// At first one Channel of the BitmapData Object is translated into an ordinary Array. Which channel doesn't matter since its already a greyscale Image
			var sampleImage_Array:Array = ImageCalc.returnBitDataChannelToIntArray(sample,0xff,inputImage.width,inputImage.height);
			
			var holdArray:Array = new Array();
			
			for(var r:uint = 1; r <inputImage.width-1; r++)  
			{
				for(var c:uint = 1; c < inputImage.height-1; c++)  
				{
					// middle row
					hPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r,c);
					rCplusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r,c+1);
					rCminusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r,c-1);
					// 1st row
					rMinuscPlusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r-1,c+1);
					rMinusCminusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r-1,c-1);	
					rMinusCPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r-1,c);
					// Last row
					rPlusCPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r+1,c);
					rPluscMinusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r+1,c-1);
					rPlusCplusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r+1,c+1);
					
					holdArray.push(orignalImage_Array[hPos],orignalImage_Array[rCplusPos],orignalImage_Array[rCminusPos]);
					holdArray.push(orignalImage_Array[rMinuscPlusPos],orignalImage_Array[rMinusCminusPos],orignalImage_Array[rMinusCPos]);
					holdArray.push(orignalImage_Array[rPlusCPos],orignalImage_Array[rPluscMinusPos],orignalImage_Array[rPlusCplusPos]);
					
					
					holdArray.sort(Array.NUMERIC);
					
					sampleImage_Array[hPos] = holdArray[4];
					holdArray = new Array();
					
				}
			}
			
			var invertedBitmap:Bitmap = ImageCalc.returnBitmapFromArray( sampleImage_Array, inputImage.width, inputImage.height);
		
			return invertedBitmap;
		}
		
		public function sobelCombVertHortEdges(img:Bitmap):Bitmap
		{
			inputImage = Bitmap(img).bitmapData;
			
			greyScaleImage = new BitmapData(inputImage.width, inputImage.height);
			
			blurredImage = new BitmapData(inputImage.width, inputImage.height);
			
			horizontalEdge = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			horizontalEdge_2 = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			
			verticalEdge = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			verticalEdge_2 = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			
			outputEdge = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			
			threshold = 100;
			
			greyScaleImage.applyFilter(inputImage, inputImage.rect, new Point(),blueScaleFilter);
						
			blurredImage.applyFilter(greyScaleImage, greyScaleImage.rect, new Point(), GAUSSIAN_3BY3);
			
			horizontalEdge.applyFilter(blurredImage, blurredImage.rect, new Point(), HORIZONTAL_SOBEL);
			
			horizontalEdge_2.applyFilter(blurredImage, blurredImage.rect, new Point(), HORIZONTAL_SOBEL_2);
			
			verticalEdge.applyFilter(blurredImage, blurredImage.rect, new Point(), VERTICAL_SOBEL);
			verticalEdge_2.applyFilter(blurredImage, blurredImage.rect, new Point(), VERTICAL_SOBEL_2);
			
			//outputEdge.threshold(horizontalEdge, horizontalEdge.rect, new Point(), ">", threshold,0,0xff,true);
			
			
			outputEdge.draw(horizontalEdge, null, null , BlendMode.ADD);
			outputEdge.draw(horizontalEdge_2, null, null , BlendMode.ADD);
			outputEdge.draw(verticalEdge, null, null , BlendMode.ADD);
			outputEdge.draw(verticalEdge_2, null, null , BlendMode.ADD);
			//outputEdge.threshold(horizontalEdge, horizontalEdge.rect, new Point(), ">", threshold,0,0xff,true);

			var hold:Bitmap= new Bitmap(outputEdge);
			/*var ImageCalc:ClassifierBase = new ClassifierBase();
			//trace ("ssss")
			// At first one Channel of the BitmapData Object is translated into an ordinary Array. Which channel doesn't matter since its already a greyscale Image
			var ImageArray:Array = ImageCalc.returnBitDataChannelToIntArray(hold.bitmapData,0xff,inputImage.width,inputImage.height);
			// The Numbers in the Array get invertet by applying a linear Function to them(f(x) = -1x+255)
			//trace ("aaa")
			var VariableVector:Vector.<Array> = new Vector.<Array>();
			VariableVector.push(new Array(0,130,0));
			//VariableVector.push(new Array(50,255,255));
			
			//VariableVector.push(new Array(50,255,255));
			var workArray:Array = ImageCalc.replaceValues(ImageArray,VariableVector);
			//var stretchedArray = ImageCalc.returnStretchedArray(ImageArray);
			//var workArray = ImageCalc.linearArrayTransform(ImageArray,[1,500])
			// This Array is then translated into a Bitmap and added to stage
			var clearedBitmap:Bitmap = ImageCalc.returnBitmapFromArray(workArray,inputImage.width,inputImage.height);
			clearedBitmap.x = 0;*/
			
			return hold;
			
		}
		
		
		public function cannyEdges(img:Bitmap):Bitmap
		{
			inputImage = Bitmap(img).bitmapData;
			
			greyScaleImage = new BitmapData(inputImage.width, inputImage.height);
			
			blurredImage = new BitmapData(inputImage.width, inputImage.height);
			
			horizontalEdge = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			horizontalEdge_2 = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			
			verticalEdge = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			verticalEdge_2 = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			
			outputEdge = new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			
			threshold = 100;
			
			greyScaleImage.applyFilter(inputImage, inputImage.rect, new Point(),blueScaleFilter);

			blurredImage.applyFilter(greyScaleImage, greyScaleImage.rect, new Point(), GAUSSIAN_3BY3);
			
			
			horizontalEdge.applyFilter(blurredImage, blurredImage.rect, new Point(), HORIZONTAL_SOBEL);
			horizontalEdge_2.applyFilter(blurredImage, blurredImage.rect, new Point(), HORIZONTAL_SOBEL_2);
			
			verticalEdge.applyFilter(blurredImage, blurredImage.rect, new Point(), VERTICAL_SOBEL);
			verticalEdge_2.applyFilter(blurredImage, blurredImage.rect, new Point(), VERTICAL_SOBEL_2);
			
			//outputEdge.threshold(horizontalEdge, horizontalEdge.rect, new Point(), ">", threshold,0,0xff,true);
			
			
			outputEdge.draw(horizontalEdge, null, null , BlendMode.ADD);
			outputEdge.draw(horizontalEdge_2, null, null , BlendMode.ADD);
			outputEdge.draw(verticalEdge, null, null , BlendMode.ADD);
			outputEdge.draw(verticalEdge_2, null, null , BlendMode.ADD);
			
			var sample:BitmapData= new BitmapData(inputImage.width, inputImage.height, true,0xff000000);
			
			sample = outputEdge;
			
			// Perform Non maximum suppression on the gradient we got :
			
			var non_max: BitmapData = new BitmapData(inputImage.width, inputImage.height);
			
			var Tangent:Number;
			
			non_max = outputEdge;
			
			///////////////////////////////////////////////////////////////Typ Casting
			
			var ImageCalc:ClassifierBase = new ClassifierBase();
			
			// At first one Channel of the BitmapData Object is translated into an ordinary Array. Which channel doesn't matter since its already a greyscale Image
			var horizontalEdge_Array:Array = ImageCalc.returnBitDataChannelToIntArray(sample,0xff,horizontalEdge.width,horizontalEdge.height);
			// At first one Channel of the BitmapData Object is translated into an ordinary Array. Which channel doesn't matter since its already a greyscale Image
			var verticalEdge_Array:Array = ImageCalc.returnBitDataChannelToIntArray(verticalEdge,0xff,verticalEdge.width,verticalEdge.height);
			// At first one Channel of the BitmapData Object is translated into an ordinary Array. Which channel doesn't matter since its already a greyscale Image
			var non_max_Array:Array = ImageCalc.returnBitDataChannelToIntArray(non_max,0xff,non_max.width,non_max.height);
			// At first one Channel of the BitmapData Object is translated into an ordinary Array. Which channel doesn't matter since its already a greyscale Image
			var outputEdge_Array:Array = ImageCalc.returnBitDataChannelToIntArray(outputEdge,0xff,outputEdge.width,outputEdge.height);
		
			//////////////////////////////////////////////////////////////
			

			for(var r:uint = 1+Math.ceil(9/2); r <= inputImage.width-Math.ceil(9/2); r++) 
			{
				for(var c:uint = 1+Math.ceil(9/2); c <= inputImage.height-Math.ceil(9/2); c++)  
				{
			   		hPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r,c);
					rCplusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r,c+1);
					rCminusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r,c-1);
					rMinusCPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r-1,c);
					rPlusCPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r+1,c);
					rMinusCminusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r-1,c-1);
					rPlusCplusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r+1,c+1);
					
					if (horizontalEdge_Array[hPos] == 0)
					{
						Tangent = 90;       
					}
					else 
					{
						Tangent = Math.ceil(Math.atan((verticalEdge_Array[hPos]) / (horizontalEdge_Array[hPos])));  
						//tangent = (horizontalEdge_Array[hPos]) / (verticalEdge_Array[hPos]);
					}
					// horizontal Edge
					if (((-22.5 < Tangent) && (Tangent <= 22.5)) || ((157.5 < Tangent) && (Tangent <= -157.5)))
					{  
						if(outputEdge_Array[hPos] < outputEdge_Array[rCplusPos] || outputEdge_Array[hPos] < outputEdge_Array[rCminusPos])
						{
							non_max_Array[hPos] = 0;
						}
					}
					// Vertical Edge
					if (((-112.5 < Tangent) && (Tangent <= -67.5)) || ((67.5 < Tangent) && (Tangent <= 112.5)))
			   		{    
						if(outputEdge_Array[hPos] < outputEdge_Array[rPlusCPos] || outputEdge_Array[hPos] < outputEdge_Array[rMinusCPos])
						{
							non_max_Array[hPos] = 0;
						}
					}
					//+45 Degree Edge
					if (((-67.5 < Tangent) && (Tangent <= -22.5)) || ((112.5 < Tangent) && (Tangent <= 157.5)))
					{   
						if(outputEdge_Array[hPos] < outputEdge_Array[rPluscMinusPos] || outputEdge_Array[hPos] < outputEdge_Array[rMinuscPlusPos])
						{
							non_max_Array[hPos] = 0;
						}
					}
					 //-45 Degree Edge
					 if (((-157.5 < Tangent) && (Tangent <= -112.5)) || ((67.5 < Tangent) && (Tangent <= 22.5)))
					{    
						if(outputEdge_Array[hPos] < outputEdge_Array[rPlusCplusPos] || outputEdge_Array[hPos] < outputEdge_Array[rMinusCminusPos])
						{
							non_max_Array[hPos] = 0;
						}
					}

				}
			}
			
			// Perform Non maximum suppression on the gradient we got :
			
			var non_max_Bitmap:Bitmap = ImageCalc.returnBitmapFromArray( non_max_Array, inputImage.width, inputImage.height);
		
			var post_hysteresis_Array:Array = ImageCalc.returnBitDataChannelToIntArray(non_max_Bitmap.bitmapData,0xff,inputImage.width,inputImage.height);
			
			//post_hysteresis_Array = non_max_Array;
			
			/*for(var r:uint = 1+Math.ceil(9/2); r <= inputImage.width-Math.ceil(9/2); r++)  
			{
				for(var c:uint = 1+Math.ceil(9/2); c <= inputImage.height-Math.ceil(9/2); c++)  
				{
					var hPos:int = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r,c);
					
					if(post_hysteresis_Array[hPos] >= max_hysteresis_thresh) 
					{
						post_hysteresis_Array[hPos] = 1;
					}

					if((post_hysteresis_Array[hPos] < max_hysteresis_thresh) && (post_hysteresis_Array[hPos] >= min_hysteresis_thresh)) 
					{	
						post_hysteresis_Array[hPos] = 2;
					}

					if(post_hysteresis_Array[hPos] < min_hysteresis_thresh) 
					{	
						post_hysteresis_Array[hPos] = 0;
					}
				}
			}*/
			
			var vvvv: uint = 1; 

			while (vvvv == 1)
			{		
				vvvv = 0;
						
				for(var r:uint = 1+Math.ceil(9/2); r <= inputImage.width-Math.ceil(9/2); r++)  
				{
					for(var c:uint = 1+Math.ceil(9/2); c <= inputImage.height-Math.ceil(9/2); c++)  
					{
					hPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r,c);
					rCplusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r,c+1);
					rCminusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r,c-1);
					rMinuscPlusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r-1,c+1);
					rPluscMinusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r+1,c-1);
					rMinusCPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r-1,c);
					rPlusCPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r+1,c);
					rMinusCminusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r-1,c-1);
					rPlusCplusPos = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r+1,c+1);
						
						if (post_hysteresis_Array[hPos] > 0)      
						{
							if(post_hysteresis_Array[hPos] == 2) 
							{
								if( post_hysteresis_Array[rMinusCminusPos] ==1 || post_hysteresis_Array[rMinusCPos] == 1 || post_hysteresis_Array[rMinuscPlusPos] ==1 || post_hysteresis_Array[rCminusPos] ==1 ||  post_hysteresis_Array[rCplusPos] ==1 || post_hysteresis_Array[rPluscMinusPos] ==1 || post_hysteresis_Array[rPlusCPos] ==1 || post_hysteresis_Array[rPlusCplusPos] ==1 ) 
								{
									post_hysteresis_Array[hPos] = 0;
			
									vvvv == 1;
			
								}
			
							}
			
						}
			
					}
			
				}
			
			}
			
			for(var r:uint = 1+Math.ceil(9/2); r <= inputImage.width-Math.ceil(9/2); r++)
			{
				for(var c:uint = 1+Math.ceil(9/2); c <= inputImage.height-Math.ceil(9/2); c++)  
				{
					var hPos:int = ImageCalc.returnArrayPos(inputImage.width,inputImage.height,r,c);
					
					if(post_hysteresis_Array[hPos] == 2) 
					{
						post_hysteresis_Array[hPos] = 0;
			
					}   
			
				}
			
			}
			
			// This Array is then translated into a Bitmap and added to stage
			var invertedBitmap:Bitmap = ImageCalc.returnBitmapFromArray( post_hysteresis_Array, inputImage.width, inputImage.height);
		
			//var hold: Bitmap = new Bitmap(invertedBitmap);
			
			return invertedBitmap;
			
	  }
			
	}
}
