package com.utility {
	
  import flash.display.*;
  import flash.events.*;
  import flash.geom.*;
  import flash.system.*;
  import flash.text.*;

  
	public class WindowLoadingBar extends MovieClip{
		
		private var Loadingbar:Shape; // der Ladebalken
		public var Elements:Number;	// Gesamtzahl der zu ladenden Elemente
		public var Progress:Number;	// Von Elements geladen
		private var Xpos:int;		// XY koordinaten des Ladebalkens
		private var Ypos:int;
		private var Xext:int;		// XY Ausdehnung des Ladenbalkens
		private var Yext:int;
		private var ColorA:Number; // Farbe des Ladenbalkens
		private var ColorB:Number; // Farbe des Ladenbalkens
		public var Ladebalken_mc:MovieClip; // Container;
		private var LoadingText:TextField;
		private var LoadContainer:MovieClip;
		public var Version:String = "20130918";
		
	public function WindowLoadingBar(loE:int,xk:int,yk:int,xex:int,yex:int,colA:Number = 0xAAAAAA,colB:Number=0xFFFFFF){
		
		Elements = loE;
		Xpos = xk;
		Ypos = yk;
		Xext = xex;
		Yext = yex;
		ColorA = colA;
		ColorB = colB;
		LoadContainer = new MovieClip();
		createBox();
	
	}// constructor close
	
	private function createBox(){
		var drawplane:Shape	= new Shape();
		drawplane.graphics.beginFill(ColorA,1);
		drawplane.graphics.drawRect(Xpos-5,Ypos-5,Xext+10,Yext+10);
		drawplane.graphics.endFill();
		this.addChild(drawplane);
		
	}
		
		public function updateLoadingBar(p:int){
					Progress = p;
					Loadingbar = new Shape();
					Loadingbar.graphics.beginFill(ColorB,1);
					Loadingbar.graphics.drawRect(Xpos,Ypos,(Progress*Xext/Elements),Yext);
					addChild(Loadingbar);
		}
		public function resetLoadingBar(){
			Loadingbar.graphics.clear();
			
		}
	} // Class close
} // package close