package com.window
{
	import com.interfaces.IDragDropable;
	
	
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.MovieClip;
	import flash.display.GradientType;
	import flash.display.SpreadMethod;
	import flash.display.InterpolationMethod;
	import flash.geom.Matrix;
	
	public class FISScrollbar extends ScrollbarBase
	{

		
		private var ControllerMainColor:uint = 0x6F9BC9;
		private var ControllerSecondColor:uint = 0xeeeeee;
		private var ControllerAlpha:uint = 1;
		
		
		public function FISScrollbar(ex:uint=100,cw:uint=20,ch:Number=30)
		{
			super(ex,cw,ch);
			
			
			initScrollButton();
			createRail()
		}
		
		public function createRail():void{
			var type:String = GradientType.LINEAR;
			var colors:Array = [0x205285, 0x163554, 0x163554, 0x205285];
			var alphas:Array = [1,1,1,1];
			var ratios:Array = [0,85,170, 255];
			var spreadMethod:String = SpreadMethod.PAD;
			var interp:String = InterpolationMethod.LINEAR_RGB;
			var focalPtRatio:Number = 1;
			var matrix:Matrix = new Matrix();
			var boxRotation:Number = Math.PI;
			
			matrix.createGradientBox(ControllerWith+4,Extend, boxRotation, 0, 0);
			
			Rail.graphics.beginGradientFill(type,colors,alphas,ratios,matrix,spreadMethod,interp,focalPtRatio);
			Rail.graphics.drawRoundRect(0,0,ControllerWith+4, Extend,5,5);
			Rail.x = -2;
			//Rail.y = posY;
		}
		
		public function initScrollButton(){
			trace ("INIT SCROLLBUTTON " + ButtonContainer.width);
			var ButtonBack:Shape = new Shape();
			
			//ButtonBack.graphics.beginFill(ConrollerMainColor,ConrollerAlpha);
			//ButtonBack.graphics.lineStyle(0,ConrollerMainColor);
			//ButtonBack.graphics.moveTo(0,ControllerHeight/10);
			//ButtonBack.graphics.curveTo(0,0,ControllerWith/10,0);
			//ButtonBack.graphics.lineTo(ControllerWith-(ControllerWith/10),0);
			//ButtonBack.graphics.curveTo(ControllerWith,0,ControllerWith,ControllerHeight/10);  
			//ButtonBack.graphics.lineTo(0,ControllerHeight/10);
			//ButtonBack.graphics.endFill();
			
			ButtonBack.graphics.beginFill(ControllerMainColor,ControllerAlpha);
			ButtonBack.graphics.lineStyle(1,ControllerMainColor);
			ButtonBack.graphics.drawRoundRect(0,0,ControllerWith,ControllerHeight,5,5);
		//	ButtonBack.y =- ControllerHeight/2;
			ButtonContainer.addChild(ButtonBack);
			
			var UP:Shape = new Shape();
			UP.graphics.beginFill(ControllerSecondColor,ControllerAlpha);
			UP.graphics.moveTo(ControllerWith/3,0);
			UP.graphics.lineTo(ControllerWith/3,ControllerHeight/2.5);
			UP.graphics.lineTo(0,ControllerHeight/2.5);
			UP.graphics.lineTo(ControllerWith/3,0);
			UP.graphics.endFill();
			
			UP.x= ControllerWith/4;
			UP.y= ButtonBack.y ;
			
			var DOWN:Shape = new Shape();
			DOWN.graphics.beginFill(ControllerSecondColor,ControllerAlpha);
			DOWN.graphics.moveTo(0,0);
			DOWN.graphics.lineTo(ControllerWith/3,0);
			DOWN.graphics.lineTo(ControllerWith/3,ControllerHeight/2.5);
			DOWN.graphics.lineTo(0,0);
			DOWN.graphics.endFill();
			
			DOWN.x= ControllerWith/4;
			DOWN.y= ButtonBack.y+ControllerHeight*0.6;
			
			
			ButtonContainer.addChild(DOWN);
			ButtonContainer.addChild(UP);
			
		//	var HitAreaShape:Shape = new Shape();
		//	HitAreaShape.graphics.beginFill(0x000000,1);
		//	HitAreaShape.graphics.lineStyle(0,0,0);
		//	HitAreaShape.graphics.drawRoundRect(-ControllerWith,0,ControllerWith*3,ControllerHeight,5,5);
			//HitAreaShape.y =- ControllerHeight/4;
		//	HitArea.addChild(HitAreaShape);
			
			
			trace ("INIT SCROLLBUTTON " + ControllerWith);
			
		}
		
		
	}
}