package com.window
{
	import com.events.*;
	import com.events.FISEvents;
	import com.interfaces.IDragDropable;
	import com.utility.Formula;
	
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.TextField;
		;
	
	public class ScrollbarBase extends Sprite implements IDragDropable
	{
		public var ScrollPercentage:Number = 0;
		public var Extend:Number;
		public var ButtonContainer:Sprite;
		public var HitArea:Sprite;
		public var Rail:Sprite;
		public var ControllerWith:uint;
		public var ControllerHeight:uint;
		private var dropChecker:Boolean = false; // wenn er true ist wir der scrollbutton gedropped 
		
		
		public function ScrollbarBase(ex:Number,cw:uint,ch:Number)
		{
			super();
			Extend = ex;
			ControllerWith=cw;
			ControllerHeight=Extend*ch;
			
			trace ("ControllerHeight "+ControllerHeight)
			Rail = new Sprite();
			this.addChild(Rail);
			
		//	HitArea = new Sprite();
		//	this.addChild(HitArea);
			
			ButtonContainer=new Sprite();
			this.addChild(ButtonContainer);
			
			
			
			
			
			ButtonContainer.addEventListener(MouseEvent.MOUSE_DOWN, dragIt);
			
			ButtonContainer.buttonMode=true;
		}
		
		public function setRestriction(e:Event):void
		{
			
		}
		
		public function resetRestriction(x1:int, y1:int, x2:int, y2:int):void
		{
		
		}
		
		public function dragIt(e:Event):void
		{
			stage.addEventListener(MouseEvent.MOUSE_UP, dropIt);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, checkForDrop);
			ButtonContainer.startDrag(false,new Rectangle(0,0,0.2,(Extend-ControllerHeight))); 
			//ButtonContainer.addEventListener(MouseEvent.MOUSE_OVER, dragIt);
			addEventListener(Event.ENTER_FRAME,checkRestriction);
			//HitArea.addEventListener(MouseEvent.MOUSE_OUT,dropIt);
		}
		
		public function dropIt(e:Event):void
		{
		
		
				trace ("MOUSEUP");
				ButtonContainer.stopDrag(); 
				//HitArea.stopDrag(); 
				stage.removeEventListener(Event.ENTER_FRAME,checkRestriction);
				ButtonContainer.removeEventListener(MouseEvent.MOUSE_OVER, dragIt);
				stage.removeEventListener(MouseEvent.MOUSE_MOVE, checkForDrop);
				//ButtonContainer.removeEventListener(MouseEvent.MOUSE_OUT,dropIt);
			
		}
		
		private function checkForDrop(e:MouseEvent){
			var distanceX:Number;
			var distanceY:Number;
			var thresholdX:Number = ButtonContainer.width+50;
			var thresholdY:Number = ButtonContainer.height+50;
			var ButtonMid:Point = new Point();
			ButtonMid.x = ButtonContainer.x + ButtonContainer.width/2;
			ButtonMid.y = ButtonContainer.y + ButtonContainer.height/2;
			distanceX = Formula.distance2d([ButtonMid.x,0],[mouseX,0]);
			distanceY = Formula.distance2d([0,ButtonMid.y],[0,mouseY]);
			trace( "Distances :" +distanceX+ " "+ distanceY);
			if (distanceX >= thresholdX || distanceY >= thresholdY){
				dropIt(new MouseEvent(MouseEvent.MOUSE_UP));
			}
		}
		
		public function checkRestriction(e:Event):void
		{
			//HitArea.y =  ButtonContainer.y
			ScrollPercentage = ((ButtonContainer.y)/(Extend-ControllerHeight))*100;
		//	trace ("Checking Restriction " + ScrollPercentage + " " +ButtonContainer.y);
			this.dispatchEvent(new WindowEvents(WindowEvents.WINDOW_SCROLL,ScrollPercentage));
		/*	if(ButtonContainer.y >= Extend){
				ButtonContainer.y = Extend
			}
			else if (ButtonContainer.y <=0){1
				ButtonContainer.y = 0;	
			}		
			ButtonContainer.x = 0;*/

		}
	}
}