﻿package  {
	import flash.display.MovieClip;
	import flash.events.*;
	
	
	
	public class HadleyAniScript extends MovieClip {
			
		private var Buttonpressed:String;
		private var Startframe:int;
		private var Land_active:Boolean = true;
		private var DruckTemp_active:Boolean = true;
			
		public function HadleyAniScript() {
			this.addEventListener(Event.ADDED_TO_STAGE,startAnimation);
			
			 
		}// constructor close
		
		private function startAnimation(e:Event){
			setObjectsVisible(false);
			IntroAni_mc.addEventListener(Event.ENTER_FRAME,checkIntro);
			Reflektion.gotoAndStop(45);
			Wolken_A.rotation = 0;
			Wolken_B.rotation = 0;
			trace(Wolken_A.rotation);
			Land_btn.buttonMode =true;
			Druck_btn.buttonMode =true;
			Sonne2106.buttonMode = true;
			Sonne2112.buttonMode = true;
			Sonne2103.buttonMode = true;
			Start_mc.buttonMode = true;
			
			Land_btn.gotoAndStop("active");
			Druck_btn.gotoAndStop("active");
			
			Druck_btn.addEventListener(MouseEvent.MOUSE_DOWN, toggleDruckTemp);
			Land_btn.addEventListener(MouseEvent.MOUSE_DOWN, toggleLand),
			Sonne2106.addEventListener(MouseEvent.MOUSE_DOWN, toggleReflekt);
			Sonne2112.addEventListener(MouseEvent.MOUSE_DOWN, toggleReflekt);
			Sonne2103.addEventListener(MouseEvent.MOUSE_DOWN, toggleReflekt);
			Start_mc.addEventListener(MouseEvent.MOUSE_DOWN, startAni);
			
		}
		
	
	
	function setObjectsVisible(vis:Boolean){
		Reflektion.visible = vis;
		Wolken_A.visible = vis;
		Wolken_B.visible = vis;
		Land_btn.visible = vis;
		Druck_btn.visible = vis;
		Sonne2106.visible = vis;
		Sonne2112.visible = vis;
		Sonne2103.visible = vis;
		HorEarth_mc.visible = vis;
		Kontinent.visible = vis;
		DruckTemp.visible = vis;
		
	}
	
	private function checkIntro(e:Event){
		if (IntroAni_mc.ani_mc.currentFrame == 154 ){
			IntroAni_mc.visible = false;
			setObjectsVisible(true);
			setStartVisibility();
			IntroAni_mc.removeEventListener(Event.ENTER_FRAME,checkIntro)
			
		}
	}
	
	private function setStartVisibility(){
		Wolken_B.visible = false;
	}
		
	
	private function toggleReflekt(e:MouseEvent){
		trace("toggle" + " " +e.currentTarget.name)
		
		if (e.currentTarget.name == "Sonne2106"){
			Wolken_A.WolkeCont.WolkeA.Rain_a.visible = false;
		}
		else{
			Wolken_A.WolkeCont.WolkeA.Rain_a.visible = true;
		}
		
		Buttonpressed = e.currentTarget.name;
		Startframe = Reflektion.currentFrame;
		trace ("Sonne2106 wird getoggelt CF: " +Reflektion.currentFrame)
	
		Reflektion.addEventListener(Event.ENTER_FRAME, rotateSun);

	}
	
	
	
	private function rotateSun(e:Event){
		
		if (Buttonpressed == "Sonne2106"){
			if (Startframe <= 45 && Reflektion.currentFrame>1 ){
				
				Reflektion.gotoAndStop(Reflektion.currentFrame-1);
				rotateClouds();
				scaleClouds();
				
				
			}
			if (Startframe <= 90 && Reflektion.currentFrame>1 ){
				Reflektion.gotoAndStop(Reflektion.currentFrame-1);
				rotateClouds();
				scaleClouds();
				
			}
			
		}
		
		if (Buttonpressed == "Sonne2112"){
			if (Startframe >= 45 && Reflektion.currentFrame<90 ){
				Reflektion.gotoAndStop(Reflektion.currentFrame+1);
				rotateClouds();
				scaleClouds();
			}
			if (Startframe >= 1 && Reflektion.currentFrame<90 ){
				Reflektion.gotoAndStop(Reflektion.currentFrame+1);
				rotateClouds();
				scaleClouds();
			}
			
		}
		if (Buttonpressed == "Sonne2103"){
			if (Startframe >= 1 && Reflektion.currentFrame<45 ){
				Reflektion.gotoAndStop(Reflektion.currentFrame+1);
				rotateClouds();
				scaleClouds();
			}
			if (Startframe <= 90 && Reflektion.currentFrame>45 ){
				Reflektion.gotoAndStop(Reflektion.currentFrame-1);
				rotateClouds();
				scaleClouds();
			}
			
		}
	}
	
	private function rotateClouds(){
	Wolken_A.rotation = calculateAngle(Reflektion.currentFrame)*0.4;
	Wolken_B.rotation = calculateAngle(Reflektion.currentFrame)*0.7;
	DruckTemp.rotation = calculateAngle(Reflektion.currentFrame)*0.4;
}
	private function scaleClouds(){
		Wolken_A.scaleX = -0.0000987654*Math.pow(Wolken_A.rotation,2)+1;
		Wolken_A.scaleY = -0.0000987654*Math.pow(Wolken_A.rotation,2)+1;
		DruckTemp.scaleX = -0.0000987654*Math.pow(Wolken_A.rotation,2)+1;
		DruckTemp.scaleY =  -0.0000987654*Math.pow(Wolken_A.rotation,2)+1;
		trace (Wolken_A.rotation);
		trace (Wolken_A.scaleX);
	};

	private function calculateAngle(inAngle:Number):Number{
		var returnValue = inAngle*1-45;
		return returnValue;
	}

	private function toggleLand(e:MouseEvent){
		trace ("toggle Land "+Land_active);
		switch (Land_active){
			case true:
			Land_active = false;
			Land_btn.gotoAndStop("neutral");
			Kontinent.visible = false;
			Wolken_A.visible = false;
			Wolken_B.visible = true;
			DruckTemp.gotoAndStop(3);
			
			break;
			case false:
			Land_active = true;
			Land_btn.gotoAndStop("active");
			Kontinent.visible = true;
			Wolken_A.visible = true;
			Wolken_B.visible = false;
			DruckTemp.gotoAndStop(1);		
			break;					 
			
		}
	}

	private function toggleDruckTemp(e:MouseEvent){
		trace ("toggle DruckTemp"+DruckTemp_active);
		switch (DruckTemp_active){
			case true:
			DruckTemp_active=false;
			Druck_btn.gotoAndStop("neutral");
			DruckTemp.visible=false;
			
			break;
			case false:
			DruckTemp_active=true;
			Druck_btn.gotoAndStop ("active");
			DruckTemp.visible=true;
			break;
		}
	}
	
	private function startAni(e:MouseEvent){
		IntroAni_mc.ani_mc.gotoAndPlay(2);
		Start_mc.visible = false;
	}



	} //Class Close
	
} // Package close
