﻿// ACHTUNG!! Das ist eine modifizierte Variante von SatCalculator.as für den Gebrauch mit der Stand Alone Version!!
// NICHT in Verbindung mit der Biologie/Geographie Einheit FEUERSPUREN verwenden!!

package {
	
	import com.events.SatCalcEvent;
	import com.tools.*;
	import ImageClip;
	import Display;
	import ImageCalc;
	import com.utilities.*;
	import com.events.*;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.ui.Mouse;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.text.*;
	import fl.transitions.Tween;
	import fl.transitions.easing.*;
	import flash.system.*;
	import flash.net.*;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	
	// NUR FALLS EINER DER BEIDEN DEBUGGER BENUTZT WIRD	
	//import nl.demonsters.debugger.MonsterDebugger;
	//import com.hexagonstar.util.debug.Debug;
	
	
public class SatCalculator extends SatCalcDisplay {
	
	
	private var DisplayAt:Point; 	// Die Koordinaten des Display
	
	//Fürs handling der Display Ebenen:
	
	var RGB_Tool:RGBKlass_tool;
	var AllocateLayer_Display:MovieClip;
	var ImageMetaData:ImageMeta; // Enthält Informationen zu eingeladenen Bildern;
	var ExtImages:ImageArray;	// lädt die externen Bilder
	var ExtImagesPos:Array;		// 2d Array enhält die positionen der extern gledenen Clips
	var ImageMetaDataXML:ImageMetaXML;
	var LoadingBar_:LoadingBar; 	// Ladestandsanzeige für die extern zu ladenden Bilder;
	
	
	var ToolsMetaDataXML:ToolsMetaXML;
	
	var CurrentlyDisplayed:Object; // Welches Bildobjekt wird momentan angezeigt
	var CurrentMarker:ClipMarker;			// markiert die gerade angezeigten Clips
	var RecentMarker:ClipMarker;			// markiert die vorher angezeigten Clips
	var DropMarker:ClipMarker;			// markiert die gerade angezeigten Clips
	
	var Calcarguments:Array; 	// Nimmt die zur Berechnung zu übergebenen Argumente auf
	var BildPositionenX:Array; 	// Enthält x-Koordinaten zur Positionierung der ImageClips
	var BildPositionenY:Array; 	// Enthält y-Koordinaten zur Positionierung der ImageClips
	var Bildnamen:Array; 		// enthält die Bildnamen der ImageClips
	var Picsdelete:Array;		// Die Bilder welche gelöscht wirden und nun wieder als Position zur verfügung stehen.
	var recentDataArray:Array;	// Daten des aktuellen Array. Nötig da sonst immer die gleiche Arrayinstanz verändert wird und so bei einem Stretch die orignal Daten verloren gehen.
	var recentArray:Array; 		// angezeigtes Array
	var ArrayForCalc:Array;		// Array welches aufgrund des gerade gedraggeden Clips in die Rechnung einfießt.
	var ReturnKoords:Array;		// enthält die x/y Werte an den der Bildclip zurückspringen soll
	var NameArray:Array;		// hier kommen die Namen der an der Rechnung Beteiligten rein
	var ArraysInTimeline:Array; // Die Arrays aus den auf die timline Fläche gedroppedten clips kommen hier rein
	var TimelineClips:Array; 	// Array speichert die Clips die an der Zeitreihe beteiligt sind.
	var TimelineData:Array;		// y-werte der Timeline
	var TimelineDataX:Array;	// x-werte der Timeline
	var TimelineTextX:Array;	// Beschriftung X-achse
	
	var Timeline_1:Array;
	var Timeline_2:Array;
	var Timeline_3:Array;
	var Timeline_4:Array;
	var Timeline_5:Array;
	var Timeline_6:Array;
	
	var CalcArrayA:Array;
	var CalcArrayB:Array;
	
	var TimePik_x:int;
	var TimePik_y:int;			//x und y Werte des Fadenkreuzes zum auslesen der Zeitreihe
	var TimelineMode:Boolean;    // Timelinemodus aus oder an?
	var NumberOfArgs:int;		// zählt die übergebenen Argumente
	var Count:int;
	var NumberOfArrayArgs:int 	// zählt die übergebenden Array- Argumente
	var Bildcounter:int; 		// zählt die erstellten  ImageClips
	var ImageForCalc:Bitmap;	// wird ein Button eines Eingangsbildes gewählt übergibt er sein Bild hierhin damit is in Calcarguments aufgenommen werden kann
	
	var ClipsForCalc:Array;		// Clips (neu erstellte Bilder) die in ein Rechnungsfeld gedraggeddropped wurden
	var AllClips:Array;			// Alle beteiligten Bilder-Movieclipsmüssen hier eingetragen sein 
	var CopyClips:Array;		// Die kopierten Clip-Bitmaps (Beim NDVI) kommen hier rein um wieder gelöscht zu werden  
	var AllCalcClips:Array		// ein erzeugter Clip trägt sich hier ein damit er zur Kollisonsabfrage innerhalb der Clips zur Verfügung steht.
	
	
	var ExtraPics:RGBSelector;
	
	var calcBild:ImageCalc;
	var Graph:GraphDraw;
	
	var activeCalc:String;	// Um festzustellen welche Rechnung begonnen wurde (NDVI / SUBST );
	
	var NDVIBitmap_A:BitmapData // Bitmap Objekt für die kleinen Kopien in der NDVI Formel
	var NDVIBitmap_B:BitmapData
	var RecentBitmap:BitmapData
	
	
	
	// BitmapData für die Zeitleistenfunktion
	
	var TimeBitmapDat_1:BitmapData;
	var TimeBitmapDat_2:BitmapData;
	var TimeBitmapDat_3:BitmapData;
	var TimeBitmapDat_4:BitmapData;
	var TimeBitmapDat_5:BitmapData;
	var TimeBitmapDat_6:BitmapData;
	
	// Bitmap für Zeitleistenfunktion
	
	var TimeBitmap_1:Bitmap;
	var TimeBitmap_2:Bitmap;
	var TimeBitmap_3:Bitmap;
	var TimeBitmap_4:Bitmap;
	var TimeBitmap_5:Bitmap;
	var TimeBitmap_6:Bitmap;
	
	var TimelineBitmaps:Array; // Array Nimmt die TimlineBitmaps zum späteren löschen  auf 

	
	
	//Variablen zur Hinterlegung ob die Cover der jeweiligen Methoden sichtbar sind
	
	var NDVIvis:Boolean;
	var SUBSTvis:Boolean;
	var TIMEvis:Boolean;
	
	//Hinterlegt in welchen Zustand sich das Modul befindet 0: Alles weg 1: Nur NDVI; 2: NDVI+SUBST; 3: NDVI+SUBST+TIME; 
	// 4: NDVI+SUBST+TIME+6Bildvorgaben
	var TaskState:uint; 
	public var PredefCalculated:Boolean = false;
	
	//var clippi:ImageClip;
	
	//var createdClip:McButton;
	//var Clippi:MovieClip;
	
	var substmc:McButton;
	var ndvimc:McButton;
	
	//var recentClip:MovieClip	// gewählter Clip
	var recentButton:MovieClip 	// momentan gedrückter Bildknopf

	var currentDisplay:String   // was wird grad angezeigt NDVI oder normal
	
	//var debugger:MonsterDebugger
	
	var Version:String;
	
	// TOOLS DIE EIGENLADEN WERDEN KÖNNEN WERDEN DURCH VARIABLEN AKTIV ODER INAKTIV GESCHALTET!!!
	
	private var ToolURL:String;
	private var ImageURL:String;
	private var RGB_Tool_active:Boolean;
	// private var TOOL_override:Boolean; // Ein aktives Tool kann deaktiviert werden;
	private var SimilarValue_Tool_active:Boolean;
	private var ToolsLoaded:Array; // die Namen aller geladenen Tools kommen hier rein
	private var ToolPositions:Array; // Die xy Positionen der Tools
	private var ToolPositionsYChange:int; // Falls der Block zum Bildspeichern wegfällt rücken die Tools um dieen Betrag nach oben;
	private var GhostsArray:Array;	//	Die Namen aller Ghosts
	
	
	// Relevant für den Drop Vorgang
	// DropFields werden in einem Array abgelegt
	
	private var SuccessfullDrop:Boolean; // Wenn der Drop eines Clips eine Funktion ausgelöst hat wird diese auf true gesetzt wenn nich erfolgt ein dropBack des Clips 
	private var DropFieldsArray:Array;
	
	// Metainformationen der aktuell angzeigten Daten
	
	var CurrentMetaArray:Array;
	
	// Metainformationen für die Sicherung
	
	var SaveMetaArray:Array;
	
	// Die Display History wird hier protokoliert Array hat drei Spalten [Name,Datum,Typ]
	
	var DisplayHistory:Array;
	
	// Wo steht der SatCalc globalche
	
	public var GlobalPos:Point;
	
	// Welches ist das aktuelle Dropfield (basierend aus der Distanz des recentClip zu den Dropfields)
	
	public var HotDropField:String;
	
	private var Screendrops:int; // Wie viele Screendrops wurden gemacht, wichtig für deren Namensfindung
	

// Wenn Eine Flash Datei über eine Dokumenten Klasse gesteuert wird, muss diese auf das ADDED_TO_STAGE Event warten
// bevor sie "initiiert" wird.

// In diesme Fall soll von aussen initier werden um noch Varialben übergeben zu können. Desswegen signalisiert der SatClac wenn
// er geaddet wurde. Die Aufrufende SWF startet dan den INIT und übergibt die Notwendigen Variablen

public function SatCalculator(){
	
	addEventListener(Event.ADDED_TO_STAGE, signalInit, false, 0, true);
}



public function signalInit(event:Event){ 
this.dispatchEvent(new SatCalcEvent(SatCalcEvent.SATCALC_INIT));
}

	
public function initalize(toolurl:String,imageurl:String){
//Display Container hinzufügen;
	addDisplay();
	
	//ZUR REAKTIVIERUNG DES DROPSCREEN WIEDER ENTKOMMENTIEREN!
	DisplayContainer.addEventListener(MouseEvent.MOUSE_OVER, addIcon,false,0,false);
	DisplayContainer.addEventListener(MouseEvent.MOUSE_OUT, removeIcon,false,0,false);

// Wo liegen Bilder und Tools

ToolURL = toolurl;
ImageURL = imageurl;

// VESRIONSNUMMER!!!!!!!!!!!!!!!!!!!!

Version = "SatCalc_StA 30102013"

GlobalPos = this.localToGlobal(new Point(this.x,this.y))
trace ("Hello SatCalc wird bei" + " "+ GlobalPos +" "+" ausgegeben");

// Startsichtbarkeiten
	trace ("SatCalc Version: "+Version);
	TaskState = 1;
	Modus_mc.visible = false; // MC wird beim wechsel des Modus angezeigt 
	
	
	
	colorpik_mc.visible=false;			// Button zur Errechnunge A-B
	tonne_mc.visible=false;
	tonneunder_mc.visible = true;
	hourglas_mc.visible=false;
	Infotext_mc.visible = false;
	
	TimelineMode = false;

	
	
	DragStatus = false;
// Zustandparameter
	NDVIvis=true;

// MetaDaten Arrays


CurrentMetaArray = new Array();
SaveMetaArray = new Array();
DisplayHistory = new Array();

// Button Modes
	
	pikpix_mc.buttonMode = true;
	pikpix_mc.useHandCursor = true;
	
	
	SwipeMode_mc.buttonMode = true;
	SwipeMode_mc.useHandCursor = true;
	
	activeCalc = new String();
	activeCalc = "NONE"
	
	
	
	CopyClips = new Array();
	TimelineBitmaps = new Array();
	
	addChildAt(display_mc,1);
	
	// hier undbedingt ALLE Movieclips der Eingangsbilder eintragen da sonst die Kollosionsabfrage untereinander nicht funktioniert
	
	AllClips = new Array();
	
	AllCalcClips = new Array();
	
	// Arrays für die Timeline initiieren
	
	ArraysInTimeline = new Array(6);
	TimelineData = new Array();
	TimelineDataX = new Array();
	//TimelineDataX.unshift(0,15,30,45,60,75)
	TimelineTextX = new Array();
	TimelineTextX.push(null,null,null,null,null,null);
	TimelineData.push(null,null,null,null,null,null);
	TimelineDataX.push(null,null,null,null,null,null);
	//TimelineData.push(0,0,0,0,0,0);
	
	Timeline_1 = new Array(250000);
	Timeline_2 = new Array(250000);
	Timeline_3 = new Array(250000);
	Timeline_4 = new Array(250000);
	Timeline_5 = new Array(250000);
	Timeline_6 = new Array(250000);
	
	TimelineClips = new Array (6);
	
	
	
	// CalcBild Object wird erstellt aber nihct angezeigt
	calcBild = new ImageCalc(new Bitmap(new BitmapData(100,100)),new Bitmap(new BitmapData(100,100)));
	
	// Movieclips die an einer Rechnung teilnehemen

	ClipsForCalc = new Array();
	
	// Display Koordinaten
	
	DisplayAt = new Point(65,12);
	
	// Image for Calc das aktuell gewählte Bild 
	
	//ImageForCalc=IR_2007_02_26Instance;
		
	// Variablen zur Zustandsdefinition
	recentButton= new MovieClip();
	//recentClip= new MovieClip();
	//recentClip.name = "Leer";
	NumberOfArrayArgs = 0;	
	NumberOfArgs = 0;
	Count = 0;
	
	//ClipsForCalc[0]= [0,"NIX"];
	
	
	CalcArrayA= new Array();
	CalcArrayB= new Array();
	
	NameArray= new Array("empty","empty");
	Calcarguments = new Array(4);
	
	// Arrays enthalten Bild und Daten des akttuell angezeigten Arrays
	
	recentArray =new Array();
	recentDataArray =new Array();
	ArrayForCalc = new Array();
	
	// Arrays mit Positions und Namensdaten für Repräsentationen der neu erstellten Rechenbilder 
	
	BildPositionenY= new Array(20,20,20,60,60,60);
	BildPositionenX= new Array(645,695,745,645,695,745);
	
	// Das Array enthält alle Informationen die zur Positionierung von neu berechneten bildern notwending sind. Name,belegbar?,Koordinaten
	Bildnamen = new Array(["B1",true,645,20],["B2",true,695,20],["B3",true,745,20],["B4",true,645,60],["B5",true,695,60],["B6",true,745,60],["B7",true,645,100],["B8",true,695,100]);
	
	
	Bildcounter =0;
	Picsdelete = new Array();
	
	// Zum Bildwerte auslesen notwendig (NDVI oder nicht?)
	
	currentDisplay = "NOIMAGE";

	
	
	// Event Listenr, der abfragt ob Tastengedrücktn wurden und keyGoto() aufruft
	
	stage.addEventListener (KeyboardEvent.KEY_DOWN,firstKey);
	
	pikpix_mc.addEventListener(MouseEvent.MOUSE_DOWN,picPix);
	stage.addEventListener(SatCalcEvent.TOOL_STATUS,setToolStatus);
	
	SwipeMode_mc.addEventListener(MouseEvent.MOUSE_DOWN,SwipeModeSwitch);
	
	// Wenn ein Tool aktiviert wird, wird ein Event an andere Tools abgegeben 
	stage.addEventListener(SatCalcEvent.TOOL_ENABLED,signalToolEnabled);
		
	// Buttons für die Rechunungen SUBST und NDVI
	
	

	//timeline();
	
	//ModulZustand einstellen
	
	
	// ALLES ZUM EINLADEN DER EXTERNEN BILDDATEN
	
	ExtImagesPos = new Array(6);
	ExtImagesPos[0] = [5,10];
	ExtImagesPos[1] = [5,52];
	ExtImagesPos[2] = [5,94];
	ExtImagesPos[3] = [5,136];
	ExtImagesPos[4] = [5,178];
	ExtImagesPos[5] = [5,220];
	ExtImagesPos[6] = [5,262];
	ExtImagesPos[7] = [5,304];
	ExtImagesPos[8] = [5,346];
	ExtImagesPos[9] = [5,388];
	
	
	
	GhostsArray = new Array();
	
	// ToolURL = ;
	
	ToolPositions = new Array();
	ToolPositions[0] = [638,165];
	ToolPositionsYChange = 0;
	
	// Drop Fields Array wird angelegt;
	DropFieldsArray = new Array();
	
	ImageMetaDataXML = new ImageMetaXML(ImageURL);
	
	ImageMetaDataXML.addEventListener(FISEvents.DATA_READY,loadExtImages,false,0,true);
	
	// Ein leerer Marker wird erstellt damit dieser gleich in clipMarker() gelöscht werden kann sobald ein Clip angezeigt wird
	CurrentMarker = new ClipMarker(new MovieClip(),false);
	addChild(CurrentMarker);
	
	RecentMarker = new ClipMarker(new MovieClip(),false);
	addChild(RecentMarker);
	
	DropMarker = new ClipMarker(new MovieClip(),false);
	addChild(DropMarker);
	
	// Einladen der TOOLS
	
	ToolsMetaDataXML = new ToolsMetaXML(ToolURL);
	
	ToolsMetaDataXML.addEventListener(FISEvents.DATA_READY,loadTools,false,0,true);
	
	addEventListener(SatCalcEvent.INIT_SAVEIMAGE,SaveImage,false,0,true);
	
	

	//DisplayContainer.addChildAt(RGB_Tool,ToolDisplayLayer);
	
	//TOOLS////TOOLS////TOOLS////TOOLS////TOOLS////TOOLS////TOOLS////TOOLS////TOOLS////TOOLS////TOOLS////TOOLS//
	
	ToolsLoaded= new Array();
	
	
	// TOOL DUMMYS jedes Tools das theoretisch instanziert werden kann muss hier einmal instanziert werden,
	// damit der Compiler es "kennt"
	
	var SimValDummy:SimilarValues = new SimilarValues(null,null,[null,null,null,null],null);
	SimValDummy = null;
	
	var NDVICalcDummy:NDVICalculator = new NDVICalculator(null,null,null,null);
	NDVICalcDummy = null;
	
	var VECTORToolsDummy:VectorTools = new VectorTools(null,null,null,null);
	VECTORToolsDummy = null;
	
	
	var DIFFToolDummy:DifferenceTool = new DifferenceTool(null,null,null,null);
	DIFFToolDummy = null;
	
	var TIMEToolDummy:TimelineTool = new TimelineTool(null,null,null,null);
	TIMEToolDummy = null;
	
	var STATToolDummy:StatFilterTool = new StatFilterTool(null,null,null,null);
	STATToolDummy = null;
	
	var VetorTollsLineModDummy:VectorToolsLineMod = new VectorToolsLineMod(null,null,null,null);
	VetorTollsLineModDummy = null;
	//var FILTERToolDummy:FilterTool = new FilterTool(null,null,null,null);
	//FILTERToolDummy = null;
	
	
	Screendrops = 0;
	
	// Gibt der Stage die Möglichkeit TOOLS zu deaktivieren (Wenn z.B. die Pipette mit unerwünscht interagiert)
	//TOOL_override = false;
	
	// Array für angezeigte Ghosts;
	
	// Wenn Bild berührt wird
	
	//DisplayContainer.addEventListener(MouseEvent.MOUSE_OVER,function(){trace ("MOUSE OVER DIPLAYCONTAINER")};
	
}//Constructor close


// Überprüft ob der gerade gewählte Clip(recentButton) auf die Anzeigefläche gedraggeddropped wurde und ruft je 
// nach dem showChannel auf und setzt den Button auf seine Ausgangsposition zurück.

private function checkDrop(){
	SuccessfullDrop = false;
	var checker:String = recentButton.toString();
	trace("Checking Drop for checker: "+checker);
	
	
		// prüfen ob der abgelegte Clip(der erzeugten Bilder) bereits Teil einer Rechnung ist 
		// Erst wird geprüft ob das ClipsfForCalc Array überhaupt ImageClips enthält, da sonst eine Suche nach
		// ImageClip.name zum Fehler führt (da Eigenschaft nicht vergeben, da kein ImageClip vorhanden)
		
		for(var j=0;j<ClipsForCalc.length;j++){
			trace ("Clip an Stelle j: " + typeof(ClipsForCalc[j][0]));
			if (ClipsForCalc[j][0] is Number){
			trace("NIX PASSIERT");
			}
			else if (ClipsForCalc[j][0] is ImageClip || ClipsForCalc[j][0] is ExtClip){
				
				if (ClipsForCalc[j][0].name==recentButton.name){
					trace (recentButton.name + " ist rausgeflogen");
					DropField(getChildByName(ClipsForCalc[j][1])).Status=true;
					ClipsForCalc.splice(j,1);
					for(var i = 0;i<ToolsLoaded.length;i++){
					 getChildByName(ToolsLoaded[i]).dispatchEvent(new SatCalcEvent(SatCalcEvent.DATA_DELETE,recentButton.name));
					}
				}
			}
		}
		
		
		// Prüfen ob der Clip bereits Teilnehmer einer Zeitreihe ist und löschen desselben aus dieser
		
		
		// TEST FÜR DROPFIELDS nur wenn auch welche da sind
			
		if (checkForDropfields()==true){
			if (recentButton.hitTestObject(DropField(getChildByName(HotDropField))) && DropField(getChildByName(HotDropField)).Status==true){
					 trace ("HIIIIIIIIIIIIIIIT AUUUUUUUUUUUUUFFFFFFFFFFFFFFF "+HotDropField);
					 DropMarker.visible = false;
					 trace ("Test vor Übergabe : "+ ArrayForCalc[20]);
					 ClipsForCalc.push([recentButton,HotDropField]);
					 DropField(getChildByName(HotDropField)).Status=false;
					 for(var i = 0;i<ToolsLoaded.length;i++){
						 getChildByName(ToolsLoaded[i]).dispatchEvent(new SatCalcEvent(SatCalcEvent.DATA_DROP,[HotDropField,recentArray,recentButton.Ghost_mc,recentButton.name,recentButton.DataWidth,recentButton.DataHeight,recentButton.kanal,recentButton.Resolution,recentButton.Unit,recentButton.datum]));
						 recentButton.x = DropField(getChildByName(HotDropField)).x;
						 recentButton.y = DropField(getChildByName(HotDropField)).y;	
						 SuccessfullDrop = true;
						 markClip();
				 }
			}
		}
		
		
		
	// Anzeigen bei drop auf die Anzeigefläche
		
		if (recentButton.x<630 && recentButton.x>60){
			SuccessfullDrop = true;
			switch (checker){					
		
				
				// Je nachdem ob der anzuzeigende ExtClip RGB oder channel ist wird ein gestretchtes graubild oder
				// das RGB Bild angezeigt.
				case "[object ExtClip]":
					currentDisplay = "ExtClip"
					if (ExtClip(getChildByName(recentButton.name)).Type_ == "channel" || ExtClip(getChildByName(recentButton.name)).Type_ == "ValueImage"){
					recentDataArray=recentButton.returnArray();
					CurrentlyDisplayed = recentArray;
					Show(CurrentlyDisplayed,"StretchArray",display_mc.x +2,display_mc.y +2,ExtClip(getChildByName(recentButton.name)).DataWidth,ExtClip(getChildByName(recentButton.name)).DataHeight,ExtClip(getChildByName(recentButton.name)).StretchFactor);
					
					
					clipRepos(recentButton.name);
					updateMetaData(ExtClip(getChildByName(recentButton.name)));
					updateDisplayHistory();
					DataToTools();
					SuccessfullDrop = true;
					trace (CurrentMetaArray);
					}
					if (ExtClip(getChildByName(recentButton.name)).Type_ == "RGB" || ExtClip(getChildByName(recentButton.name)).Type_ == "Classes"|| ExtClip(getChildByName(recentButton.name)).Type_ == "SCREEN"){
					//RGB_Tool.initClassImage(ExtClip(getChildByName(recentButton.name)).InBitmap);
					CurrentlyDisplayed = ExtClip(getChildByName(recentButton.name)).InBitmap;
					
					Show(CurrentlyDisplayed,"Bitmap",display_mc.x +2,display_mc.y +2,ExtClip(getChildByName(recentButton.name)).DataWidth,ExtClip(getChildByName(recentButton.name)).DataHeight);
					
					//showPic(ExtClip(getChildByName(recentButton.name)).InBitmap);
					clipRepos(recentButton.name);
					updateMetaData(ExtClip(getChildByName(recentButton.name)));
					updateDisplayHistory()
					DataToTools();
					SuccessfullDrop = true;
					}
					
					if (ExtClip(getChildByName(recentButton.name)).Type_ == "Overlay"){
					//RGB_Tool.initClassImage(ExtClip(getChildByName(recentButton.name)).InBitmap);
					CurrentlyDisplayed = ExtClip(getChildByName(recentButton.name)).InBitmap;
					Show(ExtClip(getChildByName(recentButton.name)).InBitmap,"Overlay",display_mc.x +2,display_mc.y +2,ExtClip(getChildByName(recentButton.name)).DataWidth,ExtClip(getChildByName(recentButton.name)).DataHeight);
					DisplayHistory.unshift([ExtClip(getChildByName(recentButton.name)).Name,ExtClip(getChildByName(recentButton.name)).datum,ExtClip(getChildByName(recentButton.name)).Type_]);
					SuccessfullDrop = true;   
		
					//showPic(ExtClip(getChildByName(recentButton.name)).InBitmap);
					//updateMetaData(ExtClip(getChildByName(recentButton.name)));
					clipRepos(recentButton.name);
					}
					
				break;
				
			}
		
		  CurrentlyDisplayed = recentButton;
		  markClip();
		}
		
		
		else {												
		
						
		// löschen von auf die Mülltonne gedraggeddropten Elementen (gilt nur für Clips die mit dem Zusatz "nopredef" erzeugt wurden
				
			if (checker =="[object ExtClip]" &&  (getChildByName(recentButton.name)).hitTestObject(tonne_mc) && (ExtClip(getChildByName(recentButton.name)).Deleteable==true)){
						trace (recentButton.name +" wandert in die tonne")
						erazeClip(ExtClip(getChildByName(recentButton.name)));
						SuccessfullDrop = true;
						
		
			}	
				
			 
			if (SuccessfullDrop == false){
					trace("Keine Funktion durch Drop ausgelöst");
					clipRepos(recentButton.name);
					
					
						
			}
					
					
			
		}

		
		trace ("aktive Rechnung: "+activeCalc);
		trace("Im CalcArray: "+typeof(Calcarguments[0])+" and "+typeof(Calcarguments[1]));
		//trace("Im CalcArray(2): "+Calcarguments[0]+" and "+Calcarguments[1]);
		
		for (var i= 0; i<2; i++){
			
			if (Calcarguments[i] is Bitmap || Calcarguments[i] is Array){
				Count = Count+1
				NumberOfArgs = Count;
			}

		}
		Count=0;
		trace (Count);
		trace ("NumberOfArgs: "+NumberOfArgs);
		
		
		NumberOfArgs = Count;
		
		


}//checkDrop close
	
		
		
// bringt die Clips der Eingangsbilder wieder an ihren angestammten Platz
		
	
	private function clipRepos(Clipname:String){
		trace ("clipname : " + Clipname);
		(getChildByName(Clipname)).x = ExtClip(getChildByName(Clipname)).XKoord;
		(getChildByName(Clipname)).y = ExtClip(getChildByName(Clipname)).YKoord;
		(getChildByName(Clipname)).scaleX=1.3;
		(getChildByName(Clipname)).scaleY=1.3;
	}
	

	 
		
	
	private function clippidown(event:MouseEvent){
		if (ImageClip(event.currentTarget).PreDef=="nopredef"){
			tonne_mc.visible = true;
			tonneunder_mc.visible = false;
			tonne_mc.gotoAndPlay(2);
			
		}
		else if (ImageClip(event.currentTarget).PreDef=="predef"){
			tonne_mc.x=800;
			tonne_mc.visible = false;
			tonneunder_mc.visible = false;
		}
		
		event.currentTarget.x=mouseX-15;
		event.currentTarget.y=mouseY-15;
		
		
		ImageClip(event.currentTarget).startDrag();
		DragStatus = true;
		unAnimate(ImageClip(event.currentTarget));
		addChildAt(getChildByName(DisplayObject(event.currentTarget).name),numChildren);
		recentArray=ImageClip(event.currentTarget).returnArray();
		ArrayForCalc=ImageClip(event.currentTarget).returnArray();
		recentButton = ImageClip(event.currentTarget);
		
		
		trace ("Nameausgw: "+ ImageClip(event.currentTarget).name);
		
		if (ImageClip(event.currentTarget).Methtext=="SUBST"){
		}
		if (pikpix_mc.currentFrame==2){
		pikpix_mc.dispatchEvent(new Event(MouseEvent.MOUSE_DOWN));
		}
	}
	

	
	private function clippiup(event:MouseEvent){
		event.currentTarget.stopDrag();
		DragStatus = false;
		checkDrop();					
		tonneunder_mc.visible = true;
		tonne_mc.x=695.3;
		tonne_mc.visible = false;
	}
	
	// Down und UP Events für die externen Clips
	
	private function extClipDown(event:MouseEvent){
		
		event.currentTarget.x=mouseX-15;
		event.currentTarget.y=mouseY-15;
		(event.currentTarget).startDrag();
		
		recentButton = ExtClip(event.currentTarget);
		// Nur wenn ein Tool mit Dropfields geladen wurde werden diese auch abgefragt If muss bei neuen Tools ggf. erweitert werden
		if (checkForDropfields()==true){
		this.addEventListener(MouseEvent.MOUSE_MOVE,setHotDropField)
		}
		unAnimate(event.currentTarget);
		ImageForCalc=ExtClip(event.currentTarget).InBitmap;
		if(ExtClip(event.currentTarget).typeStored=="Array" ){
			recentArray=ExtClip(event.currentTarget).returnArray();
			ArrayForCalc=ExtClip(event.currentTarget).returnArray();
			
		}
		
		if(ExtClip(event.currentTarget).Deleteable==true ){
			tonne_mc.visible = true;
			tonneunder_mc.visible = false;
			tonne_mc.gotoAndPlay(2);
		}
		
		
		//ArrayForCalc=ImageClip(event.currentTarget).returnArray();
	}
	
	
	private function extClipUp(event:MouseEvent){
		(event.currentTarget).stopDrag();
		this.removeEventListener(MouseEvent.MOUSE_MOVE,setHotDropField);
		//extClipDropScale(event.currentTarget);
		DragStatus = false;
		tonne_mc.gotoAndStop(1);
		checkDrop();
	}
	
	private function extClipDropScale(clip:ExtClip){
		trace("scaling "+clip.name);
		clip.width=6;
		clip.scaleY=1.2;
		
	}
	
	private function clippiover(event:MouseEvent){
		addChildAt(getChildByName(event.currentTarget.name),numChildren);
		animate(event.currentTarget)
	}
	
	private function clippiout(event:MouseEvent){
		trace("clippiout");
		unAnimate(event.currentTarget);
	}
	
	private function clippimove(event:MouseEvent){
		if(event.currentTarget.hitTestObject(tonne_mc)){tonne_mc.gotoAndPlay(6);}
		else{tonne_mc.gotoAndPlay(1);}
	
	}

	private function clipDropScale(clip:Object){
		trace("resizin");
			
			clip.scaleX=1.2;
			clip.scaleY=1.2;
			
		}
	
	private function animate(clip:Object){
		clip.scaleX=2;
		clip.scaleY=2;
	}
	
	
	private function unAnimate(clip:Object){
		/*if (clip.hitTestObject(a_mc)|| clip.hitTestObject(b_mc)
			|| clip.hitTestObject(time_mc_1)||clip.hitTestObject(time_mc_2)||clip.hitTestObject(time_mc_3)
			|| clip.hitTestObject(time_mc_4)|| clip.hitTestObject(time_mc_5)|| clip.hitTestObject(time_mc_6)){
		clip.scaleX=1.1;
		clip.scaleY=1.1;
		}*/
		//else  {
		clip.scaleX=1.3;
		clip.scaleY=1.3;
		
		//}
		
	}
	

	
		
	// Zur Ermittlung des Minimums und des Maximums der an den Graphen übergebenen Datenreihe
	// Wenn der Graph aufgerufen wird werden ihm die Stellen 0 u. 1 des ReturnArrays als darzustellender Wertebereich übergeben. 
	
	private function MinMax(ar:Array):Array{
		var ReturnArray:Array = new Array(2);
		var min = ar[1];
		var max = ar[1];
		for (var f=0;f< ar.length;++f){
				if (ar[f]<min){
				min = ar[f];
				}
				else if  (ar[f]>max){
				max = ar[f];	
				}
				ReturnArray[0]=min;
				ReturnArray[1]=max;
				if (ReturnArray[0]>=0){
					ReturnArray[0]=0}
		}
		
		return ReturnArray;
	}
	
		
	private function PixelValue(e:Event){
			trace(currentDisplay);
			//var PixVal;
			if (mouseX >65 && mouseX<(65+OutputImage.width)&&mouseY>12&&mouseY<(12+OutputImage.height)){
			colorpik_mc.x=mouseX;
			colorpik_mc.y=mouseY;
			colorpik_mc.visible=true;
			Infotext_mc.x=mouseX+5;
			Infotext_mc.y=mouseY-5;
			setChildIndex(Infotext_mc,numChildren-1);
			Infotext_mc.visible = true;
			
			Mouse.hide();
			if (currentDisplay == "NDVI" || currentDisplay == "CALCRESULT" ){
				//var PixVal=recentDataArray[calcBild.getPixValue(recentDataArray,OutputImage.width,OutputImage.height,mouseX-65,mouseY-12)]
				var PixVal=CurrentlyDisplayed[calcBild.getPixValue(CurrentlyDisplayed,OutputImage.width,OutputImage.height,mouseX-65,mouseY-12)]
				Infotext_mc.Pixwert.text = PixVal.toString();
				Infotext_mc.Pixwert.text = Infotext_mc.Pixwert.text.slice(0,4);
				}
				
				else if (currentDisplay == "SUBST" || currentDisplay == "NORM" || currentDisplay == "ExtClip") {
					trace (ExtClip(CurrentlyDisplayed).Type_);
					
					if (ExtClip(CurrentlyDisplayed).Type_ == "RGB") {
					Infotext_mc.Pixwert.text = readRGB(DisplayHistory[0][0]);
					}
					
					else if (ExtClip(CurrentlyDisplayed).Type_ == "ValueImage") {
						trace ("displaying Values for ValueImage");
						Infotext_mc.Pixwert.text = readValue(DisplayHistory[0][0]);
						//Infotext_mc.Pixwert.text = readValue();
					}
					
					else if (ExtClip(CurrentlyDisplayed).Type_ == "Classes"){
						 Infotext_mc.Pixwert.text = readClass(DisplayHistory[0][0]);
					}
					
					else if (ExtClip(CurrentlyDisplayed).Type_ == "Overlay"){
						trace ("overlay aktiv");
						
						// Abhängig vom Bildtyp welcher unter dem Ovelay liegt werden die Werte eingelesen
						
						switch (DisplayHistory[1][2]) {
						case "RGB":
						Infotext_mc.Pixwert.text =readRGB(DisplayHistory[1][0]);
						break;
						
						case "ValueImage":
						Infotext_mc.Pixwert.text =readValue(DisplayHistory[1][0]);
						break;
						
						case "Classes":
						Infotext_mc.Pixwert.text =readClass(DisplayHistory[1][0]);
						break;
						
						}
					}
					
					else{
						var PixVal=recentDataArray[calcBild.getPixValue(recentDataArray,OutputImage.width,OutputImage.height,mouseX-65,mouseY-12)]
						Infotext_mc.Pixwert.text = PixVal.toString();
						Infotext_mc.Pixwert.text = Infotext_mc.Pixwert.text.slice(0,4);
					}
				}
				
				else if (currentDisplay == "CLASS"){
				trace ("displaying Values for ");
				var PixVal=(ExtClip(CurrentlyDisplayed).returnRGBat(mouseX-65,mouseY-12)).toString();
					if (ExtClip(CurrentlyDisplayed).Type_ == "Classes"){
						Infotext_mc.Pixwert.text =ExtClip(CurrentlyDisplayed).getClass(mouseX-65,mouseY-12)
					};
					if (ExtClip(CurrentlyDisplayed).Type_ == "RGB") {
					Infotext_mc.Pixwert.text = PixVal.toString();
					}
					
				}
				
				else if (currentDisplay == "SCREEN"){
				trace ("displaying Values for SCREEN");
				var PixVal=(ImageClip(CurrentlyDisplayed).returnRGBat(mouseX-65,mouseY-12)).toString();
					Infotext_mc.Pixwert.text = PixVal.toString();
				}
			}
			else{Mouse.show();
			Infotext_mc.Pixwert.text = ""
			Infotext_mc.visible = false;
			colorpik_mc.visible=false;}
	}
	
	
	// die read... Funktionen lesen die Werte auf dem Bild aus welches ihnen als name aus der DisplayHistory übergeben wurde
	
	private function readRGB(BitmapName:String):String{
		var returnVal:String;
		returnVal =(ExtClip(getChildByName(BitmapName)).returnRGBat(mouseX-65,mouseY-12)).toString();
		return returnVal;
	}
	
	private function readValue(ArrayName):String{
		var returnVal:String;
		returnVal = ExtClip(getChildByName(ArrayName)).InArray[calcBild.getPixValue(ExtClip(getChildByName(ArrayName)).InArray,OutputImage.width,OutputImage.height,mouseX-65,mouseY-12)];
		//returnVal = recentDataArray[calcBild.getPixValue(recentDataArray,OutputImage.width,OutputImage.height,mouseX-65,mouseY-12)];
		returnVal = returnVal.slice(0,4)+ " "+ ExtClip(getChildByName(ArrayName)).ValueUnit;
		return returnVal;
	}
	
	private function readClass(BitmapName:String):String{
		var returnVal:String;
		returnVal = ExtClip(getChildByName(BitmapName)).getClass(mouseX-65,mouseY-12);
		return returnVal;
	}
	
	
	function classes(arr:Array){
		var returnString:String;
		returnString = arr.toString();
		return returnString;
	}
	



private function erazeClip(toEraze:ExtClip){
	//delete recentButton;
				Picsdelete.push(toEraze.name.toString())
				tonne_mc.gotoAndStop(1);
				trace (Picsdelete);
				
				toEraze.removeEventListener(MouseEvent.MOUSE_DOWN,clippidown); 
				toEraze.removeEventListener(MouseEvent.MOUSE_UP,clippiup);
				toEraze.removeEventListener(MouseEvent.MOUSE_OVER,clippiover);
				toEraze.removeEventListener(MouseEvent.MOUSE_OUT,clippiout);
				toEraze.removeEventListener(MouseEvent.MOUSE_MOVE, clippimove);
				
				
				// Stelle im Bildnamen Array wieder verfügbar machen
				
				var i:int;
				
				while(i<Bildnamen.length){
					if(Bildnamen[i][0] == toEraze.name){
					Bildnamen[i][1]=true;
					break;
					}
					i++
				}
				
				trace("geradegelöscht: "+toEraze.name);
				removeChild(toEraze);
				toEraze=null;
				recentArray=null;
				recentDataArray=null;
				recentButton=null;
				for (var e=0;e<numChildren;e++){
					trace(getChildAt(e).name);
				}
				
}


	private function gcHack():void
	{
		   // unsupported hack that seems to force a full GC
	
		   try
		   {
				  var lc1:LocalConnection = new LocalConnection();
				  var lc2:LocalConnection = new LocalConnection();
	
				  lc1.connect('name');
				  lc2.connect('name');
		   }
		   catch (e:Error)
	
		   {
	
		   }
	}
	
	


// gibt an den aufrufenden manager zurück, ob die vorgerechnten Bilder fertig berechnet sind
public function returnState():String{
	return PredefCalculated.toString();
}

// Startmanager kann so das AnalyseTool ausschalten
public function command():void{
	trace ("AUS");
	Infotext_mc.Pixwert.text="";
	pikpix_mc.gotoAndStop(1);
	stage.removeEventListener(MouseEvent.MOUSE_MOVE, PixelValue);
	Mouse.show();
	colorpik_mc.visible=false;
	stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_STATUS,true));
}

public function command2():void{
	trace("COMMAND2");
	stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_STATUS,false));
}
	
public function returnIntState():uint{
	return TaskState
	};

	
	
// Steuert zusammen mit secondKey() einen bestimmten Status über eine Tastaturreihenfolge an (keine Kombination!!) 
 // strg dann e - nur bilder anzeigen; strg dann n - NDVI, strg dann d - Differenzbild; strg dann z - Zeitreihe
	
 private function firstKey(e:KeyboardEvent){
	 if (e.ctrlKey){
		  trace ("strg");
		 Modus_mc.visible = true;
		stage.removeEventListener(KeyboardEvent.KEY_DOWN,firstKey);
		stage.addEventListener(KeyboardEvent.KEY_DOWN,secondKey);
		
	 }
  
 }
 
 
 
 private function secondKey(ev:KeyboardEvent){
	 trace (ev.keyCode);
	  Modus_mc.visible = false;

 }
 
 private function loadExtImages(e:FISEvents){
	LoadingBar_ = new LoadingBar(ImageMetaDataXML.ImageURLs.length,0,0,535,30,0xD9E6DC);
	LoadingBar_.x=5;
	LoadingBar_.y=490;
	LoadingBar_.rotation = -90;
	ExtImages = new ImageArray(ImageMetaDataXML.ImageURLs,ImageMetaDataXML.ImageTypes,ImageMetaDataXML.ImageChannels);
	ExtImages.addEventListener(FISEvents.IMAGE_INIT,loadImages,false,0,true);
	ExtImages.addEventListener(FISEvents.CALC_PROGRESS,updateLoadingBar,false,0,true);
 }
 
 
 
 private function loadImages(e:FISEvents){
 	
	for (var i = 0; i<ExtImages.BitmapArray.length; i++){
			//trace ("DADADAADADADA "+ExtImages.BitmapArray[i])
	  		//var ClippiName=getClipName();
			var ExtClippi:ExtClip=new ExtClip(ExtImages.BitmapArray[i],ImageMetaDataXML.MetaDataArray[i][0],ImageMetaDataXML.MetaDataArray[i][1],ImageMetaDataXML.MetaDataArray[i][2],
											ImageMetaDataXML.MetaDataArray[i][3],ImageMetaDataXML.MetaDataArray[i][4],ImageMetaDataXML.MetaDataArray[i][5],
											ImageMetaDataXML.MetaDataArray[i][6],ExtImages.ImageDimensions[i][0],ExtImages.ImageDimensions[i][1]);
			ExtClippi.name = ImageMetaDataXML.MetaDataArray[i][1];
			
			if (ExtClippi.Type_=="Classes"){
			ExtClippi.Classes=ImageMetaDataXML.ImageClassesArray[i];
			trace (ImageMetaDataXML.ImageClassesArray[i]);
			trace ("Klassen bei" +i);
			}
			if (ExtClippi.Type_=="channel"){
			ExtClippi.StretchFactor = ImageMetaDataXML.MetaDataArray[i][11];
			}
			if (ExtClippi.Type_=="ValueImage"){
			ExtClippi.LinearFunct=ImageMetaDataXML.MetaDataArray[i][9];
			trace ("Steigung und abschnitt bei: "+ ImageMetaDataXML.MetaDataArray[i][9]);
			ExtClippi.ValueUnit=ImageMetaDataXML.MetaDataArray[i][10];
			ExtClippi.transformDataArray();
			ExtClippi.StretchFactor = ImageMetaDataXML.MetaDataArray[i][11];
			}
			
	ExtClippi.addEventListener(MouseEvent.MOUSE_OVER,clippiover,false, 0, true);
	ExtClippi.addEventListener(MouseEvent.MOUSE_OUT,clippiout,false, 0, true);	
	ExtClippi.addEventListener(MouseEvent.MOUSE_DOWN,extClipDown,false, 0, true); 
	ExtClippi.addEventListener(MouseEvent.MOUSE_UP,extClipUp,false, 0, true);
	
	//addChild(ExtImages.BitmapArray[2]);
 	addChild(ExtClippi);
	ExtClippi.x = ExtImagesPos[ExtClippi.Number_][0];
	ExtClippi.y = ExtImagesPos[ExtClippi.Number_][1];
	ExtClippi.XKoord = ExtImagesPos[ExtClippi.Number_][0];
	ExtClippi.YKoord = ExtImagesPos[ExtClippi.Number_][1];
	
	ExtClippi.scaleX = 1.3;
	ExtClippi.scaleY = 1.3;
	
	//trace ("ADDED: "+ExtClippi.name + "AT "+getChildIndex(ClipContainer.ExtClip(getChildByName(ExtClippi.name))));
	//ClipsForCalc.push(ExtClippi.name);
	trace(AllClips);
 	}
	ExtImages.destroy();
	ExtImages = null;
 }
 
 private function loadTools(e:FISEvents){
 	trace ("TOOLS META DATA LOADED");
	
	
	//trace (Array(ToolsMetaDataXML.MetaDataArray[0][3])[1]);
	//trace (ToolsMetaDataXML.ToolsClasses);

	// Je nachdem welchen Zusatz das DATA_READY Event mitgibt werden die Tools oder Configurationen geladen;
	if (e.data = "TOOLS"){
		for (var i = 0; i < ToolsMetaDataXML.NumberofTools; i++){
			var GlobalPos:Point = this.localToGlobal(new Point(display_mc.x +2,display_mc.y +2)); 
			var theClass:String = ToolsMetaDataXML.ToolsClasses[i];
			var classReference:Class = getDefinitionByName( theClass ) as Class;
			var TempVariables:Array = ToolsMetaDataXML.MetaDataArray[i][3];
			var Tool:* = new classReference(GlobalPos.x,GlobalPos.y,TempVariables,ToolsMetaDataXML.MetaDataArray[i][1]); 
			Tool.name = ToolsMetaDataXML.MetaDataArray[i][1];
			Tool.addEventListener(SatCalcEvent.DATA_SEND,dataRecieve,false,0,true);
			Tool.addEventListener(SatCalcEvent.DATA_DISPLAY,addResultClip);
			ToolsLoaded.push(Tool.name);
			
			trace ("TOOLS LOADED "+ ToolsLoaded);
			
			// Die Position des Tools wird nach dem AnfangsPositionen in ToolPositions bestimmt
			// Lädt sich ein Tool ein addiert es seine Höhe zum y Wert + einen zusatzabstand
			// und fügt diese an das Ende der ToolPositions als Position für das nächste Tool ein
			
			Tool.x = ToolPositions[ToolPositions.length - 1][0];
			Tool.y = ToolPositions[ToolPositions.length - 1][1]  - ToolPositionsYChange;
			addChildAt(Tool,this.numChildren);
			ToolPositions[ToolPositions.length] = [ToolPositions[ToolPositions.length-1][0],(ToolPositions[ToolPositions.length-1][1])+Tool.ToolDims[0][1]+5];
			
			// Wenn das Tool über DropFields verfügt wird die Funktion zum einfüger der Felder aufgerufen
			
			if (Tool.HasDropFields == true){
				addDropFields(Tool.DropFields)
				Tool.addEventListener(SatCalcEvent.DROP_ENABLE,enableDropField);
				Tool.addEventListener(SatCalcEvent.DROP_DISABLE,disableDropField);
			}
			if (Tool.HasGhosts == true){
				Tool.addEventListener(SatCalcEvent.ADD_GHOST,addGhost);
				Tool.addEventListener(SatCalcEvent.REMOVE_GHOST,removeGhost);
				//Tool.addEventListener(SatCalcEvent.DATA_REFUSE,refuseData);
				
			}
			
		}
	}
	if (e.data = "CONFIG"){
		startConfig(ToolsMetaDataXML.ConfigDataArray);
	}
	
 }
 
 private function startConfig(ConfigArray:Array){
	// SOLL DIE MÖGLICHKEIT BESTEHEN BILDER ZU SICHERN
	var screenDrop:Boolean =  ConfigArray[0];
	// SOLL DIE MÖGLICHKEIT BESTEHEN IN BILDERN WERTE AUSZULESEN (ÜBER COLORPIK TOOL);
	var colorPik:Boolean =  ConfigArray[1];
	// SOLL DIE MÖGLICHKEIT FÜR SWIPING  BESTEHEN;
	var Swipe:Boolean =  ConfigArray[2];
	 
	 
 	 if (screenDrop==false){
		 ScreenDropable = false;
		 ImagePool_mc.visible = false;
		 tonneunder_mc.visible = false;
		 ToolPositionsYChange = ImagePool_mc.height;
	 }
	 else if (screenDrop==true){
		 ScreenDropable = true;
	 }

	 
	 if (colorPik==false){
		 pikpix_mc.visible = false;
	 }
	 else if (colorPik==true){
	 	 pikpix_mc.visible = true;
	 }
	 
	  if (Swipe==false){
		 SwipeMode_mc.visible = false;
	 }
	 else if (Swipe==true){
	 	 SwipeMode_mc.visible = true;
	 }
	 
 }
 
 
// Daten werden an alle geladenen Tools gesendet
 
 private function DataToTools(){
	for (var i = 0; i < ToolsLoaded.length; i++){
	trace (ToolsLoaded[i]);
	if (CurrentMetaArray[2] == "ValueImage"){
	getChildByName(ToolsLoaded[i]).dispatchEvent(new SatCalcEvent(SatCalcEvent.DISPLAY_UPDATE,[(getChildByName(CurrentMetaArray[0]).InArray),CurrentMetaArray]));
	}
	else{
	getChildByName(ToolsLoaded[i]).dispatchEvent(new SatCalcEvent(SatCalcEvent.DISPLAY_UPDATE,[OutputImage,CurrentMetaArray]));
	}
	}
 }
 
 private function updateLoadingBar(e:Event){
	 addChild(LoadingBar_);
	 LoadingBar_.updateLoadingBar((e.currentTarget).ImagesLoaded);
	 trace ("geladen: "+ LoadingBar_.Progress+ "von" + LoadingBar_.Elements)
	 if ( LoadingBar_.Elements == LoadingBar_.Progress){
		  removeChild(LoadingBar_);
	 }
 }
 
 private function markClip(){
	if (CurrentlyDisplayed){
	trace ("addingMarker");
	try{removeChild(CurrentMarker);removeChild(RecentMarker)}
	catch(e:Error){trace("No Marker set")};
 	//Marker = new ClipMarker(CurrentlyDisplayed,true,0xEEEE00);
		if (DisplayHistory.length >1){
			CurrentMarker = new ClipMarker(getChildByName(DisplayHistory[0][0]),true,0x00EE00);
			RecentMarker = new ClipMarker(getChildByName(DisplayHistory[1][0]),true,0xEEEE00);
			addChild(CurrentMarker);
			addChild(RecentMarker);
		}
		else {
			CurrentMarker = new ClipMarker(getChildByName(DisplayHistory[0][0]),true,0x00EE00);
			addChild(CurrentMarker);
		}
	}
 }
 
 private function markDropArea(DF:DropField){
	trace ("addingDropMarker");
	removeChild(DropMarker);
 	DropMarker = new ClipMarker(DF,true,0xFFEEAA);
	addChild(DropMarker);
 }
 
 public function Check(){
  trace ("JOOOOHOOOOOOOOOOOOOOOOOOOOOOOOO");
 }
 
 
// Sobald ein Tool Daten sendet werden sie angezeigt. Zusätzlich wird das MetaArray aktualisiert
public function dataRecieve(e:SatCalcEvent){
	trace ("recieved Data from: "+e.currentTarget);
	Show(e.data[0],"Tool",DisplayAt.x,DisplayAt.y);
	trace("METADATA FROM TOOL :" +e.data[1]);
	SaveMetaArray[2] = (e.data[1][0]);
	SaveMetaArray[3] = (e.data[1][1]);
	trace ("SAVEMETA" + SaveMetaArray);
}

// Updated das CurrentMetaData Array entsprechend des momentan angezeigten Clips
private function updateMetaData(inClip:ExtClip){
	CurrentMetaArray[0] = inClip.Name
	CurrentMetaArray[1] = inClip.datum 
	CurrentMetaArray[2] = inClip.Type_;
	CurrentMetaArray[3] = inClip.Resolution;
	CurrentMetaArray[4] = inClip.Unit;
	CurrentMetaArray[5] = inClip.kanal;
	CurrentMetaArray[6] = inClip.LinearFunct;
	CurrentMetaArray[7] = [OutputImage.width,OutputImage.height];
	CurrentMetaArray[8] = inClip.ValueUnit;
	CurrentMetaArray[9] = inClip.ColorScale;
	trace ("DISPLAY CurrentMetaArray "+ CurrentMetaArray[0]);
}

// Updated die Display History für alles außer Ovlerlays
private function updateDisplayHistory(){
	DisplayHistory.unshift([CurrentMetaArray[0],CurrentMetaArray[1],CurrentMetaArray[2]]);
	trace ("DISPLAY HISTORY 1 "+ DisplayHistory[0]);
	trace ("DISPLAY HISTORY 2 "+ DisplayHistory[1]);
}

private function arrangeSaveMeta(){
	SaveMetaArray[0] = null;
	SaveMetaArray[1] = null;
	trace ("DIP HIST "+ DisplayHistory[0][2]);
	trace ("DIP HIST "+ DisplayHistory);
	if (DisplayHistory[0][2] != "Overlay"){
		SaveMetaArray[1]=DisplayHistory[0][0];
	}
	else{
	SaveMetaArray[0]=DisplayHistory[0][0];
	SaveMetaArray[1]=DisplayHistory[1][0];
	}
	trace (SaveMetaArray);
}

private function setToolStatus(e:SatCalcEvent){
	ToolActive = e.data
	trace ("TOOLSTATUS: "  + ToolActive);
}



// Schnittstellenfunktionen zur Kommunikation mit dem aufrufenden SWF

public function commandIncome(...args) {
/*	trace (args[0])
	var checkin:String = args[0].toString();
	switch(checkin){
		case "TOOLOFF":
		
		TOOL_override = true;
		trace (args[0]);
		
		break;
		case "TOOLON":
		trace (args[0]);
		TOOL_override = false;
		break;
	}*/
} 

public function passData(...args) {
//	trace ("PASSED URLS "+args[])
	initalize(args[0][0],args[0][1]);
} 

// Drop Fields werden eingefügt

private function addDropFields(df:Array){
	
	 ToolPositions[ToolPositions.length - 1][0]
	
	for (var i = 0; i < df.length;i++){
		trace ("ADDING DROPFIELD " + df[i]);
		var x_ = (returnGlobalKoords(df[i][0],df[i][2]).x)-GlobalPos.x;
		var y_ = (returnGlobalKoords(df[i][0],df[i][2]).y)-GlobalPos.y;
		trace ("ADDING DROPFIELD AT" +  " " +x_ +" "  +y_);
		var Drop = new DropField(x_,y_,df[i][1],df[i][2]);
		Drop.x  = x_;
		Drop.y  = y_ ;
		Drop.name = df[i][1];
		addChild(Drop);
		DropFieldsArray.push(Drop.name)
		
	}
	trace ("NEW KOORDS "+returnGlobalKoords(df[0][0],df[0][2]));
	trace ("DROPFIELDS TO ADD " + df);
	trace ("DROPFIELDS Array " + DropFieldsArray);
}

// Gibt die Globalen Koordinaten eines Punktes in einem eingefügten Objekt(Tool) zurück
private function returnGlobalKoords(inString:String,inPoint:Point):Point{
 var returnPoint:Point = getChildByName(inString).localToGlobal(inPoint);
 return returnPoint;
}

// Gibt das nächstgelegene Dropfield zum recentButton zurück
private function returnHotDropField():Array{
	var returnArray:Array;
	returnArray =["nada",0];
	var Dist:uint;
	Dist = 1000;
	for (var i = 0;i < DropFieldsArray.length;i++){
	var PointA:Point = new Point(DropField(getChildByName(DropFieldsArray[i])).x,DropField(getChildByName(DropFieldsArray[i])).y);
	var PointB:Point = new Point(recentButton.x,recentButton.y);																										   
	tempDist=Math.sqrt(Math.pow((PointB.x- PointA.x),2)+Math.pow((PointB.y- PointA.y),2));
		if(tempDist<Dist){
		Dist=tempDist;
		returnArray[0] =DropFieldsArray[i];
		returnArray[1] =Dist;
		}	
	}
	trace ("DIST : "+Dist);
	return returnArray;
}


private function setHotDropField(e:MouseEvent){
	 var DropFieldData:Array = returnHotDropField();
	 HotDropField = DropFieldData[0];
	 var dropDist = DropFieldData[1];
	 unAnimate(recentButton);
		 if (dropDist<recentButton.width&&(DropField(getChildByName(HotDropField)).Status==true)){
		 	 markDropArea(DropField(getChildByName(HotDropField)));
		 }
		 if (dropDist>recentButton.width){
			 DropMarker.visible =false;
		 }
	trace (HotDropField);
}

// Deaktiviert Dropfields

private function disableDropField(e:SatCalcEvent){
	DropField(getChildByName(e.data)).Status = false;
}

// Aktiviert Dropfields

private function enableDropField(e:SatCalcEvent){
	DropField(getChildByName(e.data)).Status = true;
}


// Über ein vom Tool ausgelöstes Event wir ein Ghost angelegt
//data Object des Events enhält[Namedes Tools, Bitmap des Ghosts,Name,Koordinaten als Point,Feld welches auch gespert werden muss]

private function addGhost(e:SatCalcEvent){
	trace ("adding Ghost: "+ e.data);
	var addAt:Point = new Point(0,0);
	var scalefactor:Number = (getChildByName(e.data[4]).width-6) / (e.data[1].width);
	trace ("Scaling Ghost: "+ scalefactor + " "+getChildByName(e.data[4]).width+" "+(e.data[1].width));
	addAt = returnGlobalKoords(e.data[0],e.data[3]);
	var Ghost_mc:MovieClip = new MovieClip();
	Ghost_mc.x = addAt.x-GlobalPos.x;
	Ghost_mc.y = addAt.y-GlobalPos.y;
	addChild(Ghost_mc);
	Ghost_mc.addChild(e.data[1]);
	Ghost_mc.name=e.data[2];
	GhostsArray.push(Ghost_mc);
	
	Ghost_mc.scaleX = scalefactor;
	Ghost_mc.scaleY = scalefactor;
	DropField(getChildByName(e.data[4])).Status=false;
}

private function removeGhost(e:SatCalcEvent){
	trace ("removing Ghosts "+ e.data)
	for (var i=0;i<GhostsArray.length;i++){
		if (MovieClip(GhostsArray[i]).name == e.data[0]){
			removeChild(MovieClip(GhostsArray[i]));
			DropField(getChildByName(e.data[1])).Status=true;
			GhostsArray.splice(i,1);
		}
	}
	markClip();
}

/*private function showDataFromTool(e:SatCalcEvent){
	trace ("DISPLAYING DATA: " + e.data[1]+" "+e.data[2]);
	CurrentlyDisplayed = e.data[0];
	//trace ("Auszug aus Array "+CurrentlyDisplayed[300] + " " +CurrentlyDisplayed[30]+ " " +CurrentlyDisplayed[99]);
	Show(e.data[0],"StretchArray",65,12,e.data[1],e.data[2],[1,3.5]);
	
	addResultClip(e.data);
	currentDisplay = "CALCRESULT";
	reposCalcClips();
}*/


// legt einen Clip für die Speicherung des Display Inhalts an
	
	public function SaveImage(e:SatCalcEvent){
		trace("creating DISPLAY_SAVE");
		
		arrangeSaveMeta()
		var ClippiName="Screen_"+Screendrops.toString();
		var DropClip:ExtClip=new ExtClip(Bitmap(e.data),0,ClippiName,SaveMetaArray[1],"SCREEN",1,SaveMetaArray[1],SaveMetaArray,Bitmap(e.data).width,Bitmap(e.data).height);
		DropClip.name = ClippiName; 
		
		var PosinBildname:int=setClipName();
		
		DropClip.addEventListener(MouseEvent.MOUSE_OVER,clippiover,false, 0, true);
		DropClip.addEventListener(MouseEvent.MOUSE_OUT,clippiout,false, 0, true);	
		DropClip.addEventListener(MouseEvent.MOUSE_DOWN,extClipDown,false, 0, true); 
		DropClip.addEventListener(MouseEvent.MOUSE_UP,extClipUp,false, 0, true);
		
		DropClip.Deleteable = true;
		
		DropClip.XKoord = Bildnamen[PosinBildname][2];
		DropClip.YKoord = Bildnamen[PosinBildname][3];
		
		DropClip.scaleX = 1.3;
		DropClip.scaleY = 1.3;
		
		DropClip.x = DropClip.XKoord;
		DropClip.y = DropClip.YKoord;
		Screendrops = Screendrops+1;
		addChild(DropClip);

	}

// Erstellt ein neues ExtClip Object für die Speicherung von Ergebnissbildern

private function addResultClip(e:SatCalcEvent){
	trace ("ResultClip wird angefügt");
	// Wenn statt Daten einfach false ankommt soll nur die CalcClips zur+ückgesetzt werden
	if (e.data[0] == false){reposCalcClips()}
	
	else{
		var PosinBildname:int = setClipName();
		trace ("NAME DES NEUEN BILDES: "+Bildnamen[PosinBildname][0]);
		
		//									Bildaten Nummer Name Datum type res unit channel width height
		if (e.data[0] instanceof Array){
		var ExtClippi:ExtClip=new ExtClip(e.data[0],0,Bildnamen[PosinBildname][0].toString(),e.data[7],"channel",e.data[5],e.data[6],e.data[4],e.data[1],e.data[2]);
		recentDataArray=e.data[0];
		}
		
		if (e.data[0] instanceof Bitmap){
		var ExtClippi:ExtClip=new ExtClip(e.data[0],0,Bildnamen[PosinBildname][0].toString(),e.data[7],"RGB",e.data[5],e.data[6],e.data[4],e.data[1],e.data[2]);
		//recentDataArray=e.data[0];
		}
		
		ExtClippi.addEventListener(MouseEvent.MOUSE_OVER,clippiover,false, 0, true);
		ExtClippi.addEventListener(MouseEvent.MOUSE_OUT,clippiout,false, 0, true);	
		ExtClippi.addEventListener(MouseEvent.MOUSE_DOWN,extClipDown,false, 0, true); 
		ExtClippi.addEventListener(MouseEvent.MOUSE_UP,extClipUp,false, 0, true);
		ExtClippi.name = Bildnamen[PosinBildname][0];
		
		ExtClippi.Deleteable = true;
		
		ExtClippi.XKoord = Bildnamen[PosinBildname][2];
		ExtClippi.YKoord = Bildnamen[PosinBildname][3];
		
		ExtClippi.x = ExtClippi.XKoord;
		ExtClippi.y = ExtClippi.YKoord;
		
		ExtClippi.addText(e.data[3]);
		
		addChild(ExtClippi);
		
		if (e.data[0] instanceof Array){
		Show(e.data[0],"StretchArray",display_mc.x +2,display_mc.y +2,e.data[1],e.data[2],[1,3.5]);
		recentDataArray=e.data[0];
		}
		if (e.data[0] instanceof Bitmap){
		Show(e.data[0],"Bitmap",display_mc.x +2,display_mc.y +2,e.data[1],e.data[2],[1,1]);
		//recentDataArray=e.data[0];
		}
		
		CurrentlyDisplayed = ExtClippi;
		currentDisplay = "ExtClip"
		updateMetaData(ExtClippi);
		updateDisplayHistory();
		DataToTools();
		SuccessfullDrop = true;
		reposCalcClips();
		unAnimate(ExtClippi);
		markClip();
	}
	
}


private function setClipName():int{
		
		var i:int = 0;
		while( i<Bildnamen.length){
			if (Bildnamen[i][1] == true){
			Bildnamen[i][1] = false;
			break;
			}
		i++
		}
		return i;
	}

// fügt das "Speichern" Symbol ein oder aktiviert swiping

private function addIcon(e:MouseEvent){
	trace("ASSSSIII");
		if (ToolActive == false && ScreenDropable == true && SwipeMode == false){
			//ZUR REAKTIVIERUNG DES DROPSCREEN WIEDER ENTKOMMENTIEREN!
			//addChild(ScreenDrop_mc);
			//ScreenDrop_mc.visible = true;
			//ScreenDrop_mc.x=xPos+OutputImage.width-ScreenDrop_mc.width;
			//ScreenDrop_mc.y=yPos;
		}
		
		if (SwipeMode == true){
			trace ("Swiping")
		}
		
	signalMouseOver();
}

private function removeIcon(e:MouseEvent){
			trace("ASSSSIII");
			ScreenDrop_mc.visible = false;
			signalMouseOut();
			if (SwipeMode == true){
			restoreAfterSwipe();
		}
}


 private function signalMouseOver(){
	for (var i = 0; i < ToolsLoaded.length; i++){
	trace (ToolsLoaded[i]);
	getChildByName(ToolsLoaded[i]).dispatchEvent(new SatCalcEvent(SatCalcEvent.DISPLAY_MOUSEOVER));
	}
 }

  private function signalMouseOut(){
	for (var i = 0; i < ToolsLoaded.length; i++){
	trace (ToolsLoaded[i]);
	getChildByName(ToolsLoaded[i]).dispatchEvent(new SatCalcEvent(SatCalcEvent.DISPLAY_MOUSEOUT));
	}
 	
 }
 
 
 //  prüft ob ein Tool Dropfields einlädt 
 
  private function checkForDropfields():Boolean{
 	var returnBool:Boolean = false
	for (var i=0;i<ToolsLoaded.length;i++){
		trace ("Checking for Dropfields = :" + ToolsLoaded[i]);
		if (getChildByName(ToolsLoaded[i]).HasDropFields == true){
			returnBool = true;
		}
	}
	
	trace ("Dropfield Check = :" + returnBool)
	return returnBool;
 }
 
 // prüft ob ein bestimmtes Tool geladen wurde
 private function checkForTool(tool:String):Boolean{
 	var returnBool:Boolean = false
	
	trace ( "checking for "+tool +" in "+ToolsLoaded)
	
	for (var i=0;i<ToolsLoaded.length;i++){
		if (ToolsLoaded[i] == tool){
			returnBool = true;
		}
	}

	return returnBool;
 }
 
 private function signalToolEnabled(e:SatCalcEvent){
	if (pikpix_mc.currentFrame == 2){
	pikpix_mc.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));
	}
	if (SwipeMode_mc.currentFrame == 2){
	SwipeMode_mc.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));
	}
 	for (var i = 0; i < ToolsLoaded.length; i++){
	trace (ToolsLoaded[i]);
	getChildByName(ToolsLoaded[i]).dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_ENABLED,e.data));
	}
 
 
 }
 
 // Functionen zur aktiviering der übergeordeneten Tools
 
 private function picPix(e:Event){
		
		if (pikpix_mc.currentFrame==1 && currentDisplay == "NOIMAGE"){
		 
		 trace ("No Image");
		
		}
		
		else if (pikpix_mc.currentFrame==1 && currentDisplay != "NOIMAGE" ){
			pikpix_mc.gotoAndPlay(2);
			deactSwipe();
			stage.addEventListener(MouseEvent.MOUSE_MOVE, PixelValue)
			Mouse.hide();
			colorpik_mc.visible=true;
			addChild(colorpik_mc);
			colorpik_mc.x=mouseX;
			colorpik_mc.y=mouseY;
			stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_STATUS,true));
			for (var i = 0; i < ToolsLoaded.length; i++){
				getChildByName(ToolsLoaded[i]).dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_ENABLED,"picPix"));
			}
		}
		else if(pikpix_mc.currentFrame==2){
			deactPicPix();
		}
	}
 
 
 private function SwipeModeSwitch(e:MouseEvent){
 	if ( currentDisplay == "NOIMAGE"){
		 
		 trace ("No Image");
		
	}
	
		else if (currentDisplay != "NOIMAGE" ){
			switch (SwipeMode_mc.currentFrame){
			 case 1:
			 activateSwipe();
			 deactPicPix();
			 DisplayContainer.addEventListener(MouseEvent.MOUSE_MOVE,swipe);
			  SwipeMode_mc.gotoAndStop(2);
			  SwipeMode = true;
			 
			SwipeIcon_mc.x=mouseX;
			SwipeIcon_mc.y=mouseY;
			  stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_STATUS,true));
			  for (var i = 0; i < ToolsLoaded.length; i++){
						getChildByName(ToolsLoaded[i]).dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_ENABLED,"Swipe"));
					}
			 break;
			 case 2:
				deactSwipe();
			 break;
		
			}
 	
 		}
 }
 
 private function deactPicPix(){
	 Infotext_mc.Pixwert.text="";
	 pikpix_mc.gotoAndStop(1);
	 stage.removeEventListener(MouseEvent.MOUSE_MOVE, PixelValue);
	 Mouse.show();
	 colorpik_mc.visible=false;
	 stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_STATUS,false));
 }
 
 private function deactSwipe(){
	 DisplayContainer.removeEventListener(MouseEvent.MOUSE_MOVE,swipe);
	 SwipeMode_mc.gotoAndStop(1);
	 SwipeMode = false;
	 Mouse.show();
	 stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_STATUS,false));
 }
 
 private function reposCalcClips(){
	 for (var i= 0;i<ClipsForCalc.length;i++){
		trace(ClipsForCalc);
	 	clipRepos( ClipsForCalc[i][0].name   );
		DropField(getChildByName(ClipsForCalc[i][1])).Status=true;
	 }
 }
 

 
// gibt die Position zurück an welche das Tool gesetzt wird.Das ist immer die letzet Stelle im ToolPositions Array
// private function getToolPos

} //Class close
   

}// Package close