﻿package  com.tools{
import flash.display.Sprite;
import flash.display.*;
import flash.geom.*;
import flash.text.*;
import flash.events.*;
import FISEvents;
import flash.ui.Mouse;
import flash.utils.*;
import flash.net.*;
import com.utilities.*;

//import JPGEncoder;
	
	public class RGBKlass_tool extends Display{
	
	public var RGB_mc:MovieClip; 
	
	public var StageZero:Point;
	
	private var Image_BMP:Bitmap;	// Das anzuzeigende und zu klassifizierende Bild AutoImage stellt nur das Bitmap bereit
										// angezeigt und klassifiziert wird über RGBSelector
	private var Rect:Rectangle; 		// Rectangle für Sliderbegrenzung
	private var X_extend:int;
	private var Y_extend:int;
	private var R:int;					// Variablen für RGB und Toleranz werden an RGBSelector.selectValue übergeben
	private var G:int;
	private var B:int;
	private var T:int;
	private var Rp:int;					// Variablen für RGB und Toleranz werden an RGBSelector.selectValue übergeben
	private var Gp:int;
	private var Bp:int;
	private var Tp:int;
	private var orgBild:RGBSelector; 	// Die Klasse in welcher die RGB Selection stattfindet
	private var ClassPosArray:Array; 	// 2D Array in welchem die x,y positionen der Klassenfelder vorgegeben sind
	private var ClassArray:Array; 		// 2D in dem die y,p positionen der momentan gewählten Pixel gespeichert sind
	private var ClassNames:Array;		// enthält Namen für die erstellten ClassFields; 
	private var NumberOfClasses:int 	// wie vile Klassen gibt es;
	private var ClassFields:Array; 		// Nimmt die Klassenfelder auf, um sie geschlossen anteuern zu können (z.B.sichtbar/unsichtbar))
	private var ClassVisibility:Boolean; // Sind die Klassenlayer sichtbar?
	private var Mask_BD:BitmapData;		// Bitmap Data objekt enthält die Mask mit schon klassifizierten Pixeln
	private var Mask_B:Bitmap;
	private var Delay:Timer;
	private var Resolution:int;			// Auflösung des verwendeten Bildes in Unit
	private var Unit:String;			// Einheit der Auflösung des Bildes
	private var MetaDataRequest:URLRequest;	// Request zum Laden externer Variablen
	private var MetaDataLoader:URLLoader;	// Loader zum Laden externer Variablen
	private var MetaData:URLVariables;		// enthält die externern Variablen
	private var Scale:Scalebar;				// Ein Maßstabsbalken
	public var OutAt_X:int;					// an welche Stage Koordinaten werden die Overlays ausgegeben
	public var OutAt_Y:int;
	private var AddField:AddField_mc;		// Feld zum Hinzufügen einer neuen Klasse




	// Variablen für RGB und Toleranz werden an RGBSelector.selectValue übergeben
	
		public function RGBKlass_tool(outX:int,outY:int){
		
		OutAt_X=outX;
		OutAt_Y=outY;
		
		// RGB_Mmc wird aus dem SatCalculator importiert
		
		RGB_mc= new RGB_Klass
		addChild(RGB_mc);
		trace ("RGBMC addet AT "+getChildIndex(RGB_mc)); 
		
		
		/*Der Delay sorgt dafür, dass die dir RGB Selektion mit einer kleinen Verzögerung
		ausgeführt wird. So läuft die Selektion flüssiger da der RGBSelector nicht mit 
		Aktuallisierungen überfrachet wird*/
		
		Delay = new Timer(100);
		
		// Klassensichtbarkeit
		
		ClassVisibility=true;
		
		// Kassenarray
		
		ClassFields = new Array();
		
		// Klassenanzahl
		NumberOfClasses=0;
		
		// Aufruf des Bildes welches klassifiziert werden soll
		
		//Image_BMP = new AutoImage("Images/RGBImage.png");
		//Image_BMP.addEventListener(FISEvents.IMAGE_INIT,initClassImage);
		
		// Variablen für RGB und Toleranz werden an RGBSelector.selectValue übergeben
		
		R = 0;
		G = 0;
		B = 0;
		T = 0;
		
		// ClassArray;
		ClassArray = new Array();
		
		// ClassPosArray
		// Positionen der Klassen Objekte am rechten Rand
		
		ClassPosArray = new Array();
		ClassPosArray[0] = [5,10];
		ClassPosArray[1] = [5,45];
		ClassPosArray[2] = [5,80];
		ClassPosArray[3] = [5,115];
		ClassPosArray[4] = [5,150];
		ClassPosArray[5] = [5,185];
		ClassPosArray[6] = [5,220];
		ClassPosArray[7] = [5,255];
		
		// ClassNames Array
		
		ClassNames = new Array();
		ClassNames = ["Class1","Class2","Class3","Class4","Class5","Class6","Class7"];
		
		// Anzeigen der Regler auf AUS

		RGB_mc.Regler_R.Griff_R.RWERT.text ="aus";
		RGB_mc.Regler_G.Griff_G.GWERT.text ="aus";
		RGB_mc.Regler_B.Griff_B.BWERT.text ="aus";
		
		Rect = new Rectangle(0, 0, 0, 255);
		
		// Button zum Hinzufügen eines neuen Klassenfeldes
		
		AddField = new AddField_mc();
		addChild(AddField);
		
		AddField.buttonMode =true;
		AddField.addEventListener(MouseEvent.MOUSE_DOWN, addClassField);
		AddField.addEventListener(MouseEvent.MOUSE_OVER,overAndOut)
		AddField.addEventListener(MouseEvent.MOUSE_OUT,overAndOut)
		

		// Event Listener für Regler Toleranz
		RGB_mc.Regler_T.Griff_T.addEventListener(MouseEvent.MOUSE_DOWN, Slide_T);
		RGB_mc.Regler_T.Griff_T.addEventListener(MouseEvent.MOUSE_UP,StopSlide);
		RGB_mc.Regler_T.Griff_T.addEventListener(MouseEvent.MOUSE_OUT,StopSlide);
		
		// Event Listener für Regler ROT
		RGB_mc.Regler_R.Griff_R.addEventListener(MouseEvent.MOUSE_DOWN, Slide_R);
		RGB_mc.Regler_R.Griff_R.addEventListener(MouseEvent.MOUSE_UP,StopSlide);
		RGB_mc.Regler_R.Griff_R.addEventListener(MouseEvent.MOUSE_OUT,StopSlide);
		
		
		// Event Listener für Regler GRÜN
		RGB_mc.Regler_G.Griff_G.addEventListener(MouseEvent.MOUSE_DOWN, Slide_G)
		RGB_mc.Regler_G.Griff_G.addEventListener(MouseEvent.MOUSE_UP,StopSlide)
		RGB_mc.Regler_G.Griff_G.addEventListener(MouseEvent.MOUSE_OUT,StopSlide)
	
		
		// Event Listener für Regler BLAU
		RGB_mc.Regler_B.Griff_B.addEventListener(MouseEvent.MOUSE_DOWN, SlideB)
		RGB_mc.Regler_B.Griff_B.addEventListener(MouseEvent.MOUSE_UP,StopSlide)
		RGB_mc.Regler_B.Griff_B.addEventListener(MouseEvent.MOUSE_OUT,StopSlide)

		
		// Event Listener für blauen Kanal des Vorher Bildes
		this.addEventListener(FISEvents.DATA_TRANS,initClassImage)
		setInitState();
		 
		}// Constructor close
		
		
		private function setInitState(){
			RGB_mc.Regler_T.Griff_T.y = 50;
			T = 50;
			RGB_mc.Regler_T.Griff_T.TWERT.text =(Math.round(T/2.55)+"%").toString();
			
		}
	
		private function Update(e:MouseEvent){
			
			R=RGB_mc.Regler_R.Griff_R.y;
			G=RGB_mc.Regler_G.Griff_G.y;
			B=RGB_mc.Regler_B.Griff_B.y;
			T=RGB_mc.Regler_T.Griff_T.y;
			
			trace ("R: "+R+"G: "+G+"B: "+B+"T: "+T);
			
			RGB_mc.Regler_R.Griff_R.RWERT.text =(Math.round(R/2.55)+"%").toString();
			RGB_mc.Regler_G.Griff_G.GWERT.text =(Math.round(G/2.55)+"%").toString();
			RGB_mc.Regler_B.Griff_B.BWERT.text =(Math.round(B/2.55)+"%").toString();
			RGB_mc.Regler_T.Griff_T.TWERT.text =(Math.round(T/2.55)+"%").toString();
			
			
			
			Delay.start(); 
			Delay.addEventListener(TimerEvent.TIMER, delayMark);
					
			ClassArray = orgBild.PosArray;
			
			var Pixelzahl:int=orgBild.Pixamount;
			RGB_mc.QuadMeter_txt.text = Math.round((Pixelzahl*70)).toString();
			
		}
		
		private function delayMark(e:TimerEvent){
			orgBild.clearMarkBmp();
			orgBild.MarkColor =0xFF9964BD;
			orgBild.selectValue(R,G,B,T);
			orgBild.Showmarked();
			
			Delay.stop();
			Delay.removeEventListener(TimerEvent.TIMER, delayMark);
		}
			
			
// Regler für Toleranz

		private function Slide_T (e:Event){
			//Regler_R.Griff_R.addEventListener(MouseEvent.MOUSE_MOVE,updatePercent)
			RGB_mc.Regler_T.Griff_T.addEventListener(MouseEvent.MOUSE_MOVE,Update)
			RGB_mc.Regler_T.Griff_T.startDrag (false, Rect); 
		}
		
// Regler für roten Kanal 

		private function Slide_R (e:Event){
			
			//Regler_R.Griff_R.addEventListener(MouseEvent.MOUSE_MOVE,updatePercent)
			RGB_mc.Regler_R.Griff_R.addEventListener(MouseEvent.MOUSE_MOVE,Update)
			RGB_mc.Regler_R.Griff_R.startDrag (false, Rect); 
			
		}
		
// Regler für grünen Kanal 

		private function Slide_G (e:Event){
			
			//Regler_G.Griff_G.addEventListener(MouseEvent.MOUSE_MOVE,updatePercent)
			RGB_mc.Regler_G.Griff_G.addEventListener(MouseEvent.MOUSE_MOVE,Update)
			RGB_mc.Regler_G.Griff_G.startDrag (false, Rect);
			
	 	}
//Regler für blauen Kanal

		private function SlideB (e:Event){
			
			//Regler_B.Griff_B.addEventListener(MouseEvent.MOUSE_MOVE,updatePercent);
			RGB_mc.Regler_B.Griff_B.addEventListener(MouseEvent.MOUSE_MOVE,Update);
			RGB_mc.Regler_B.Griff_B.startDrag (false, Rect);
			
		}
		



// Funktion zum Anhalten des Sliders

		private function StopSlide (e:Event) {
			
			e.currentTarget.removeEventListener(MouseEvent.MOUSE_MOVE,Update);
			
			switch (e.type){
				
			case "mouseOut":
				Mouse.show();
				
				this.stopDrag();
				//Update();
				break;
			
			case "mouseUp":
			
			 this.stopDrag();
			
			// Update();
			 
			 break;
			
			default:
			trace ("nothin")}
		}
		
		
		
		private function overAndOut(e:Event){
				if (e.currentTarget.currentFrame==2){
				e.currentTarget.gotoAndStop(1);
				}
				else{
					e.currentTarget.gotoAndStop(2);
				}
			}
		
		// wird initiert wenn der SatCalculator  Das entsprechende Event abgibt
		
		public function initClassImage(e:FISEvents){
			trace ("RGBCLASS initiert")
			trace (e.data);
			Image_BMP = e.data;
			orgBild = new RGBSelector(Image_BMP,false);
			
			trace ("ORG BILD BREIT: " +Image_BMP.width)
			X_extend = Image_BMP.width;
			Y_extend = Image_BMP.height;
			StageZero = this.globalToLocal(new Point(OutAt_X,OutAt_Y)); 
			orgBild.x =StageZero.x;
			orgBild.y =StageZero.y;
			AddField.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN)); 
			addChild(orgBild);
		}
		
	/*	public function initClassImage(inBitm:Bitmap){
			Image_BMP = inBitm;
			orgBild = new RGBSelector(Image_BMP,false);
			addChild(orgBild);
			trace ("ORG BILD BREIT: " +Image_BMP.width)
			X_extend = Image_BMP.width;
			Y_extend = Image_BMP.height;
			StageZero = this.globalToLocal(new Point(OutAt_X,OutAt_Y)); 
			orgBild.x =StageZero.x;
			orgBild.y =StageZero.y;
			AddField.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN)); 
		}*/
		
			
		// aktuallisiert die Protzentangaben auf den Reglern wenn diese bewegt werden
		
			private function updatePercent(e:Event){
				trace("updating Regler");
				/*R=Regler_R.Griff_R.y;
				G=Regler_G.Griff_G.y;
				B=Regler_B.Griff_B.y;
				T=41;*/
				
				RGB_mc.Regler_R.Griff_R.RWERT.text =(Math.round(R/2.55)+"%").toString();
				RGB_mc.Regler_G.Griff_G.GWERT.text =(Math.round(G/2.55)+"%").toString();
				RGB_mc.Regler_B.Griff_B.BWERT.text =(Math.round(B/2.55)+"%").toString();
			}
			
			// Erstellt ein neues Feld in welchem eine Klasse gespeichert werden kann
			private function addClassField(e:MouseEvent){
				
					var Class_x:ClassField = new ClassField(new Array(),orgBild.W,orgBild.H,OutAt_X,OutAt_Y);
					addChildAt(AddField,getChildIndex(RGB_mc));
					//addChild(Class_x);
					trace ("Class_x BREIT: " +Class_x.height + " " + +Class_x.width)
					//addChildAt(RGB_mc,getChildIndex(Class_x)+1);
					Class_x.addEventListener(FISEvents.IMAGE_INIT, updateClass);
					Class_x.addEventListener(MouseEvent.MOUSE_OVER, displayClassInfo);
					Class_x.x = ClassPosArray[NumberOfClasses][0];
					Class_x.y = ClassPosArray[NumberOfClasses][1];
					Class_x.name = ClassNames[NumberOfClasses];
					
					if (NumberOfClasses<6){
						AddField.x=ClassPosArray[NumberOfClasses+1][0];
						AddField.y=ClassPosArray[NumberOfClasses+1][1];
					}
					else{
						removeChild(AddField);
					}
					NumberOfClasses = NumberOfClasses+1;
					trace ("Number of Classes " + NumberOfClasses);
					ClassFields.push(Class_x);
					
			}
			
			
			private function updateClass(e:FISEvents){
				
				// Garantiert, der neue Klassenlayer immer an die 0/0 Position des RGB_Klassifikators gesetzt wird
				// auch wenn dieser auf einer anderen Stage aufgerufen wird
				
				var StageZero:Point = new Point(0,0);
				StageZero = this.localToGlobal(StageZero);
				ClassField(getChildByName(e.currentTarget.name)).OutAt_X = OutAt_X;
				ClassField(getChildByName(e.currentTarget.name)).OutAt_Y = OutAt_Y;
				
				ClassArray = orgBild.updatePosArray();
				trace ( "gedrückt wurde :" +e.currentTarget.name);
				ClassField(getChildByName(e.currentTarget.name)).PosArray = ClassArray;
				
				ClassField(getChildByName(e.currentTarget.name)).markClass();
				ClassField(getChildByName(e.currentTarget.name)).showMarkedClass();
				
				ClassField(getChildByName(e.currentTarget.name)).R = R;
				ClassField(getChildByName(e.currentTarget.name)).G = G;
				ClassField(getChildByName(e.currentTarget.name)).B = B;
				ClassField(getChildByName(e.currentTarget.name)).T = T;
				
				createMask();
				orgBild.Masking = true;
				orgBild.Mask_BD = Mask_BD;
			}
			
			/*Schaltet die Sichtbarkeit des KlassenLayer ein und aus */
			
			private function switchClassVisibility(e:MouseEvent){
			trace("switch visible");
				switch (ClassVisibility){
					case false:
						for (var i=0; i<NumberOfClasses;i++){
							trace (ClassFields[i].name+" sichtbar");
							ClassField(getChildByName(ClassFields[i].name)).switchVisibility (true);
					}
					ClassVisibility = true;
					break;
					case true:
						for (var i=0; i<NumberOfClasses;i++){
							trace (ClassFields[i].name+" unsichtbar");
							ClassField(getChildByName(ClassFields[i].name)).switchVisibility (false);
						}
					ClassVisibility = false;
					break;
					
				}
				 
			}
			
			/*Holt sich aus den angelegten Klassen die Pixelpositionen und schreibt sie
			in eine Maske. Diese wird verwendet um schon klassifizierte Pixel auszumaskieren*/
			
			private function createMask(){
				Mask_BD = new BitmapData(X_extend,Y_extend,false,0x000000);
				for (var i=0; i<NumberOfClasses;i++){
					var PixelsForMask:Array = new Array();
					PixelsForMask=ClassField(getChildByName(ClassFields[i].name)).PosArray;
						for(var d=0; d<PixelsForMask.length;d++){
							Mask_BD.setPixel(PixelsForMask[d][0],PixelsForMask[d][1],0xFFFFFF);
						}
				}
				Mask_B = new Bitmap(Mask_BD);
				Mask_B.scaleX =0.2;
				Mask_B.scaleY =0.2;
				Mask_B.x =210;
				Mask_B.y =435;
				//addChild(Mask_B);
				
				
			}
			
			private function removeMask(e:MouseEvent){
			removeChild(Mask_B);
			
			}
			
			/*Bei einem MouseOver werden die Randdaten der entsprchenden Klasse im Display angezeit*/
			
			private function displayClassInfo(e:MouseEvent){
				var getPixnumber = ClassField(getChildByName(e.currentTarget.name)).PosArray.length;
				var getR = ClassField(getChildByName(e.currentTarget.name)).R;
				var getG = ClassField(getChildByName(e.currentTarget.name)).G;
				var getB = ClassField(getChildByName(e.currentTarget.name)).B;
				var getT = ClassField(getChildByName(e.currentTarget.name)).T;
				var getName = ClassField(getChildByName(e.currentTarget.name)).ClassName;
				RGB_mc.QuadMeter_txt.text = Math.round((getPixnumber*70)).toString();
				RGB_mc.R_txt.text=getR.toString();
				RGB_mc.G_txt.text=getG.toString();
				RGB_mc.B_txt.text=getB.toString();
				RGB_mc.T_txt.text=getT.toString();
				RGB_mc.Name_txt.text=getName;
			}
			
			
			/*Lädt alle Klassenpixel aus den ClassFields in einen Movieclip 
			und übergibt diesen an SaveMap, wo er als JPG gespeichert wird*/
			
			private function saveClasses(e:MouseEvent){
				var CombineClip_mc:MovieClip = new MovieClip();
				var LegendData:Array = new Array();
				var LegendDataRow:Array = new Array();
				
				/*Sammelt die Metadaten für die Legende aus allen Angezeigten Klassen*/
				
				for(var i=0;i<ClassFields.length;i++){
					LegendDataRow = [ClassField(getChildByName(ClassFields[i].name)).ClassName,ClassField(getChildByName(ClassFields[i].name)).ClassColor];
					LegendData[i] = LegendDataRow;
				}
				trace (LegendData[0]);
				trace (LegendData[1]);
				var saveBitmap_BD:BitmapData= new BitmapData(X_extend,Y_extend);
				var saveBitmap_B:Bitmap;
				
				/*Sammelt die BitmapDaten  aus allen Angezeigten Klassen
				und packt sie in einen MovieClip*/
				
				for(var i=0;i<ClassFields.length;i++){
					saveBitmap_BD = ClassField(getChildByName(ClassFields[i].name)).ClassMark_BD;
					saveBitmap_B = new Bitmap(saveBitmap_BD);
					CombineClip_mc.addChild(saveBitmap_B);
				}
				
				/*Fügt den Maßstabsbalken in den Clip ein*/
				
				//CombineClip_mc.addChild(Scale);
				trace ("Breite der Karte: "+ CombineClip_mc.width);
				trace ("Breite der Scalebar: "+ Scale.width);
				var Save_Map:SaveMap =new SaveMap(CombineClip_mc,LegendData,90);
				/*addChild(CombineClip_mc);
				CombineClip_mc.x = 500;*/
			}
				
	
	} //Class close
} //Package close