﻿/*#############################################################
# 				ClipMarker									 ##
#														     ##
# Markiert die momentan angezeigten Clips				  .  ##
#															 ##
#														     ##
#(c) 2008, Henryk Hodam ##
#############################################################*/


package com.utilities {
	
	import SatCalculator;
	import Display;
	import ImageCalc;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.text.*;
	import flash.filters.BitmapFilterQuality;
	import flash.filters.GlowFilter;
	
	public class ClipMarker extends Sprite {
		
	
	private var Vis:Boolean;
	public var XKoord:int;
	public var YKoord:int;
	public var XScale:Number;
	public var YScale:Number;
	public var Xext:Number;
	public var Yext:Number;
	private var CanvasMarker:Shape; 		// Container für Graphen Zeichnung
	private var Color:Number
	
	public function ClipMarker(InData:Object,vis:Boolean=true,col:Number = 0xff0000){
		Vis = vis;
		XKoord = InData.x;
		YKoord = InData.y;
		XScale = InData.scaleX;
		Color = col;
		YScale = InData.scaleY;
		trace ("IN OBJECT for CLIP Marker: "+ XKoord +" " +YKoord +" " + XScale +" "+ YScale+" WIDTH "+InData.width );
		//trace ("IN OBJECT: "+ getBounds(DisplayObject(InData)));
		Xext = InData.width;
		Yext = InData.height; 
		CanvasMarker = new Shape();
		drawMarker();
		highlightMarker();
	}
	
	private function drawMarker(){

		CanvasMarker.graphics.lineStyle(2,Color);
		CanvasMarker.graphics.moveTo(XKoord,YKoord);
		CanvasMarker.graphics.drawRect(XKoord,YKoord,Xext,Yext);
		if (Vis==true){
			addChild(CanvasMarker);
		}
		
	}
	
	private function highlightMarker(){
		var glow:GlowFilter = new GlowFilter();
		glow.color = Color;
		glow.alpha = 1;
		glow.blurX = 5;
		glow.blurY = 10;
		glow.quality = BitmapFilterQuality.MEDIUM;

		CanvasMarker.filters = [glow];
		
	}

	
	
		
	
		
	}	//Class close
}	// Package close