﻿/*#############################################################
#					 Display     							 ##
#    														 ##
#Dient der Ausgabe von Bitmaps, Arrays und ByteArrays   	 ##
#															 ##
#   														 ##
#(c) 2009, Henryk Hodam										 ##
#############################################################*/

package {
	
	import com.events.*;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.text.*;
	import flash.ui.Mouse;

	public class SatCalcDisplay extends MovieClip {
		
		
		// VARIABLEN FÜR DIE INDEXSTEUERUNG DER ANGEZEIGTEN BILDER
		// Wird ein Bild angezeigt nimmt es sich den durch AllocateLayer_1 reservierten Platz im DisplayContainer.
		// getLayerIndices() gibt den Indexplatz den jedes Bild belegen soll, entsprechend der Variablen AddAt zurück
		// Soll auf die beiden schon vorhanden Bilder ein Drittes gelegt werden, tauschen (in  getLayerIndices()) beide Bilder ihre Indices und das ober wird gelöscht.
		// an seine Stelle tritt das neue Bild. Es werden so immer nur 2 Bilder angezeigt, welche immer übereinander liegen
		// Das Jüngste immer oben das ältere darunter.
		
		
	 public var SwipeIcon_mc:MovieClip;	// Das ICon für den Swipe
	   public var ScreenDrop_mc:MovieClip;	// Das ICon für den Screendrop
	   public var DisplayContainer:MovieClip; // Alle geladenen und erzeugten Clips kommen hier rein
	   public var FirstDispLayer:int;
	   public var SecondDispLayer:int;
	   public var ToolDisplayLayer:int;
	   public var SaveDisplayLayer:int; 
	   public var OverlayDisplayLayer:int; 
	   public var ScreenDropable:Boolean; 		// Kann der Screen gesichert werden?
	   private var Delay:Timer; 				// für Bildsichern
	   private var CollectClip:MovieClip;
	  
	   var AllocateLayer_1:Sprite;				// Clips werden eingefügt um Display Ebenen vorzureservieren damit diese späterBildern zugewiesen werden können
	   var AllocateLayer_2:Sprite;
	   var AllocateLayer_3:Sprite;
	   var AllocateLayer_4:Sprite;
	   var AllocateLayer_5:Sprite;
		
	// Variablen für swipe funktion
		public var FrontImageCopy_BD:BitmapData;
		public var FrontImageCopy:Bitmap;
		private var AlphaMask:BitmapData;
		private var NoAlphaMask:BitmapData;
		private var alphaRectangle:Rectangle; // Definiert den bereich an dem das vordere Bild transparent ist.
		private var NoAlphaRectangle:Rectangle; // Definiert den bereich an dem das vordere Bild nicht transparent ist.
		
	private var AddAt:int;					// And dieser Stelle im Display Container wird ein Bild angefügt;
		
		private var Version:String;
		public var OutputImage:Bitmap;
		var Region:Rectangle;
		//var OutputImageBD:BitmapData;
		
		public var DisplayedType:String;
		
		var w:int;
		var h:int;
		public var xPos:int;
		public var yPos:int;
		
	  // Ist eine Funktion aktiv?? Ballspielwiese Werte Lesen oder Pipette...
	
	    public var ToolActive:Boolean;
		// Ist der Swipe Mode an oder aus
		public var SwipeMode:Boolean;
		
		
		public function SatCalcDisplay(...args) {
			if(args.length>0){
			w=args[0];
			h=args[1];
			}
			else{
			w=500;
			h=500;
			}
			
			Version = "Display Version: 22.09.2011";
			
			SwipeMode = false;
			
			ScreenDrop_mc = new DropScreen;
			ScreenDrop_mc.scaleX = 0.6;
			ScreenDrop_mc.scaleY = 0.6;
			addChildAt(ScreenDrop_mc,numChildren);
			ScreenDrop_mc.visible =false;
			ScreenDrop_mc.buttonMode =true;
			
			ScreenDropable = true;
			
			SwipeIcon_mc = new SwipeIcon;
			SwipeIcon_mc.scaleX = 0.4;
			SwipeIcon_mc.scaleY = 0.4;
			SwipeIcon_mc
			
			DisplayContainer = new MovieClip();
			
	
			AllocateLayer_1 = new Sprite();
			AllocateLayer_2 = new Sprite();
			AllocateLayer_3 = new Sprite();
			AllocateLayer_4 = new Sprite();
			AllocateLayer_5 = new Sprite();
					
			DisplayContainer.addChild(AllocateLayer_1); // Da kommt das erste Bild hin
			DisplayContainer.addChild(AllocateLayer_2);// Da kommt das zweite Bild hin
			DisplayContainer.addChild(AllocateLayer_3);// Da kommen Anzeigen der Tools hin
			DisplayContainer.addChild(AllocateLayer_4);// Da kommen Overlays hin
			DisplayContainer.addChild(AllocateLayer_5);// Da kommen Overlays hin
		
			FirstDispLayer= DisplayContainer.getChildIndex(AllocateLayer_1);
			SecondDispLayer	= DisplayContainer.getChildIndex(AllocateLayer_2); 
			ToolDisplayLayer = DisplayContainer.getChildIndex(AllocateLayer_3);
			SaveDisplayLayer = DisplayContainer.getChildIndex(AllocateLayer_4);
			OverlayDisplayLayer = DisplayContainer.getChildIndex(AllocateLayer_5);
			trace (FirstDispLayer);
			trace (SecondDispLayer);
			trace (ToolDisplayLayer);
			trace (OverlayDisplayLayer);
			
			
			AddAt = FirstDispLayer;
			
			ScreenDrop_mc.visible = false;			// SreenDrop_Icon
			
			//this.addEventListener(MouseEvent.MOUSE_DOWN, initSaveDelay, false, 0, true);
			//this.addEventListener(MouseEvent.MOUSE_UP, stopSave, false, 0, true);
			
			ScreenDrop_mc.addEventListener(MouseEvent.MOUSE_OVER, ScreenDropAni);
			ScreenDrop_mc.addEventListener(MouseEvent.MOUSE_DOWN, ScreenDrop);
			ScreenDrop_mc.addEventListener(MouseEvent.MOUSE_OUT, ScreenDropAniStop);
			
			
		}
		
		public function Show(...args) {
			trace ("Display Version: " + Version)
			xPos=args[2];
			yPos=args[3];
			if (args[4] && args[5]){
			w=args[4];
			h=args[5];
			}
			//var datatype:String = ;
			//trace (args[1]);
			switch (args[1]) {
				case "Overlay" :
					trace("displaying Overlay");
					
					DisplayContainer.addChildAt(args[0],DisplayContainer.numChildren);
					args[0].name = "OVER"
					args[0].x=xPos;
					args[0].y=yPos;
					break;
				case "Bitmap" :
					trace("displaying Bitmap");
					try {
            			DisplayContainer.removeChild(DisplayContainer.getChildByName("OVER"));
					}
					catch(e:Error){};
					DisplayContainer.addChildAt(args[0],getLayerIndices());
					OutputImage=args[0];
					args[0].name = "Bitmap";
					args[0].x=xPos;
					args[0].y=yPos;
					break;
				case "Array" :
					    
					showArray(args[0]);
					break;
				case "ByteArray" :
					showByteArray(args[0]);
					break;
				case "StretchArray" :
					trace("StretchArray");
					stretchArray(args[0],args[6][0],args[6][1]);
					//stretchArray(args[0],500,500);
					break;
				case "Tool" :
					trace("Tool");
					DisplayContainer.addChildAt(args[0],ToolDisplayLayer);
					args[0].x=xPos;
					args[0].y=yPos;
					
					break;
				default :
					//trace(args[0]);
					throw new Error(" No valid argument for method: Show(). Vaild arguments (String): Bitmap, Array, StretchArray, ByteArray ");
			}
			// wenn swipe aktiv ist muss es neu gestartet werden
			
			if (SwipeMode==true){
			activateSwipe();
			}
		}
		
		private function showByteArray(BArray:ByteArray) {
			DisplayContainer.removeChildAt(SecondDispLayer);
			DisplayContainer.removeChildAt(FirstDispLayer);
			trace("displaying ByteArray to Bitmap");
			Region= new Rectangle(0,0,w,h);
			var OutputImageBD:BitmapData=new BitmapData(w,h);
			BArray.position=0;
			OutputImageBD.setPixels(Region,BArray);
			var OutputImage:Bitmap=new Bitmap(OutputImageBD);
			addChildAt(OutputImage,getLayerIndices());
			OutputImage.x=xPos;
			OutputImage.y=yPos;
		}
		
		private function showArrayByte(IntArray:ByteArray) {
			
			var OutputImageBD:BitmapData=new BitmapData(w,h);
			trace("displaying Array to Bitmap");
			trace(IntArray.length);
			var bytecount:int = 0;// variable zur festlegung der aktuellen Stelle im Bytarray
			Region= new Rectangle(0,0,h,w);
			var genByteArray:ByteArray = new ByteArray();
			genByteArray.length=IntArray.length*4;
			OutputImageBD=new BitmapData(w,h);
			for (var b=0; b <=  IntArray.length; b++) {
				if ( b>0) {
					bytecount = bytecount +4;
				}
				genByteArray[bytecount]=255;
				genByteArray[bytecount+1]=IntArray[b];
				genByteArray[bytecount+2]=IntArray[b];
				genByteArray[bytecount+3]=IntArray[b];
			}
			trace( "ByteArray size:"+ genByteArray.length);
			trace( genByteArray[4]);
			trace( IntArray[500]);
			OutputImageBD.setPixels(Region,genByteArray);
			//trace (genByteArray);
			var OutputImage:Bitmap=new Bitmap(OutputImageBD);
			DisplayContainer.addChildAt(OutputImage,getLayerIndices());
			trace ("Child Added At :" + getChildIndex(OutputImage));
			OutputImage.x=xPos;
			OutputImage.y=yPos;

		}
		
		private function showArray(IntArray:Array) {
			try {
            DisplayContainer.removeChild(DisplayContainer.getChildByName("OVER"));
			}
			catch(e:Error){};
			trace("displaying Array to Bitmap");
			trace(IntArray.length);
			var bytecount:int = 0;// variable zur festlegung der aktuellen Stelle im Bytearray
			Region= new Rectangle(0,0,w,h);
			var genByteArray:ByteArray = new ByteArray();
			genByteArray.length=IntArray.length*4;
			var OutputImageBD:BitmapData=new BitmapData(w,h);
			
			trace("Hoch:"+h);
			trace("Breit:"+w);
			for (var b=0; b <=  IntArray.length; b++) {
				if ( b>0) {
					bytecount = bytecount +4;
				}
				genByteArray[bytecount]=255;
				genByteArray[bytecount+1]=IntArray[b];
				genByteArray[bytecount+2]=IntArray[b];
				genByteArray[bytecount+3]=IntArray[b];
			}
			//trace( "ByteArray size:"+ genByteArray.length);
			//trace( genByteArray[4]);
			//trace( IntArray[500]);
			OutputImageBD.setPixels(Region,genByteArray);
			//trace (genByteArray);
			OutputImage = new Bitmap(OutputImageBD);
			
			//var OutputImage:Bitmap=new Bitmap(OutputImageBD);
			
			OutputImage.x=xPos;
			OutputImage.y=yPos;
			DisplayContainer.addChildAt(OutputImage,getLayerIndices());
			trace ("CONTAINER: "+DisplayContainer.width)
			trace ("Child Added At :" + DisplayContainer.getChildIndex(OutputImage));
			
		}
		
		
		private function stretchArray(ArraytoStretch:Array,minFact:Number = 1,maxFact:Number = 3.5) {
			// die Werte fürs Stretching werden im eingehenden Array berrechnet und dann in WorkArray geschrieben und angezeigt
			var WorkArray:Array=new Array(ArraytoStretch.length);
			trace("Afterpassing:"+ArraytoStretch[45]);
			trace("Length Afterpassing: "+ArraytoStretch.length);


			var f: int=0;
			var h: int=0;
			var i: int=0;
			var Steig:Number;
			var yachs:Number;
			var sum:Number=0;
			var sum2:Number;
			var sumSTABW:Number = 0;
			var STABW:Number = 0;
			var toAdd:Number = 0;
			var mw:Number = 0;
			var max:Number;
			var min:Number;
			var setValue:int; //Im Stretching verwendeter Zwischenwert

			max=ArraytoStretch[0];
			min=ArraytoStretch[0];
			
			trace ("Testsumme: "+ (sum+ArraytoStretch[h]));
			
			for (h;h<ArraytoStretch.length;h++){
			sum2  =  ArraytoStretch[h];
			sum = sum +sum2;
						}
			
			trace ("Summe: "+sum);
			trace (typeof(sum));
			
			mw = sum / ArraytoStretch.length;
			
				
			trace ("Mittelwert:"+mw);
			
		  for (h=0; h<ArraytoStretch.length; ++h) {
				if (ArraytoStretch[h]>=0){
				toAdd=ArraytoStretch[h]-mw;
					if (toAdd<0){
						toAdd=toAdd*-1;
					}
				
				}
				else if(ArraytoStretch[h]<0){
				toAdd=((ArraytoStretch[h])*-1)-mw;
					if (toAdd<0){
						toAdd=toAdd*-1;
					}
				}
				sumSTABW=sumSTABW+toAdd;
			}
			
			trace ("SummeStabw: "+sumSTABW);
			
			STABW = sumSTABW/ArraytoStretch.length;
			
			trace ("StandardAbsweichung: "+STABW);
			
	
			
			min = mw-(minFact*STABW)
			max = mw+(maxFact*STABW)
			trace ("min: "+min+"max: "+max);
			

			//trace("Steig:"+Steig);
			
			
			/*for (h=0; h<WorkArray.length; ++h) {
				if (WorkArray[h]>max) {
					max = WorkArray[h];
				}
			}
			//trace("MAx:"+max);
			for (f=0; f<WorkArray.length; ++f) {
				if (WorkArray[f]<min) {
					min = WorkArray[f];
				}
			}
			
			trace ("min: "+min+"max: "+max);*/
			
			
			Steig = (255-0) / (max - min);
			yachs = 0-Steig*min;
			
			for (i=0; i<ArraytoStretch.length; ++i) {
				setValue=ArraytoStretch[i]*Steig+yachs;
				if (setValue>255){
					WorkArray[i]=255}
				else if (setValue<0){
					WorkArray[i]=0}
				else {WorkArray[i]=setValue}
				//WorkArray[i]=WorkArray[i]*Steig+yachs;
			}
			showArray(WorkArray);
			sum = 0;
			sumSTABW = 0;
			STABW = 0;
			toAdd = 0;
			mw = 0;
		}
			//trace("reinArray:"+ArraytoStretch[50]);
			
			/*private function traceDisp(){
				trace ("Output Image bei: "+ DisplayContainer.getChildIndex(OutputImage));
				trace ("FirstLayer bei: "+ FirstDispLayer);
				trace ("SecondLayer bei: "+ SecondDispLayer);
			}*/
			
		 // wenn alle layer vergeben sind wird DisplayContainer hinzugefügt
		 
		public function addDisplay(){
			addChild(DisplayContainer);
			trace ("DisplayContainer At :" + getChildIndex(DisplayContainer));
		}
		
		// Gibt den Index an an welchen ein Bild im Display Layer hinzugefügt werden soll
		// werden mehr als 2 Bilder angezeigt werden die Indexstellen für die Bilder(0,1) im Display Container
		// vorher geleert ( Das ist natürlich nach dem die ersten 2 Bilder angezeigt wurden sowieso immer der Fall!!)
		
		private function getLayerIndices():int{
			var returnIndex:int
			switch (AddAt) {
				case 0:
				returnIndex = 0; 
				AddAt=1;
				
				break;
				case 1:
				returnIndex =  1;
				AddAt=2;
				
				break;
				case 2:
				DisplayContainer.swapChildrenAt(1,0);
    			DisplayContainer.removeChildAt(1);
				
				trace ("Child 0 :" +typeof(DisplayContainer.getChildAt(1)));
				trace ("Child 1 :" +typeof(DisplayContainer.getChildAt(1)));
				trace ("Child 2 :" +typeof(DisplayContainer.getChildAt(2)));
				trace ("Child 3 :" +typeof(DisplayContainer.getChildAt(3)));
				deleteAlocates(); 
				
				returnIndex =  1; 
				AddAt = 2;
				
				break;
			}
			return returnIndex;
		}
		
		
		// Für ein Timergesteuertes sichern der Anzeige (wird rausgenommen);
		
		private function stopSave(e:MouseEvent){
			try {trace ("Save interrupted at :" + Delay.currentCount);
			Delay.reset();
			ScreenDrop_mc.gotoAndStop(1);
			this.removeEventListener(MouseEvent.MOUSE_MOVE, stopSave)}
			catch(e:Error){trace(e)};
		}
		
		private function startSave(e:TimerEvent){
			trace ("starting SaveProcedure");
			CollectClip = new MovieClip();
			var getSprite = new Sprite();
			var Rect = new Rectangle(0,0,w,h);
			trace (w+" "+h)
			var SaveBitmap:Bitmap = new Bitmap(new BitmapData(OutputImage.width,OutputImage.height));
			SaveBitmap.bitmapData.draw(OutputImage);
			getSprite = DisplayContainer.getChildAt(2);
			SaveBitmap.bitmapData.draw(getSprite);
			getSprite = DisplayContainer.getChildAt(3);
			SaveBitmap.bitmapData.draw(getSprite);
			getSprite = DisplayContainer.getChildAt(4);
			SaveBitmap.bitmapData.draw(getSprite);
			getSprite = DisplayContainer.getChildAt(DisplayContainer.numChildren-1);
			SaveBitmap.bitmapData.draw(getSprite);
			
			dispatchEvent(new SatCalcEvent(SatCalcEvent.INIT_SAVEIMAGE,SaveBitmap));
			ScreenDrop_mc.gotoAndStop(1);
			//addChild(SaveBitmap);
		}
		
		private function initSaveDelay(e:MouseEvent){
			if (mouseX<560 && mouseY>60){
				this.addEventListener(MouseEvent.MOUSE_MOVE, stopSave, false, 0, true);
				Delay = new Timer(1,200);
				Delay.start();
				Delay.addEventListener(TimerEvent.TIMER_COMPLETE,startSave,false,0,true);
				Delay.addEventListener(TimerEvent.TIMER,animateScreenDrop,false,0,true);
			}
		}
		
		private function animateScreenDrop(e:TimerEvent){
			ScreenDrop_mc.gotoAndPlay(Math.round(ScreenDrop_mc.totalFrames/Delay.repeatCount*Delay.currentCount));
		}
		
		// Die Layer werden wieder gelöscht damit die Ebenen nur Bitmaps enthalten.
		private function deleteAlocates(){
			AllocateLayer_1 = null;
			AllocateLayer_2 = null;
			AllocateLayer_3 = null;
		}
		
		
		
		
		
		private function ScreenDropAni(e:MouseEvent){
			ScreenDrop_mc.visible = true;
			ScreenDrop_mc.gotoAndPlay(2);
			
		}
		
		private function ScreenDropAniStop(e:MouseEvent){
			ScreenDrop_mc.visible = true;
			ScreenDrop_mc.gotoAndStop(1);
			
		}
		
		
		
		// Wenn der ScreenDrop nicht über den Timer Ausgelöst wird sondern über den Button
		private function ScreenDrop(e:MouseEvent){
			trace ("starting SaveProcedure");
			CollectClip = new MovieClip();
			var getSprite = new Sprite();
			var Rect = new Rectangle(0,0,w,h);
			trace (w+" "+h)
			var SaveBitmap:Bitmap = new Bitmap(new BitmapData(OutputImage.width,OutputImage.height));
			SaveBitmap.bitmapData.draw(OutputImage);
			getSprite = DisplayContainer.getChildAt(2);
			SaveBitmap.bitmapData.draw(getSprite);
			getSprite = DisplayContainer.getChildAt(3);
			SaveBitmap.bitmapData.draw(getSprite);
			getSprite = DisplayContainer.getChildAt(4);
			SaveBitmap.bitmapData.draw(getSprite);
			getSprite = DisplayContainer.getChildAt(DisplayContainer.numChildren-1);
			SaveBitmap.bitmapData.draw(getSprite);
			dispatchEvent(new SatCalcEvent(SatCalcEvent.INIT_SAVEIMAGE,SaveBitmap));
			ScreenDrop_mc.gotoAndStop(1);
		}
		
							  
		
		// Swipe wird activiert
		
			public function activateSwipe(){
				
				
				FrontImageCopy_BD =  new BitmapData(w,h);
				FrontImageCopy_BD.copyPixels(OutputImage.bitmapData,new Rectangle(0,0,w,h),new Point(0,0));
				FrontImageCopy = new Bitmap(FrontImageCopy_BD);
				NoAlphaMask = new BitmapData(w,h,true,0xffffffff);
				AlphaMask = new BitmapData(w,h,true,0x00ffffff);
			}
		
		// Swipe wird ausgeführt
		
		public function swipe(e:MouseEvent){
			trace ("swiping");
			var xmouse:int = mouseX - xPos; // da mouseX direkt keine ganzen Zahlen zurückgibt würde es sonst im Vollbildmodus Probleme geben
			
			 addChild(SwipeIcon_mc);
			 SwipeIcon_mc.mouseEnabled = false;
			 SwipeIcon_mc.visible = true;
			 Mouse.hide();
			
			SwipeIcon_mc.x=mouseX;
			SwipeIcon_mc.y=mouseY;
			
			// SwiperBut_mc.x=mouseX-SwiperBut_mc.width/2;
			// SwiperBut_mc.y=mouseY;
			NoAlphaRectangle = new Rectangle (xmouse,0,w,h);
			alphaRectangle = new Rectangle (0,0,xmouse,h);
			OutputImage.bitmapData.copyChannel(AlphaMask,alphaRectangle,new Point(0,0),BitmapDataChannel.ALPHA,BitmapDataChannel.ALPHA);
			OutputImage.bitmapData.copyPixels(FrontImageCopy.bitmapData,NoAlphaRectangle,new Point(xmouse,0));
		}
		
		// Bild wird nach swipe wiederhergestellt 
		 public function restoreAfterSwipe(){
			SwipeIcon_mc.visible=false;
	 		Mouse.show();
			var FullRectangle = new Rectangle (0,0,w,h);
		 	OutputImage.bitmapData.copyPixels(FrontImageCopy.bitmapData,FullRectangle,new Point(0,0));
			
		 }
	
		
	}//Class close
}// Package close