﻿// Soll Fehlermeldungen oder Text ausgeben

package com.utilities {
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.text.*;
	
	
	public class ExtWindow extends Sprite{
		
		public var Group:Sprite// Container für Alles
		var ButtonSTOP:Shape// StopButton
		var ButtonSTOP_mc:MovieClip
		
		var Relocate_mc:MovieClip
		
		public var Xsize:int // Textgrösse
		public var Ysize:int // Textgrösse
		public var Xpos:int // XPosition
		public var Ypos:int // YPosition
		public var TextColor:uint // Textfarbe
		public var BackColor:uint // HintergrundFarbe
		public var FrameColor:uint // RahmenFarbe
		public var RelocColor:uint // Farbe des RelocationButtons
		public var BackAlpha:Number // AlphaWert des Hintergrundes
		public var Reloclpha:Number // AlphaWert des Reloc buttons
		public var FrameStrengh:int // RahmenDicke
		
		public var TitleText:String // Der Text
		public var TextArray:Array;
		private var Title:TextField//Textfeld
		public var StopMode:Boolean// Ist der StopMode true hält die Textausgabe an
		public var RestrictionPoint_1:Point // Obere linke Ecke des Begrenzungsfeldes in welchem das Fenster bewegt werden soll
		public var RestrictionPoint_2:Point // Untere linke Ecke des Begrenzungsfeldes in welchem das Fenster bewegt werden soll
		public var WindowContainer:MovieClip; // hier kommt rein was angezeigt werden soll
		public var Version:String;
		
		// [0] = Text [1] = Xpos [2] = Ypos [3] = Xsize [4] = Ysize [5] = Farbe
		public function ExtWindow(tX:String="",xP:int=0,yP:int=0,xS:int=100,yS:int=100){	
			
			Version = "20111124"
			trace ("ExtWindow V: "+Version);
			Title = new TextField();
			
			
			
			TextArray = new Array();
			Group=new Sprite();
			addChild(Group);
			StopMode=false;
			ButtonSTOP_mc = new MovieClip();
			ButtonSTOP= new Shape();
			
			BackAlpha = 0.5
			RelocAlpha = 0.5
			
			TitleText = tX;
			Xpos = xP;
			Ypos = yP;
			Xsize = xS;
			Ysize = yS;
			TextColor =  0x000000;
			BackColor =  0x000000;
			FrameColor = 0xffffff;
			RelocColor = 0xff0000;
			FrameStrengh = 1;
			
			this.addEventListener(Event.ADDED_TO_STAGE,setRestriction);
			
			
			//initBox();
			//initText();
		}
				//Hintergrund
			public function initWindow(){
				
				var Background:Shape = new Shape();
				Background.graphics.beginFill(BackColor,BackAlpha);
				Background.graphics.lineStyle(FrameStrengh,FrameColor);
				Background.graphics.drawRect(0,0,Xsize,Ysize);
				Group.addChild(Background);
				Relocate_mc = new MovieClip();
				var Relocate:Shape = new Shape();
				Relocate.graphics.lineStyle(FrameStrengh,FrameColor);
				Relocate.graphics.beginFill(RelocColor,RelocAlpha);
				Relocate.graphics.drawRect(0,0,Xsize,Ysize/8);
				Relocate_mc.buttonMode=true;
				Group.addChild(Relocate_mc);
				Relocate_mc.addChild(Relocate);
				Relocate_mc.addEventListener(MouseEvent.MOUSE_DOWN, dragWindow);
				Relocate_mc.addEventListener(MouseEvent.MOUSE_UP, dropWindow);
				
			
				Group.x=Xpos;
				Group.y=Ypos;
				
			}
			
			// legt die Buttons zum Scrollen an
			private function initButtons(){
				
				
				var ButtonDown_mc:MovieClip = new MovieClip();
				var ButtonDown:Shape = new Shape();
				ButtonDown.graphics.beginFill(0x000000,0.5);
				ButtonDown.graphics.lineStyle(1,FrameColor);
				ButtonDown.graphics.drawRect(0,0,Xsize*0.1,Ysize*0.5);
				ButtonDown.graphics.moveTo((Xsize*0.1)/2,Ysize*0.5);
				ButtonDown.graphics.lineTo(0,0);
				ButtonDown.graphics.moveTo((Xsize*0.1)/2,Ysize*0.5);
				ButtonDown.graphics.lineTo(Xsize*0.1,0);
				Group.addChild(ButtonDown_mc);
				ButtonDown_mc.addChild(ButtonDown);
				ButtonDown_mc.x=Xsize;
				ButtonDown_mc.y=Ysize*0.5;
				ButtonDown_mc.buttonMode=true;
				ButtonDown_mc.addEventListener(MouseEvent.MOUSE_DOWN, function(){TextF.scrollV++;});
				
				ButtonSTOP.graphics.beginFill(0xFF0000,0.5);
				ButtonSTOP.graphics.drawRect(0,0,-10,Ysize);
				Group.addChild(ButtonSTOP_mc);
				ButtonSTOP_mc.buttonMode=true;
				ButtonSTOP_mc.addChild(ButtonSTOP);
				ButtonSTOP_mc.addEventListener(MouseEvent.MOUSE_DOWN, changeStopMode);
				
			
			}
			
			public function initText(){
				TextF.textColor= TextColor;
				TextF.text = Text;
				Group.addChild(TextF); 
				TextF.height=Ysize;
				TextF.width=Xsize;
			}
			
			
			public function addText(i:String){
				if (StopMode==true){
				}
				else if (StopMode==false){
				TextArray.push("\n"+TextArray.length.toString()+": "+(i));
				//TextF.scrollV++;
				TextF.text = TextArray.toString();
				TextF.scrollV++;
				}
				
			}
			
			private function changeStopMode(e:Event){
				switch (StopMode){
					case true:
					StopMode=false
					
					ButtonSTOP.graphics.beginFill(0x000000,0.5);
					ButtonSTOP_mc.addChild(ButtonSTOP);
					break;
					case false:
					ButtonSTOP.graphics.endFill();
					ButtonSTOP.graphics.beginFill(0xFF0000,0.5);
					StopMode = true;
					break;
				}
			}
			
			public function initTitle(){
				
				Title.width= Xsize;
			    Title.height = Xsize/10;
				
				var myFont:Font = new Arial_type();
				var format:TextFormat = new TextFormat();
				format.font = myFont.fontName  ;
				format.color = TextColor;
				format.size = Ysize/11;
				
				format.align = "center";
				//format.bold = true;
				Title.text = TitleText;
				Title.setTextFormat(format);
				Title.embedFonts=true;
				Title.selectable=false;
				
				
				Title.x = 0 
				Title.y = 0 
				
				Title.mouseEnabled  = false;
				
				Group.addChild(Title); 
				
			}
			
			
			
			private function setRestriction (e:Event){
			 	RestrictionPoint_1 =  globalToLocal(new Point(0,0));
				RestrictionPoint_2 =  globalToLocal(new Point(stage.stageWidth,stage.stageHeight));
			
				//trace ("RESTRICION " + RestrictionPoint_1 +" "+ RestrictionPoint_2);
				trace ("RESTRICION " + RestrictionPoint_1,RestrictionPoint_2);
			}
			
			public function resetRestriction (x1:int,y1:int,x2:int,y2:int){
			 	RestrictionPoint_1 =  globalToLocal(new Point(x1,y1));
				RestrictionPoint_2 =  globalToLocal(new Point(x2,y2));
			
				//trace ("RESTRICION " + RestrictionPoint_1 +" "+ RestrictionPoint_2);
				trace ("RESTRICION " + RestrictionPoint_1,RestrictionPoint_2);
			}
			
			
			
			private function dragWindow(e:Event){
				Group.startDrag(); 
				Group.addEventListener(MouseEvent.MOUSE_MOVE,checkRestriction);
				Group.addEventListener(MouseEvent.MOUSE_OUT,dropWindow);
			}
			
			private function dropWindow(e:Event){
				Group.stopDrag(); 
				Group.removeEventListener(MouseEvent.MOUSE_MOVE,checkRestriction);
				Group.removeEventListener(MouseEvent.MOUSE_OUT,dropWindow);
			}
			
			
			
			private function checkRestriction(e:Event){
			trace ("Checking Restriction");
			if(Group.x >=(RestrictionPoint_2.x-Xsize)){
				Group.x = RestrictionPoint_2.x-Xsize;
				
			}
				else if (Group.x <=RestrictionPoint_1.x){
				 Group.x = RestrictionPoint_1.x;
				
				}
			
			
			 if(Group.y >=(RestrictionPoint_2.y-Ysize)){
				Group.y = RestrictionPoint_2.y-Ysize;
				
			}
				else if (Group.y <=RestrictionPoint_1.y){
				 Group.y = RestrictionPoint_1.y;
				
				
				}
			}
			
			public function addContainer(CName:String,cont:DisplayObject,xpos,ypos){
				var Container:MovieClip = new MovieClip();
				Container.x = xpos;
				Container.y = ypos;
				
				Container.name = CName;
				Group.addChild(Container)
				Container.addChild(cont);
				Container.height = Xsize;
				Container.width = Ysize;
				trace ("Size of Container: " +Container.height+" " +Container.width);
				/*var TestRect:Shape = new Shape();
				TestRect.graphics.lineStyle(1,0xff0000);
				TestRect.graphics.drawRect(Container.x,Container.y,cont.height,cont.width);
				Container.addChild(TestRect);
				Container.mouseEnabled = false;*/
			}
			
			public function refreshContainer(CName:String,cont:DisplayObject){
				var tempX = Group.getChildByName(CName).x;
				var tempY = Group.getChildByName(CName).y;
				
				Group.removeChild(MovieClip(Group.getChildByName(CName)));
				var Container:MovieClip = new MovieClip();
				Container.x = tempX;
				Container.y = tempY;
				
				Container.name = CName;
				Group.addChild(Container)
				Container.addChild(cont);
				/*var TestRect:Shape = new Shape();
				TestRect.graphics.lineStyle(1,0xff0000);
				TestRect.graphics.drawRect(tempX,tempY,cont.height,cont.width);
				Container.addChild(TestRect);
				Container.mouseEnabled = false;*/
				
			}
			
			
			
				

		
	}// Class close
}// Package close