﻿// lädt ein Bild aus einer URL und zeigt es an

package com.utility{
	
	import flash.events.*;
	import flash.display.*;
	import flash.net.URLRequest;
	import com.events.FISEvents;	

	
	public class AutoImage extends Sprite {
		
		public var InBitmapData:BitmapData;
		public var Image:Bitmap;
		var BitLoader:Loader; // Loader für das Bild
		var url:String; // Die übergebene URL
		var URLReq:URLRequest; 
		public var Width:int; // Höhe des geladenen Bildes
		public var Height:int;// Breite des geladenen Bildes
		private var ShowImage:Boolean; // soll das Bild angzeigt werden?
		private var Version:String;
		private var Transaparency:Boolean;
		private var Bitmapfill;
		public var Description:String;
		
		public function AutoImage(urlin:String,showImage:Boolean = true,transp:Boolean = true) {
			Version = "AutoImage V: 0.1 14.03.2011";
			ShowImage = showImage;
			Transaparency = transp;
			if (transp==true){
				Bitmapfill == 0x00FFFFFF;
			}
				else{
					Bitmapfill == 0xFFFFFF
				}
			
			trace (Version);
			url=urlin;
			trace(typeof(url));
			BitLoader = new Loader();
			BitLoader.contentLoaderInfo.addEventListener( Event.COMPLETE, onLoaderComplete );
			loadImage();
		}
		
			public function loadImage(){
				trace ("loadingImage");
				URLReq=new URLRequest(url) 
				BitLoader.load(URLReq);	
				trace ("LADE BILD VON: " +url);
			}
			
			private function showImage(){
				InBitmapData.draw(BitLoader);
				Image=new Bitmap(InBitmapData);
					if (ShowImage == true){
					addChild(Image);
					}
				dispatchEvent(new FISEvents(FISEvents.IMAGE_INIT));
			}
			
			private function onLoaderComplete(e:Event){
				trace ("Loader complete");
				Width=BitLoader.content.width;
				Height=BitLoader.content.height;
				InBitmapData=new BitmapData(Width,Height,Transaparency,0x00FFFFFF);
				showImage();
				
			}
			
			public function getBitmapData(){
				return InBitmapData;
			}
			
			
		
	}//Class close
}// Package close
		