﻿

package  com.tools {
	
import com.events.SatCalcEvent;
import flash.display.Sprite;
import flash.display.*;
import flash.geom.*;
import flash.text.*;
import flash.events.*;
import FISEvents;
import com.utilities.*;
import flash.ui.Mouse;
import flash.utils.*;
import flash.net.*;


	public class VectorToolsLineMod extends SatCalcDisplay {
	
	public var OutAt_X:int;					// an welche Stage Koordinaten werden die Overlays ausgegeben
	public var OutAt_Y:int;
	public var StageZero:Point;
	private var Distance2Point:PointLine;
	private var LinesSave:Array;			// nimmt die angelegten Lineien auf [line1[linieData],linie2[linieData...]
	public var VectTool_mc:MovieClip; 
	public var HasDropFields:Boolean;
	public var HasGhosts:Boolean;
	public var DropFields:Array;
	public var IRZaehl_koord:Point;
	public var IRNenn_koord:Point;
	public var RZaehl_koord:Point;
	public var RNenn_koord:Point;
	public var ToolDims:Array;				// Die Abmessungen der Tools. Wird im SatCalculator benötigt um die Positionierung vorzunehmen
	public var Ident:String;				// Gleicht dem Namen des Objektes im Satcalculator
	
	public var MetaOfCurrentData:Array;	 	// Metadaten Array des momentan angezeigten Bildes(welches das Tool bearbeitet)
	
	private var ColorArray:Array;		// Gibt verschiedene Farben on welchen die Linien erscheinen sollen
	
	private var DataWidth_:int;
	private var DataHeight_:int;
	
	private var LinesCreated:int // Wie viele Linien wurden angelegt
	public var Resolution:Number;	// Auflösung des Bildes 
	public var Unit:String;			// Einheit der Distanz
	public var ThisLabel:String;	// Name des Bildes

	
		public function VectorToolsLineMod(outX:int,outY:int,varArr:Array,ID:String){
			
			Ident = ID;
			
			// Die Positionen der Dropflächen im Lokalen Objekt
			
			IRZaehl_koord = new Point(6,4);
			RZaehl_koord = new Point(70,4);
			IRNenn_koord = new Point(6,53);
			RNenn_koord = new Point(70,53);
			
			trace ("LOCALLLLLLLLLLLLLLLLLLLLRUNDE " +localToGlobal(IRZaehl_koord))
			
			// Das Array in dem alle relevanten Daten zu den DropFields gespeichert sind
			
			DropFields = new Array();

			HasDropFields = false;
			HasGhosts	= false;
			trace ("VectorTools INVOKED");
			
			ColorArray = new Array(0xE73A3A,0xA2E33E,0xCF8BA,0x5173FB,0x63E9E8);
			
			
			OutAt_X=outX;
			OutAt_Y=outY;
			
			StageZero = this.globalToLocal(new Point(OutAt_X,OutAt_Y)); 
			
			VectTool_mc = new VectorTool;
			addChild(VectTool_mc);
			ToolDims = new Array();
			ToolDims[0] =[VectTool_mc.width,VectTool_mc.height];
			
			
			this.addEventListener(SatCalcEvent.DISPLAY_UPDATE,setCurrentValues);
			this.addEventListener(SatCalcEvent.TOOL_ENABLED,disableTool);
			VectTool_mc.Line_mc.gotoAndStop(1)
			VectTool_mc.DeleteLines_mc.gotoAndStop(1)
			
			VectTool_mc.Line_mc.addEventListener(MouseEvent.MOUSE_DOWN,switchLineTool,false,0,true);
			VectTool_mc.DeleteLines_mc.addEventListener(MouseEvent.MOUSE_DOWN,deleteLines,false,0,true);
			VectTool_mc.DeleteLines_mc.addEventListener(MouseEvent.MOUSE_OVER,function(){VectTool_mc.DeleteLines_mc.gotoAndStop(2)},false,0,true);
			VectTool_mc.DeleteLines_mc.addEventListener(MouseEvent.MOUSE_OUT,function(){VectTool_mc.DeleteLines_mc.gotoAndStop(1)},false,0,true);
			
			VectTool_mc.Line_mc.buttonMode=true;
			VectTool_mc.DeleteLines_mc.buttonMode=true;
			
			LinesSave = new Array();
			
			LinesCreated = 0;
			
			this.addEventListener(SatCalcEvent.DISPLAY_UPDATE,metaDataUpdate)
			
						
			
		}// Constructor close
		
		private function StartLine(){
			
			LinesCreated++;
			trace("Starting LineTool");
			StageZero = this.globalToLocal(new Point(OutAt_X,OutAt_Y)); 
			Distance2Point = new PointLine(DataWidth_,DataHeight_);
			Distance2Point.name =LinesCreated.toString();
			trace("Name of LineTool " +Distance2Point.name);
			Distance2Point.SelectionMode = false;
			Distance2Point.x = StageZero.x;
			Distance2Point.y = StageZero.y;
			addChild(Distance2Point);
			Distance2Point.Resolution = Resolution;
			Distance2Point.Unit = Unit;
			Distance2Point.LineLabel = ThisLabel;
			Distance2Point.PointColor_outer = ColorArray[LinesCreated];
			stage.doubleClickEnabled = true;
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN,NewTwoPoint,false,0,true);
			stage.addEventListener(MouseEvent.DOUBLE_CLICK, terminateTwoPoint);
		}
		
			
		private function setCurrentValues(e:SatCalcEvent){
			MetaOfCurrentData =  e.data[1];
			trace ("METADATA IN VECTOR TOOLS" + typeof(MetaOfCurrentData[0]));
			DataWidth_=Bitmap(e.data[0]).width;
			DataHeight_=Bitmap(e.data[0]).height;
			
			trace ("DataWidth_ / height" + DataWidth_ +" "+DataHeight_);
		}
		
		
		/*zwischen den Zuständen der Schalter im Vektor Tool wird gewchelt., Davon hängt ab,
		ob eine Linie etc überhaupt aglegt werden kann*/
		
		private function switchLineTool(e:MouseEvent){
			switch(VectTool_mc.Line_mc.currentFrame){
				case 1:
				VectTool_mc.Line_mc.gotoAndStop(2)
				try{
				StartLine();
				//Pipette_mc.mouseEnabled=false;
				//stage.addEventListener(MouseEvent.MOUSE_DOWN,getColorValues,false,0,true);
				stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_STATUS,true));
				this.addEventListener(SatCalcEvent.DISPLAY_MOUSEOVER,showToolSymbol)
			    this.addEventListener(SatCalcEvent.DISPLAY_MOUSEOUT,hideToolSymbol)
				stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_ENABLED,"VectorTool"));
				
				}
				catch(e:Error){
					trace("Tool nicht initialisiert")};
					
				break;
				case 2:
				VectTool_mc.Line_mc.gotoAndStop(1);
				try{
				stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_STATUS,false));
				this.removeEventListener(SatCalcEvent.DISPLAY_MOUSEOUT,hideToolSymbol)
				this.removeEventListener(SatCalcEvent.DISPLAY_MOUSEOVER,showToolSymbol)
				stage.dispatchEvent(new MouseEvent(MouseEvent.DOUBLE_CLICK));
				break;
				}
				catch(e:Error){
					trace("Tool nicht deaktviert")};
					
			}
		}
		
		// Schaltet im Distance Measure object den SelectionStatuts auf true oder false
		
		private function showToolSymbol(e:SatCalcEvent){
			Distance2Point.SelectionMode = true;
			trace("TOOL ACTIVE");
		}
		
		private function hideToolSymbol(e:SatCalcEvent){
			Distance2Point.SelectionMode = false;
			trace("TOOL PASSIVE");
		}
		
		private function NewTwoPoint(e:MouseEvent){
			Distance2Point.addNewPoint();
			Distance2Point.mouseEnabled = false;
		}
		
		private function terminateTwoPoint(e:MouseEvent){
			Distance2Point.terminateDraw();
			stage.removeEventListener(MouseEvent.MOUSE_DOWN, NewTwoPoint);
			stage.removeEventListener(MouseEvent.DOUBLE_CLICK, terminateTwoPoint);
			Distance2Point.mouseEnabled = true;
			LinesSave.push(getChildByName(LinesSave.length.toString()).PointArray);
			trace (LinesSave);
		}
		
		private function deleteLines(e:MouseEvent){
			//Distance2Point.purge();
			trace("Lines save: " + LinesSave.length.toString())
			//for(var i = 0; i < LinesSave.length;i++){
				while(LinesCreated>0){
				removeChild(getChildByName((LinesCreated).toString()));
				LinesCreated-- ;
			}
		}
		
	private function metaDataUpdate(e:SatCalcEvent){
		trace ("Data in Vectortools: "+ e.data[1]);
		MetaOfCurrentData = e.data[1];
		Resolution = MetaOfCurrentData[3]
		Unit =	MetaOfCurrentData[4];
		ThisLabel = MetaOfCurrentData[0];
		 for (var i =0;i<LinesSave.length;i++){
			getChildByName(i.toString()).Resolution = Resolution ;
			getChildByName(i.toString()).Unit = Unit;
			getChildByName(i.toString()).LineLabel = ThisLabel;
		 	getChildByName(i.toString()).updateSegments();
			getChildByName(i.toString()).Xextend = e.data[0].width;
			getChildByName(i.toString()).Yextend = e.data[0].height;
		 	
		 }
		trace ("Auflösung und Einheit: "+ Resolution+ " " +Unit);
		 
		}
		
	private function disableTool(e:SatCalcEvent){
		if ((e.data.toString())!="VectorTool"){
			try{
			trace ("disabeling: "+ this +" " + e.data);
			VectTool_mc.Line_mc.gotoAndStop(1);
			//stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_STATUS,false));
			this.removeEventListener(SatCalcEvent.DISPLAY_MOUSEOUT,hideToolSymbol);
			this.removeEventListener(SatCalcEvent.DISPLAY_MOUSEOVER,showToolSymbol);
			stage.dispatchEvent(new MouseEvent(MouseEvent.DOUBLE_CLICK));
			}
			catch(e:Error){};
		}
	}
	
		
			
	} // Class Close
} // package close