﻿// StageBack zieht einen Hintergund über die gesamte Fläche der Stage auf

package com.utility{
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.text.*;
	
	public class StageBack extends Sprite{
	
	private var BackClip:Sprite // Container für den Hintergrund
	private var BackRect:Rectangle // Der Hintergrund
	private var BackShape:Shape // Der Hintergrund
	
	private var BackColor:uint // HintergrundFarbe
	private var BackAlpha:Number // Alpha
	private var StageWidth:uint;
	private var StageHeight:uint;
	
	private var Version:String; 
	
		public function StageBack(bc:uint=0x000000,ba:Number = 1,SW:uint=800,SH:uint=600){
			Version = "08032012"
			trace ("init StageBack :"+Version);
			StageWidth = SW;
			StageHeight = SH;
			BackColor = bc;
			BackAlpha = ba;
			BackClip = new Sprite();
			addChild(BackClip);
			this.addEventListener(Event.ADDED_TO_STAGE,drawBack);
			;
			
		}// Constructor close
		
		private function drawBack(e:Event){
			var Point_1:Point =  globalToLocal(new Point(0,0));
			var Point_2:Point =  globalToLocal(new Point(StageWidth,StageHeight));
			BackShape = new Shape();
			BackShape.graphics.beginFill(BackColor,BackAlpha);
			//BackShape.graphics.drawRect(Point_1.x,Point_1.y,Point_2.x,Point_2.y);
			BackShape.graphics.drawRect(Point_1.x,Point_1.y,Point_2.x,Point_2.y);
			trace("adding Background");
			addChild(BackShape);
		}
		
		
	
	} //public class close
}//Package close