﻿/*SimliarValues lässt den Benutzer aus dem im Satcalculator aktuell angezeigten Bild eine Fabwert auswählen.
Über einen Tolreanzregler können dann ähnliche Farbwerte im Bild markiert werden.*/

package  com.tools {
	
import com.events.SatCalcEvent;
import flash.display.Sprite;
import flash.display.*;
import flash.geom.*;
import flash.text.*;
import flash.events.*;
import FISEvents;
import com.utilities.*;
import flash.ui.Mouse;
import flash.utils.*;
import flash.net.*;


	public class SimilarValues extends SatCalcDisplay {
		
		public var StageZero:Point;
		private var Image_BMP:Object;	// Das anzuzeigende und zu klassifizierende Bild 
		public var SimValue_mc:MovieClip; 
		private var T:Number;
		private var Rect:Rectangle; 		// Rectangle für Sliderbegrenzung
		private var Delay:Timer;
		private var orgBild:RGBSelector; 	// Die Klasse in welcher die RGB Selection stattfindet
		public var OutAt_X:int;					// an welche Stage Koordinaten werden die Overlays ausgegeben
		public var OutAt_Y:int;
		private var ColValues:Array;			// welche Farbwerte werden ausgewählt
		private var CoordinatesOverlay:Bitmap; // Transparente Fläche auf welcher PixelKoordinaten ausgwählt werden können
		private var Pipette_mc:MovieClip;
		private var VisInVis_mc:MovieClip;
		private var ColorField:Bitmap;			// zeigt die aktuell gewählte Farbe an
		private var UpDown_mc:MovieClip;
		private var PickArea:Bitmap;
		private var CurrentCursor:String;		// welcher Cursor ist aktutell
		private var VarrArray:Array;			// Array in welchem zusätzliche Variablen bei initialisierung übergeben werden
												// Array[0] = Mask:Boolean; Array[1] = MaskURL
		private var Mask:Boolean;				// gibt es eineMaske
		private var MaskURL:String;				// URL der Maske
		private var MaskImage:AutoImage;		// Das Maskenbild fallsvorhanden
		private var MaskImageBD:BitmapData;		// Bitmap Daten der Maske
		//public var PixelDims:int;				// Welche Abmessungen hat ein Pixel;
		public var PixelsMarked:int;			// Welche Abmessungen hat ein Pixel;
		public var AreaMarked:int;				// Wie viel fläche wzrde makiert;
		public var AreaUnit:String;				// in welcher Einheit
		public var MetaOfCurrentData:Array;		// Metadaten Array des Momentan angezeigten Bildes(welches das Tool bearbeitet);;
		public var ToolDims:Array;				// Die Abmessungen der Tools. Wird im SatCalculator benötigt um die Positionierung vorzunehmen
		public var HasDropFields:Boolean;		// Hat dieses Tool Dropfields
		public var HasGhosts:Boolean;
		public var Ident:String;				// Gleicht dem Namen des Objektes im Satcalculator
		public var Preset:Boolean;				// Ein fester Wert für die Toleranz wird übergeben, der Toleranz Regeler bleibt unsichtbar
		private var PresetValue:int;				// Ein fester Wert in Prozent welcher die voreingestellte Toleranz vorgibt
		private var ValueSpan:Number			// Wie ist der Werteumfang der Bilddaten
		private var ImagesDropped:int;			//zaählt die gedroppten Bilder, damit das erste nicht markiert wird
		private var Version:String
		public var ColorChoosen:Boolean;		// Erst wenn eine Farbe gewählt wurde soll auch die Fläche markiert wederden. Da die Standard Farbe 0/0/0 und auch bei einer Bilderneuerung Flächen markiert werden würde sonst ohne vorherige Farbwahl beim Bildwechsel eine Farbe markiert.
		private var ToleranceUnit:String;		// In welcher Einheit wird die Toleranz geregelt
		private var TransformFunction:Array;	// Die lineare function nach welcherdie Werte des Bildes in seine Einheitserte umgerechnet werden(bei ValueImages);
		private var CalcTools:ClassifierBase;	// zur Umrechnung von Dingen
		private var DataIsArray:Boolean;
		private var W:int;						// Höhe des auszuwertenden Bildes
		private var H:int;						// Breite des auszuwertenden Bildes
		
		public function SimilarValues(outX:int,outY:int,varArr:Array,ID:String){
			
			Version = "20111206"
			
			var ImagesDropped = 0;
			
			ColorChoosen = false;
			
			Ident = ID;
			
			trace ("SIMILAR VALUES INVOKED "+Version);
			
			HasDropFields = false;
			HasGhosts = false;
			
			Mask = StringToBool(varArr[0]);
			//trace ("MASK IS "+Mask);
			
			ToleranceUnit = varArr[4];
			
			MaskURL = varArr[1];	
			//trace ("MaskURL IS "+MaskURL);
			if (Mask == true){
				MaskImage = new AutoImage(MaskURL,false,false);
				MaskImage.addEventListener(FISEvents.IMAGE_INIT,addMask,false,0,true)
			}
			
			
			CalcTools = new ClassifierBase();
			
			Pipette_mc = new Pipette;
			Pipette_mc.name = "Pipette_mc";
			
			UpDown_mc = new UpDownArrow;
			UpDown_mc.name = "UpDown_mc";
			
			ValueSpan=255;
			
			OutAt_X=outX;
			OutAt_Y=outY;
			
			SimValue_mc = new SimValues;
			addChild(SimValue_mc);
			
			ToolDims = new Array();
			ToolDims[0] =[SimValue_mc.width,SimValue_mc.height];
			
			ColValues = new Array(3);
			
			ColorField = new Bitmap(new BitmapData(52,28,false,0x000000));
			addChild(ColorField);
			ColorField.x=45;
			ColorField.y=28;
			
			SimValue_mc.VisInVis_mc.gotoAndStop(1);
			SimValue_mc.VisInVis_mc.buttonMode = true;
			SimValue_mc.VisInVis_mc.addEventListener(MouseEvent.MOUSE_DOWN,switchVis,false,0,true);
			
			SimValue_mc.Tolerance_mc.Griff_T.buttonMode = true;
			SimValue_mc.Tolerance_mc.Griff_T.addEventListener(MouseEvent.MOUSE_DOWN, Slide_T,false,0,true);
			SimValue_mc.Tolerance_mc.Griff_T.addEventListener(MouseEvent.MOUSE_UP,StopSlide,false,0,true);
			SimValue_mc.Tolerance_mc.Griff_T.addEventListener(MouseEvent.MOUSE_OUT,StopSlide,false,0,true);
			SimValue_mc.Tolerance_mc.Griff_T.addEventListener(MouseEvent.MOUSE_OVER,addUpDown,false,0,true);
			SimValue_mc.Tolerance_mc.Griff_T.addEventListener(MouseEvent.MOUSE_OUT,removeUpDown,false,0,true);
			
			this.addEventListener(SatCalcEvent.TOOL_ENABLED,disableTool);
			
			SimValue_mc.PikColor_mc.buttonMode=true;
			SimValue_mc.PikColor_mc.addEventListener(MouseEvent.MOUSE_DOWN,switchPick,false,0,true);
			SimValue_mc.PikColor_mc.gotoAndStop(1);
			
			Rect = new Rectangle(0, 0, 0, 255);
			
			Delay = new Timer(100);
			
			T = 0;
			
			MetaOfCurrentData = new Array()
			trace (varArr[2]);
			Preset = StringToBool(varArr[2]);
			trace("SHSHSHSHSSH"+Preset);
			if (Preset == true){
				trace("PRSETVALUEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE")
				SimValue_mc.Tolerance_mc.Griff_T.y = varArr[3];
				T = varArr[3];
				PresetValue = varArr[3];
				SimValue_mc.Tolerance_mc.visible=false;
				//SimValue_mc.Tolerance_mc.Schiene_mc.visible=false;
				SimValue_mc.Tolerance_mc.Griff_T.buttonMode = false;
				SimValue_mc.Tolerance_mc.Griff_T.removeEventListener(MouseEvent.MOUSE_DOWN, Slide_T);
				SimValue_mc.Tolerance_mc.Griff_T.removeEventListener(MouseEvent.MOUSE_UP,StopSlide);
				SimValue_mc.Tolerance_mc.Griff_T.removeEventListener(MouseEvent.MOUSE_OUT,StopSlide);
				SimValue_mc.Tolerance_mc.Griff_T.removeEventListener(MouseEvent.MOUSE_OVER,addUpDown);
				SimValue_mc.Tolerance_mc.Griff_T.removeEventListener(MouseEvent.MOUSE_OUT,removeUpDown);
				SimValue_mc.Tolerance_mc.Griff_T.TWERT.text =(Math.round(T/2.55)+ToleranceUnit).toString();
			}
			
			this.addEventListener(SatCalcEvent.DISPLAY_UPDATE,initImage)
			//this.addEventListener(SatCalcEvent.DISPLAY_MOUSEOVER,showPipette)
			//this.addEventListener(SatCalcEvent.DISPLAY_MOUSEOUT,hidePipette)
				
		}// Constructor close
		
				
		// Regler für Toleranz

		private function Slide_T (e:Event){
			//Regler_R.Griff_R.addEventListener(MouseEvent.MOUSE_MOVE,updatePercent)
			switchVis(new MouseEvent(MouseEvent.MOUSE_UP));
			SimValue_mc.Tolerance_mc.Griff_T.addEventListener(MouseEvent.MOUSE_MOVE,Update)
			SimValue_mc.Tolerance_mc.Griff_T.startDrag (false, Rect); 
		}
		
		
		private function Update(e:MouseEvent){
			
			trace ("TOLERANCE: "+T);
			if (MetaOfCurrentData[2] == "ValueImage"){
			// der Werteumfang wird bberechnet
				
				
				// Der Umrechnungfaktor
			var TransFact:Number = ValueSpan/255;
			//T=CalcTools.linearTransformValue(SimValue_mc.Tolerance_mc.Griff_T.y,TransformFunction);
			//T = T-ColValues[0];
			
			T=SimValue_mc.Tolerance_mc.Griff_T.y*TransFact;
			T = Math.round(T*10)/10;
			
			SimValue_mc.Tolerance_mc.Griff_T.TWERT.text = (T+ToleranceUnit).toString();
			}
			else{
			T=SimValue_mc.Tolerance_mc.Griff_T.y;
			SimValue_mc.Tolerance_mc.Griff_T.TWERT.text =(Math.round(T/2.55)+ToleranceUnit).toString();
			}
			
			Delay.start(); 
			Delay.addEventListener(TimerEvent.TIMER, delayMark);
				
		}
		
		
		private function delayMark(e:TimerEvent){
			if(orgBild && ColorChoosen ==true){
			orgBild.clearMarkBmp();
			orgBild.MarkColor =0xFF9964BD;
			orgBild.selectValue(ColValues[0],ColValues[1],ColValues[2],T);
			orgBild.Showmarked();
			//Sobald die Pixel markiert sind werden die Daten an als Main weitergegegeben.Array:[Bildinformationen,[Array mit Metainformationen]]
			PixelsMarked = orgBild.Pixamount;
			AreaMarked = (MetaOfCurrentData[3]*MetaOfCurrentData[3])*PixelsMarked;
			SimValue_mc.Amount_txt.text = AreaMarked.toString();
			this.dispatchEvent(new SatCalcEvent(SatCalcEvent.DATA_SEND,[orgBild.markbmp,[AreaMarked,AreaUnit]]));
			Delay.stop();
			Delay.removeEventListener(TimerEvent.TIMER, delayMark);
			
			}
		}
		
		private function normalMark(){
			if (ColorChoosen ==true){
				orgBild.clearMarkBmp();
				orgBild.MarkColor =0xFF9964BD;
				orgBild.selectValue(ColValues[0],ColValues[1],ColValues[2],T);
				//Sobald die Pixel markiert sind werden die Daten an als Main weitergegegeben.Array:[Bildinformationen,[Array mit Metainformationen für die sicherung]]
				orgBild.Showmarked();
				
				PixelsMarked = orgBild.Pixamount;
				AreaMarked = (MetaOfCurrentData[3]*MetaOfCurrentData[3])*PixelsMarked;
				SimValue_mc.Amount_txt.text = AreaMarked.toString();
				this.dispatchEvent(new SatCalcEvent(SatCalcEvent.DATA_SEND,[orgBild.markbmp,[AreaMarked,AreaUnit]]));
			}
		}
		
				
		// Funktion zum Anhalten des Sliders

		private function StopSlide (e:Event) {
			
			e.currentTarget.removeEventListener(MouseEvent.MOUSE_MOVE,Update);
			
			switch (e.type){
				
			case "mouseOut":
				//Mouse.show();
				
				this.stopDrag();
				//Update();
				break;
			
			case "mouseUp":
			
			this.stopDrag();
			
			// Update();
			 
			 break;
			
			default:
			trace ("nothin")}
		}
		
		public function passData(...args) {
		 LoadedContent.content.passData(args);
		} 
		
		// Sobald ein Bild im SatCalc af die Anzeigefläche geropped wurde, wir ein SimValues für dieses Bild inititiert
		
		private function initImage(e:SatCalcEvent){
			try{
				orgBild.clearMarkBmp();
				
			}
			
			catch(e:Error){}
			
			//Metadaten updaten
			MetaOfCurrentData =  e.data[1];
			
			W=MetaOfCurrentData[7][0];
			H=MetaOfCurrentData[7][1];
			
			if (MetaOfCurrentData[2] == "ValueImage"){
				TransformFunction = MetaOfCurrentData[6]
				trace ("Function für SimValue: " +MetaOfCurrentData[6] );
			}
			// Was wird angezeigt Array/Bitmap
			if ( e.data[0] instanceof Bitmap){
			trace ("SimValue bekommt Bitmap");
			DataIsArray = false;
			Image_BMP = e.data[0];
			ColorField.width = 52;
			ColorField.height = 28;
			addChild(ColorField);
			ColorField.x=45;
			ColorField.y=28;
			ValueSpan = 255;
			}
			if ( e.data[0] instanceof Array){
			trace (" SimValue bekommt Array");
			Image_BMP = e.data[0];
			DataIsArray = true;
			ColorField.width = 52;
			ColorField.height = 10;
			addChild(ColorField);
			ColorField.x=45;
			ColorField.y=50;
			ToleranceUnit = MetaOfCurrentData[8];
			var min:Number = CalcTools.linearTransformValue(0,TransformFunction);
			var max:Number = CalcTools.linearTransformValue(255,TransformFunction);
			ValueSpan = max-min;
			
			// CalcTools.returnBitmapFromArray(e.data[0],MetaOfCurrentData[7][0],MetaOfCurrentData[7][1]);
			}
			
			trace ("SimilarValues initiert");
			trace (typeof(e.data));
			
			SimValue_mc.Info_txt.text = MetaOfCurrentData[0].toString()+ "\n"+ MetaOfCurrentData[1].toString();
			AreaUnit = MetaOfCurrentData[4].toString();
			SimValue_mc.Unit_txt.text = AreaUnit;
			
			if (Mask==false){
				orgBild = new RGBSelector(Image_BMP,false,false,MetaOfCurrentData[7][0],MetaOfCurrentData[7][1]);
			} 
			
			else if (Mask==true){
				orgBild = new RGBSelector(Image_BMP,true,false,MetaOfCurrentData[7][0],MetaOfCurrentData[7][1]);
				orgBild.Mask_BD = MaskImageBD;
			}
			
			trace ("ORG BILD BREIT: " +Image_BMP.width);
			X_extend = Image_BMP.width;
			Y_extend = Image_BMP.height;
			
			StageZero = this.globalToLocal(new Point(OutAt_X,OutAt_Y)); 
			orgBild.x =StageZero.x;
			orgBild.y =StageZero.y;
			//PickArea = new Bitmap(new BitmapData(X_extend,Y_extend,true,0x00000000));
			PickArea = new Bitmap(new BitmapData(1,1));
			//PickArea.mouseEnabled=false; 
			this.addChild(PickArea);
			PickArea.x =StageZero.x;
			PickArea.y =StageZero.y;
			if (ImagesDropped != 0){
			normalMark();
			}
			
			if (MetaOfCurrentData[2] == "ValueImage"){
				orgBild.TransFunction = TransformFunction;
			}
			
			if (Preset == true){
				setPresetValue();
			}
			
			//SimValue_mc.PikColor_mc.gotoAndStop(1);
			Pipette_mc.visible = false;
			ImagesDropped++;
			try{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,movePik);
			}
			
			
			catch(e:Error){};
			Mouse.show();
			switchVis(new MouseEvent(MouseEvent.MOUSE_UP));
			
		}
		
		private function switchPick(e:MouseEvent){
			switch(SimValue_mc.PikColor_mc.currentFrame){
				case 1:
				SimValue_mc.PikColor_mc.gotoAndStop(2)
				try{
				//Pipette_mc.mouseEnabled=false;
				//stage.addEventListener(MouseEvent.MOUSE_DOWN,getColorValues,false,0,true);
				stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_STATUS,true));
				this.addEventListener(SatCalcEvent.DISPLAY_MOUSEOVER,showPipette)
			    this.addEventListener(SatCalcEvent.DISPLAY_MOUSEOUT,hidePipette)
				stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_ENABLED,"SimilarValues"));
				}
				catch(e:Error){
					trace("Pipette nicht initialisiert")};
					
				break;
				case 2:
				SimValue_mc.PikColor_mc.gotoAndStop(1)
				try{
				stage.removeEventListener(MouseEvent.MOUSE_DOWN,getColorValues);
				stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_STATUS,false));
				this.removeEventListener(SatCalcEvent.DISPLAY_MOUSEOUT,hidePipette)
				this.removeEventListener(SatCalcEvent.DISPLAY_MOUSEOVER,showPipette)
				break;
				}
				catch(e:Error){};
					
			}
		}
		
		private function getColorValues(e:MouseEvent){
			ColorChoosen = true;
			var GlobalPos:int
			trace ("DIFF " + StageZero);
			if(this.mouseX<orgBild.x+W && this.mouseX>orgBild.x){
				ColValues = orgBild.returnValue((mouseX-orgBild.x)+5,(mouseY-orgBild.y))
				trace ("ValuesSSSS: " + ColValues + " " +orgBild.x+ " "+ orgBild.y);
				updateColorField(ColValues);
				switchVis(new MouseEvent(MouseEvent.MOUSE_UP));
			}
			
		}
		
		private function updateColorField(colVal:Array){
			var color:uint =   0 << 24 | colVal[0] << 16 | colVal[1] << 8 | colVal[2];
			ColorField.bitmapData.floodFill(1,1,color);
			//addChild(ColorField);
			if(DataIsArray==true){SimValue_mc.Farbwert_txt.text = (int(colVal[0]*10)/10).toString()+ToleranceUnit};
		}
		
		private function movePik(e:MouseEvent){
			Pipette_mc.x = mouseX+5;
			Pipette_mc.y = mouseY;

		}
		
		private function addUpDown(e:MouseEvent){
			addChild(UpDown_mc);
			UpDown_mc.visible=true;
			Mouse.hide();
			trace (CurrentCursor);
			try{
				getChildByName(CurrentCursor).visible = false;
			}
			catch(e:Error){trace ("nix")};
			UpDown_mc.mouseEnabled=false; 
			SimValue_mc.Tolerance_mc.Griff_T.addEventListener(MouseEvent.MOUSE_MOVE,moveUpDown,false,0,true);
		}
		
		
		private function removeUpDown(e:MouseEvent){
			UpDown_mc.visible=false;
			Mouse.show();
			SimValue_mc.Tolerance_mc.Griff_T.removeEventListener(MouseEvent.MOUSE_MOVE,moveUpDown);
		}
		
		
		private function moveUpDown(e:MouseEvent){
			UpDown_mc.x = mouseX;
			UpDown_mc.y = mouseY;
		}
		
		private function changeCursor(e:MouseEvent){
			trace(e.currentTarget.name)
			switch (e.currentTarget.name){
				case "Griff_T":
				try{
				getChildByName(CurrentCursor).visible = false;
				}
				catch(e:Error){};
				addChild(UpDown_mc);
				UpDown_mc.visible=true;
				Mouse.hide();
				CurrentCusor = UpDown_mc.name;
				trace(CurrentCursor);
				UpDown_mc.mouseEnabled=false; 
				SimValue_mc.Tolerance_mc.Griff_T.addEventListener(MouseEvent.MOUSE_MOVE,moveUpDown,false,0,true);
				break;
			
			}
		}
		
		private function addMask(e:FISEvents){
			MaskImageBD =  MaskImage.InBitmapData;
		}
		
		// die eingehenden Anweisung im Array sind grundsätzlich Strings. Boolwerte müsen erst hier durch 
		
		private function StringToBool(inString:String):Boolean{
			var returnBool:Boolean;
			switch(inString){
				case "true":
				returnBool = true;
				break;
				case "false":
				returnBool = false;
				break;
			}
			return returnBool;
		}
			
		private function showPipette(e:SatCalcEvent){

			stage.addEventListener(MouseEvent.MOUSE_DOWN,getColorValues,false,0,true);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,movePik,false,0,true);
			addChild(Pipette_mc);
			Pipette_mc.visible = true;
			Pipette_mc.mouseEnabled=false; 
			CurrentCursor = Pipette_mc.name;
			Mouse.hide();
			trace ("Pipette an");
			
		}
		
		private function hidePipette(e:SatCalcEvent){
			trace ("Pipette aus");
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,movePik);
			stage.removeEventListener(MouseEvent.MOUSE_DOWN,getColorValues);
			Pipette_mc.visible = false;
			Mouse.show();
		}
		
		private function switchVis(e:Event){
			trace (e);
			switch (e.type){
				case "mouseDown":
				switch(SimValue_mc.VisInVis_mc.currentFrame){
					case 1:
					trace ("VIS aus");
					SimValue_mc.VisInVis_mc.gotoAndStop(2);
					orgBild.clearMarkBmp();
					this.dispatchEvent(new SatCalcEvent(SatCalcEvent.DATA_SEND,[orgBild.markbmp,[AreaMarked,AreaUnit]]));
					break;
					
					case 2:
					SimValue_mc.VisInVis_mc.gotoAndStop(1);
					trace ("VIS an");
					normalMark();
					break;
				}
				break;
				case "mouseUp":
					SimValue_mc.VisInVis_mc.gotoAndStop(1);
					trace ("VIS an");
					normalMark();
				break;
			}
			
		}
		
		// Deaktiviert das Tool nachdem ein anderes gewählt wurde
	
	private function disableTool(e:SatCalcEvent){
		if ((e.data.toString())!="SimilarValues"){
			try{
			SimValue_mc.PikColor_mc.gotoAndStop(1);
			trace ("disabeling: "+ this +" " + e.data);
			stage.removeEventListener(MouseEvent.MOUSE_DOWN,getColorValues);
			//stage.dispatchEvent(new SatCalcEvent(SatCalcEvent.TOOL_STATUS,false));
			this.removeEventListener(SatCalcEvent.DISPLAY_MOUSEOUT,hidePipette)
			this.removeEventListener(SatCalcEvent.DISPLAY_MOUSEOVER,showPipette)
			}
			catch(e:Error){};
		}
	}
	
	private function setPresetValue(){
		 if (MetaOfCurrentData[2] == "ValueImage"){
			 T = ValueSpan/100*PresetValue;
			
		 }
		 else{
			T = PresetValue;
		}
	trace("PRESET VALUE :"+T);
	}

	
	}// Class Close
}//Package close
	 