﻿// VORLAGE FÜR TOOLS//

package  com.tools {
	
import com.events.SatCalcEvent;
import flash.display.Sprite;
import flash.display.*;
import flash.geom.*;
import flash.text.*;
import flash.events.*;
import FISEvents;
import com.utilities.*;
import flash.ui.Mouse;
import flash.utils.*;
import flash.net.*;


	public class TimelineTool extends SatCalcDisplay {
	
	
	public var OutAt_X:int;					// an welche Stage Koordinaten werden die Overlays ausgegeben
	public var OutAt_Y:int;
	public var VectTool_mc:MovieClip; 
	public var HasDropFields:Boolean;
	public var HasGhosts:Boolean;
	public var DropFields:Array;
	public var UnusedDropFields:Array;

	public var ToolDims:Array;				// Die Abmessungen der Tools. Wird im SatCalculator benötigt um die Positionierung vorzunehmen
	public var Ident:String;				// Gleicht dem Namen des Objektes im Satcalculator
	
	private var DataWidth_:int;
	private var DataHeight_:int;
	
	private var DataWidth_disp:int;			// Bildmaße des angezeigten Bildes
	private var DataHeight_disp:int;
	
	// Variablen für Dropfields und Bilddaten in diesen
	public var Image_1_koord:Point;
	public var Image_2_koord:Point;
	public var Image_3_koord:Point;
	public var Image_4_koord:Point;
	public var Image_5_koord:Point;
	public var Image_6_koord:Point;
	
	private var Data_0:Array;			// Array mit den Daten des 1. Bildes
	private var Data_1:Array;			// Array mit den Daten des 2. Bildes
	private var Data_2:Array;			// Array mit den Daten des 3. Bildes
	private var Data_3:Array;			// Array mit den Daten des 4. Bildes
	private var Data_4:Array;			// Array mit den Daten des 5. Bildes
	private var Data_5:Array;			// Array mit den Daten des 6. Bildes
	
	private var TimeArray:Array;		// Die Daten (Zeit) kommen hier an die entsprechende Stelle
	private var DataArray:Array;		// Die yDaten  kommen hier an die entsprechende Stelle
	private var DataArrayX:Array;		// Die xDaten  kommen hier an die entsprechende Stelle
	
	public var Timeline:MovieClip; 
	public var NameOfData:Array;			// Die Namen der in der Rechung verwendeten Clips kommen hier rein
	public var NameOfGhosts:Array;			// Die Namen der Ghosts
	public var GhostArray:Array;			// sammelt die MovieClips der Ghosts
	
	private var TimePik:TimelinePik_mc;
	private var TimePikVis:Boolean;			// ist der Tim Pik sichtbar
	
	private var window:ExtWindow;			// Fenster zur Anzeige des Graphen
	private var Graph:GraphDraw;			// Der Herr Graf
	
	private var CalcTools:ClassifierBase; // Umrechnungskram
	
	private var Range:Array;				// Welcher Werteumfang soll angezeigt werden
	
	private var FirstDrop:Boolean;			// das Erste Bild legt den Wertebereich fest
	
		public function TimelineTool(outX:int,outY:int,varArr:Array,ID:String){
			
			Ident = ID;
			
			// Die Positionen der Dropflächen im Lokalen Objekt
			
			Image_1_koord = new Point(1,4);
			Image_2_koord = new Point(51,4);
			Image_3_koord = new Point(101,4);
			Image_4_koord = new Point(1,53);
			Image_5_koord = new Point(51,53);
			Image_6_koord = new Point(101,53);
			
			trace ("LOCALLLLLLLLLLLLLLLLLLLLRUNDE " +localToGlobal(Image_1_koord))
			
			this.addEventListener(SatCalcEvent.DATA_DROP,dataDropped);
			//this.addEventListener(SatCalcEvent.DATA_DELETE,removeData);
			
			CalcTools = new ClassifierBase();
			
			
			// Das Array in dem alle relevanten Daten zu den DropFields gespeichert sind
			
			DropFields = new Array();
			
			UnusedDropFields = new Array();
			
			NameOfData = new Array();
			
			NameOfGhosts = new Array();

			HasDropFields = true;
			HasGhosts	= true;
			trace ("TimlineTool INVOKED");
			
			OutAt_X=outX;
			OutAt_Y=outY;
			
			DropFields[0] = [Ident,"1",Image_1_koord];
			DropFields[1] = [Ident,"2",Image_2_koord];
			DropFields[2] = [Ident,"3",Image_3_koord];
			DropFields[3] = [Ident,"4",Image_4_koord];
			DropFields[4] = [Ident,"5",Image_5_koord];
			DropFields[5] = [Ident,"6",Image_6_koord];
			
			
			Timeline = new TimelineTool_mc;
			addChild(Timeline);
			ToolDims = new Array();
			ToolDims[0] =[Timeline.width,Timeline.height];
			
			Timeline.Timebutt_mc.visible =false;
			Timeline.Timebutt_mc.buttonMode = true;
			Timeline.Timebutt_mc.addEventListener(MouseEvent.MOUSE_DOWN, triggerTimeline);
			
			
			AllocationStatus = new Array();
			AllocationStatus =[false,false,false,false,false,false];
			
			TimeArray = new Array();
			TimeArray = [null,null,null,null,null,null]
			
			DataArray = new Array();
			DataArray = [null,null,null,null,null,null];
			
			DataArrayX = new Array();
			DataArrayX = [10,30,50,70,90,110];
			
			GhostArray = new Array();
			GhostArray = [null,null,null,null,null,null];
			
			Range = new Array();
			Range = [0,255];
			
			FirstDrop = false;
			this.addEventListener(SatCalcEvent.DISPLAY_UPDATE,setWH)
			
			TimePikVis = false;
			
		}// Constructor close
		
				// Das e.data array beinhaltet: Name des getroffenen Dropfields(HotDropField),DatenArray(recentArray),recentButton.Ghost_mc,recentButton.name,recentButton.DataWidth,recentButton.DataHeight,recentButton.kanal,recentButton.Resolution,recentButton.Unit,recentButton.datum]
		//															0						1							2				3					4						5							6					7					8				9				
		private function dataDropped(e:SatCalcEvent){
		// Erst wird überprüft ob das Dropfield für dieses Tool überhaupt relevant ist
		var isRelevant:Boolean = checkDropfields(e.data[0]);
			if (isRelevant == true){
				var GhostImage:MovieClip = MovieClip(e.data[2]);
				var DroppedOn:String = e.data[0];
				trace ("Drop in TIMELINE TOOL: " + e.data[0]);
				
					try {
					this["Data_" + int(DroppedOn)] = e.data[1]}
					catch(e:Error){}
					
						AllocationStatus[int(DroppedOn)-1] = true;
						NameOfData.push([e.data[3],DroppedOn]);
						//NameOfGhosts.push([e.data[3],DroppedOn]); // Das Array ist identisch mit NameOfData, wird aber beim auslesen der ZR nicht gelöscht
						//trace ("1 wurde bestückt :"+ Data_1[1599] + " von " +NameOfData + " WH "+e.data[4]+" "+e.data[5]);
						DataWidth_=e.data[4];
						DataHeight_=e.data[5];
						TimeArray[int(DroppedOn)-1] = e.data[9];
						//addGhost(GhostImage,DroppedOn);
						GhostArray[int(DroppedOn)-1] = GhostImage;
						
					trace ("DATUMSARRAY " +TimeArray);
					checkTimePik();
					if (FirstDrop==false){
						Range[0] = CalcTools.returnMinMax(e.data[1],"min");
						Range[1] = CalcTools.returnMinMax(e.data[1],"max");
					}
					
					FirstDrop = true;
				//checkCalcButton();
			}
		}
		
		// Ist der TimePik in abhängigkeit vom Allocation Status Array sichtbar oder nicht
		
		private function checkTimePik(){
			
			trace ("Zustand von Allocation "  + AllocationStatus);
			var timPikvis:Boolean = false;
			for (var i = 0; i<AllocationStatus.length; i++){
			trace (AllocationStatus[i]+" "+timPikvis);
			 if(AllocationStatus[i] == true){timPikvis = true}
			 
			}
			if (timPikvis == true){readyTimePik();trace ("TimePik aktiviert")}
			if (timPikvis == false){deactivateTimePik();trace ("TimePik deaktiviert")};
		}
		
		private function readyTimePik(){
			Timeline.Timebutt_mc.visible = true;
			Timeline.Timebutt_mc.gotoAndStop(1);
		}
		
		private function triggerTimeline(e:MouseEvent){
		 if (e.currentTarget.currentFrame == 1){
		 activateTimePik()}
		
		 else if (e.currentTarget.currentFrame == 2){
		 deactivateTimePik();
		 Timeline.Timebutt_mc.gotoAndStop(1)};
		 
		}
	
		private function activateTimePik(){
			if (TimePikVis == true){ }
			else{
				TimePik = new TimelinePik_mc();
				TimePik.gotoAndPlay(1);
				TimePik.x = -300;
				TimePik.y = -50;
				Timeline.Timebutt_mc.gotoAndStop(2)}
				TimePik.addEventListener(MouseEvent.MOUSE_DOWN,movePik,false,0,true);
				TimePik.addEventListener(MouseEvent.MOUSE_UP,stopPik,false,0,true);
				addChild(TimePik);
				TimePik.buttonMode = true;
				trace ("Timepik an");
				TimePikVis = true;
				window = new ExtWindow("Zeitreihe",-300,-50,150,180);
				window.FrameStrengh = 3;
				window.RelocColor = 0x99CC33;
				window.FrameColor = 0xD9E6DC;
				window.TextColor = 0xFFFFFF;
				window.initWindow();
				window.initTitle();
				
				
				addChild(window);
				Timeline.Timebutt_mc.visible = true;
				window.resetRestriction(OutAt_X,OutAt_Y,OutAt_X+505,OutAt_Y+505); 
				// Graph wir angefügt
				addGraph();
				// Zeireihe gelehrt
				removeTimelineClips();
				//Ghosts hinzugefügt
				addGhosts();
				deactivateUnusedDropFields();

		}
		
		private function deactivateTimePik(){
			TimePikVis = false;
			try{removeChild(TimePik);
			removeChild(window);}
			catch(e:Error){};
			Timeline.Timebutt_mc.visible = false;
			emptyTimeline();
			removeTimelineClips();
			removeGhosts();
		}
		
		private function movePik(e:MouseEvent){
			TimePik.startDrag();
		}
		
		private function stopPik(e:MouseEvent){
			var localCoordinates:Point = new Point(TimePik.x - OutAt_X ,TimePik.y - OutAt_Y);
			var globalCoordinates:Point = localToGlobal(localCoordinates);
			trace ("Pik in local :"  +localCoordinates);
			trace ("Pik in global :" +globalCoordinates);
			TimePik.stopDrag();
			refreshDataArray(globalCoordinates);
		}
		
		// Liest an den aus den koordinaten des Piks die Daten aus Data_1, Data_2... aus und erstellt das DataArray()
		
		private function refreshDataArray(inPoint:Point){
			DataArray = new Array();
			DataArray = [null,null,null,null,null,null];
			
			for(var i =0; i<AllocationStatus.length; i++){
				if (AllocationStatus[i] == true){
					DataArray[i] = this["Data_" + (i+1)][getArrayPos(DataWidth_disp,DataHeight_disp,inPoint.x,inPoint.y)]
				}
			}
			trace (DataArray);
			refreshGraph();
		}
		
	
	public function getArrayPos(W:int,H:int,xpos:int,ypos:int):int{
		var ArrayPos:int = (ypos*W)-(W-xpos);
		trace ("arpos:" +ArrayPos);
		var ReturnValue:Number = ArrayPos;
		return ArrayPos;
	}
	
	
	private function setWH(e:SatCalcEvent){
		DataWidth_disp = Bitmap(e.data[0]).width;
		DataHeight_disp = Bitmap(e.data[0]).height;
	}
		
		
		
	// nur die Clips werden entfernt nach Timeline start
	private function removeTimelineClips(){
		trace ("Clips werden aus Zeitreihe entfernt");
		// In diesem Fall wird durch das übergebene false im SatCalculator nur das zurücksetzen der ExtClips bewirkt
		 this.dispatchEvent(new SatCalcEvent(SatCalcEvent.DATA_DISPLAY,[false]));
		
	}
	
	
		// Wenn Zeitreihe komplett beendet wird
		
		private function emptyTimeline(){
		trace ("Daten werden aus Zeitreihe entfernt " +NameOfData.length );
			for(var i=0;i<NameOfData.length;i++){
				trace (NameOfData[i][0]+ " wird aus Zeitreihe entfernt");
				removeData((NameOfData[i][0]).toString());
			}
			
			NameOfData = new Array();
			activateUnusedDropFields();
			UnusedDropFields = new Array();
		}
		
		private function removeData(toRemove:String){
			
			trace (toRemove + " soll fliegen");
			trace (NameOfData);
			for(var i=0;i<NameOfData.length;i++){
				if (NameOfData[i][0]==toRemove){
				trace (NameOfData[i][0] +" fliegt");
				this.dispatchEvent(new SatCalcEvent(SatCalcEvent.REMOVE_GHOST,[NameOfData[i][1],NameOfData[i][1]]));
				clearData(NameOfData[i][1]);
				}
			}
		}
		
		// Die Datenarrays werden zurückgesetzt  
		private function clearData(rem:String){
				trace("Data wird gelöscht: "+ rem)
				this["Data_" + int(rem)] = new Array();
				//TimeArray[int(rem)-1]
				AllocationStatus[int(rem)-1] = false;
				DataArray[int(rem)-1] = null;
				TimeArray[int(rem)-1] = null;
				//NameOfData = NameOfData.splice(int(rem)-1,1);
				//NameOfGhosts = NameOfGhosts.splice(int(rem)-1,1);
				GhostArray[int(rem)-1] = null;
				
			//checkTimePik();
	
		}
		
		private function addGraph(){
					  
			Graph = new GraphDraw([0,0,0,0,0,0],[0,0,0,0,0,0],arrangeDataArray(TimeArray),DataArray,125,100,true,Range[0],Range[1]);
			Graph.LineColor = 0xFF0000;
			Graph.AxisColor = 0xFFAA00;
			Graph.TextColor = 0xFFFFFF;
			Graph.redrawGraph();
			window.addContainer("Graph_1",Graph,10,30);
			trace ("MINMAX "+ CalcTools.returnMinMax(DataArray,"min"),CalcTools.returnMinMax(DataArray,"max"));
		
		}
		
		private function refreshGraph(){
			Graph = new GraphDraw(arrangeDataArrayX(DataArray),arrangeDataArray(DataArray),arrangeDataArray(TimeArray),DataArray,125,100,true,Range[0],Range[1]);
			Graph.LineColor = 0xFF0000;
			Graph.AxisColor = 0xFFAA00;
			Graph.TextColor = 0xFFFFFF;
			Graph.redrawGraph();
			window.refreshContainer("Graph_1",Graph);
			trace ("MINMAX "+ CalcTools.returnMinMax(DataArray,"min"),CalcTools.returnMinMax(DataArray,"max"));
		}
		
		
		// Die Arrays die im Graphen angezeigt werden sollen werden vorserts von allen null Stellen bereinigt
		
		private function arrangeDataArray(inArray):Array{
			trace ("unarrranged Array "+ inArray);
			var returnArray:Array = new Array();
			for (var i=0;i<inArray.length;i++){
				if (inArray[i] != null){
					returnArray.push(inArray[i]);
				}
				
			}
			trace ("Arranged Array "+ returnArray);
			return returnArray;
			
		}
		
		private function arrangeDataArrayX(inArray):Array{
			trace ("unarrranged Array "+ inArray);
			var returnArray:Array = new Array();
			for (var i=0;i<inArray.length;i++){
				if (inArray[i] != null){
					returnArray.push(DataArrayX[i]);
				}
				
			}
			trace ("Arranged Array "+ returnArray);
			return returnArray;
					
		}
	
	
		private function addGhosts(){
			trace ("Ghost Array :"+GhostArray);
			for (var i=0;i<GhostArray.length;i++){
				if (GhostArray[i]){
					var checker:String = i.toString();
					trace ("Ghost Array is true for:"+ checker);
					switch (checker){
						case "0":
						dispatchEvent(new SatCalcEvent(SatCalcEvent.ADD_GHOST,[Ident,GhostArray[i],"1",Image_1_koord,"1"]));
						break;
						case "1":
						dispatchEvent(new SatCalcEvent(SatCalcEvent.ADD_GHOST,[Ident,GhostArray[i],"2",Image_2_koord,"2"]));
						break;
						case "2":
						dispatchEvent(new SatCalcEvent(SatCalcEvent.ADD_GHOST,[Ident,GhostArray[i],"3",Image_3_koord,"3"]));
						break;
						case "3":
						dispatchEvent(new SatCalcEvent(SatCalcEvent.ADD_GHOST,[Ident,GhostArray[i],"4",Image_4_koord,"4"]));
						break;
						case "4":
						dispatchEvent(new SatCalcEvent(SatCalcEvent.ADD_GHOST,[Ident,GhostArray[i],"5",Image_5_koord,"5"]));
						break;
						case "5":
						dispatchEvent(new SatCalcEvent(SatCalcEvent.ADD_GHOST,[Ident,GhostArray[i],"6",Image_6_koord,"6"]));
						break;
					}
				
				}
				// Wenn nix im Ghost Array steht muss diese Stelle gesperrt werden!
				
				else {
					UnusedDropFields.push((i+1).toString())
					trace ("Dropfields unused: "+UnusedDropFields);
				}
			}
		}
		
		private function removeGhosts(){
			trace ("Ghost Array :"+GhostArray);
			for (var i=0;i<GhostArray.length;i++){
				if (GhostArray[i]){
					var checker:String = (i+1).toString();
					trace ("Ghost Array is true for:"+ checker);
						this.dispatchEvent(new SatCalcEvent(SatCalcEvent.REMOVE_GHOST,[checker,checker]));
						
				}
			}
		}
		
		private function deactivateUnusedDropFields(){
		 for (var i = 0; i<UnusedDropFields.length;i++){
		 	dispatchEvent(new SatCalcEvent(SatCalcEvent.DROP_DISABLE,[UnusedDropFields[i]]));
		 }
		}
		
		private function activateUnusedDropFields(){
		 for (var i = 0; i<UnusedDropFields.length;i++){
		 	dispatchEvent(new SatCalcEvent(SatCalcEvent.DROP_ENABLE,[UnusedDropFields[i]]));
		 }
		}
		
		private function checkDropfields(Dropfield:String){
			var returnVar:Boolean = false;
			var i:int
			while (i<DropFields.length){
				if (DropFields[i][1] == Dropfield){
					returnVar = true;
					break;
				}
				i++;
			}
			
			return returnVar;
		};
		
			
	} // Class Close

}//Package close