﻿// lädt ein Bild aus einer URL und zeigt es an

package{
	
	import flash.events.*;
	import flash.display.*;
	import flash.net.URLRequest;
	import FISEvents;	

	
	public class AutoImage extends Sprite {
		
		public var InBitmapData:BitmapData;
		public var Image:Bitmap;
		var BitLoader:Loader; // Loader für das Bild
		var url:String; // Die übergebene URL
		var URLReq:URLRequest; 
		public var Width:int; // Höhe des geladenen Bildes
		public var Height:int;// Breite des geladenen Bildes
		private var ShowImage:Boolean; // soll das Bild angzeigt werden?
		private var Version:String;
		
		public function AutoImage(urlin:String,showImage:Boolean = true) {
			Version = "V: 0.1 13.07.2010";
			trace (Version);
			url=urlin;
			BitLoader = new Loader();
			loadImage();
			BitLoader.contentLoaderInfo.addEventListener( Event.COMPLETE, onLoaderComplete );
			
		}
		
			public function loadImage(){
				trace ("loadingImage");
				URLReq=new URLRequest(url) 
				BitLoader.load(URLReq);	
			}
			
			private function showImage(){
				InBitmapData.draw(BitLoader);
				Image=new Bitmap(InBitmapData);
					if (ShowImage == true){
					addChild(Image);
					}
			}
			
			private function onLoaderComplete(e:Event){
				Width=BitLoader.content.width;
				Height=BitLoader.content.height;
				InBitmapData=new BitmapData(Width,Height);
				showImage();
				dispatchEvent(new FISEvents(FISEvents.IMAGE_INIT));
			}
			
			public function getBitmapData(){
				return InBitmapData;
			}
			
			
		
	}//Class close
}// Package close
		