﻿package com.utilities{
	
import flash.display.*;
import flash.geom.*;
import flash.utils.*;
import flash.text.*;
import flash.events.*;
import FISEvents;


	public class ClassField extends Sprite{
	/*Variablen für die markierung im Bild*/
	public var PosArray:Array; 					// Array in welchem die zu markierenden Pixelpositionen eingetragen sind
	public var ClassMark_BD:BitmapData;			// BitmapData für eine transparente Fläche auf welcher die Pixel markiert werden
	public var ClassMark_B:Bitmap;				// Bitmap zu ClassMark_BM
	public var ClassName:String;				// Name der Klasse
	public var ClassColor:uint;					// Farbe der Klasse
	public var X_Extend:int;
	public var Y_Extend:int;
	public var OutAt_X:int;						// an welcher Stelle erscheint die Klassifizierte Bitmap
	public var OutAt_Y:int;
	private var TargetPoint:Point;				// in koodinaten der Stage umgerechneter punkt ader Klassenanzeige
	
	/* Varriablen für die graphische Anzeige*/
	private var Group:Sprite 					// Container für alles
	private var AssignButt_shp:Shape;
	private var AssignButt_mc:MovieClip;   		// Der Button zum zuweisen der klasse
	private var TextBack_shp:Shape;				// Textfeld Hintergrund
	private var LabelText_mc:MovieClip;			
	private var LabelText:TextLabel;			// Feld für das Labeln der Klasse
	private var Text:TextField					// Textfeld 
	private var ColorPik_mc:MovieClip;			// MC für Farbwähler
	private var ColorPik_shp:Shape;				// Shape für ColoPik
	private var ColorPik:ColorPick;				// Der Color Picker
	private var Highligth_shp:Shape;			// ein Rahmen der Als Highlight on MouseOver um die Buttons gezogen wird
	
	/* Parameter zur Klassenerstellung(aus RGBSelect) können abgelegt werden*/
	
	public var R:int;
	public var G:int;
	public var B:int;
	public var T:int;
	
		public function ClassField(InArray:Array,W:int,H:int,X:int = 0,Y:int = 0){
			
			OutAt_X = X;
			OutAt_Y = Y;
			
			TargetPoint = this.globalToLocal(new Point(OutAt_X,OutAt_Y)); 
			
			ClassColor = 0xFF00FF00;
			ClassName = "NAME!";
			
			X_Extend = W;
			Y_Extend = H;
			
			Group = new Sprite();
			addChild(Group);
			drawAssign();
			drawTextField();
			initColorPicker();
			
			PosArray = new Array();
			PosArray = InArray;
			
			ClassMark_BD = new BitmapData(X_Extend,Y_Extend,true,0x00000000);
			ClassMark_B = new Bitmap(ClassMark_BD);
			ClassMark_B.x=TargetPoint.x;
			ClassMark_B.y=TargetPoint.y;
			addChild(ClassMark_B);
			
		} //Constructor close
		
		//Legt den Assign Button an
		
		private function drawAssign(){
		 // Hintergund	
		 AssignButt_mc = new MovieClip();
		 AssignButt_shp = new Shape();
		 
		 AssignButt_shp.graphics.beginFill(ClassColor,1);
		 AssignButt_shp.graphics.lineStyle(0.5,ClassColor);
		 AssignButt_shp.graphics.drawRect(0,0,15,20);
		 // Pfeil
		 AssignButt_shp.graphics.beginFill(0xFFFFFF,1);
		 AssignButt_shp.graphics.moveTo(0,0);
		 AssignButt_shp.graphics.lineTo(18,10);
		 AssignButt_shp.graphics.lineTo(8,10);
		 
		 AssignButt_shp.graphics.beginFill(0x505050,1);
		 AssignButt_shp.graphics.moveTo(0,20);
		 AssignButt_shp.graphics.lineTo(18,10);
		 AssignButt_shp.graphics.lineTo(8,10);
		 
		 AssignButt_mc.buttonMode = true;
		 AssignButt_mc.x = 0;
		 AssignButt_mc.y = 0;
		 Group.addChild(AssignButt_mc);
		 AssignButt_mc.addChild(AssignButt_shp);
		 AssignButt_mc.addEventListener(MouseEvent.MOUSE_DOWN, assignClass);
		 AssignButt_mc.addEventListener(MouseEvent.MOUSE_OVER,showFrame);
		 AssignButt_mc.addEventListener(MouseEvent.MOUSE_OUT,removeFrame);
		}
		
		//Legt das Text feld an
		
		private function drawTextField(){
			TextBack_shp = new Shape();
			Text = new TextField();
			var TextForm=new TextFormat();
			TextForm.size=11;
			TextForm.font = "Arial";
			//TextForm.bold = true;
			TextForm.align = TextFormatAlign.LEFT;
			Text.text = ClassName;
			Text.type = TextFieldType.INPUT;
			Text.setTextFormat(TextForm);
			Text.textColor = 0x000000;
			Text.x = 18;
			Text.y = 2;
			Text.height = 25;
			Text.width = 65;
			Text.maxChars=11;
			
			TextBack_shp.graphics.beginFill(0xFFFFFF);
			TextBack_shp.graphics.lineStyle(0.5,ClassColor);
			TextBack_shp.graphics.drawRect(17,0,65,20);
			
			/*LabelText_mc=new MovieClip();
			LabelText = new TextLabel();
			LabelText_mc.addChild(TextBack_shp);
			LabelText_mc.buttonMode = true;
			Group.addChild(LabelText_mc);
			
			LabelText_mc.addEventListener(MouseEvent.MOUSE_DOWN, callLabel);
			LabelText.addEventListener(FISEvents.DATA_READY, updateText);*/
			
			Group.addChild(TextBack_shp);
			Group.addChild(Text);
			Text.addEventListener(FocusEvent.MOUSE_FOCUS_CHANGE, updateText);
			
		}
		
		/* Zunächst wird nur ein MovieClip in der Klassenfarbe erstellt 
		in diesem wird über die Klasse ColorPick eine Farbe gewäht*/
		
		private function initColorPicker(){
			 ColorPik_mc = new MovieClip();
			 ColorPik_shp = new Shape();
			 
			 ColorPik_shp.graphics.beginFill(ClassColor,1);
			 ColorPik_shp.graphics.lineStyle(0.5,ClassColor);
			 ColorPik_shp.graphics.drawRect(0,0,82,10);
				
			 ColorPik_mc.buttonMode = true;
			 ColorPik_mc.y = 22;
			 Group.addChild(ColorPik_mc);
			 ColorPik_mc.addChild(ColorPik_shp);
			 ColorPik = new ColorPick(5,5,14);
			 ColorPik_mc.addEventListener(MouseEvent.MOUSE_DOWN,pickColor);
			 ColorPik_mc.addEventListener(MouseEvent.MOUSE_OVER,showFrame);
			 ColorPik_mc.addEventListener(MouseEvent.MOUSE_OUT,removeFrame);
		}
		
		
		private function pickColor(e:MouseEvent){
			ColorPik.x = 18;
			ColorPik.y = 0;
			addChild(ColorPik);
			ColorPik.showPickField()
			ColorPik.addEventListener(MouseEvent.MOUSE_DOWN,changeColor,false, 0, true);
		}
		
	private function changeColor(e:MouseEvent){
			ClassName = Text.text;
			ClassColor = ColorPik.PickedValue;
			drawAssign();
			drawTextField();
			initColorPicker();
			markClass();
			showMarkedClass();
	}
		
		
	public function markClass(){
		ClassMark_BD = new BitmapData(X_Extend,Y_Extend,true,0x00000000);
		ClassMark_BD.fillRect(new Rectangle(0, 0,X_Extend, Y_Extend), 0x00FFFFFF)
			for (var i=0; i<PosArray.length;i++){
				ClassMark_BD.setPixel32(PosArray[i][0],PosArray[i][1],ClassColor);
			}
	}
		
	public function showMarkedClass(){
		removeChild (ClassMark_B);
		ClassMark_B = new Bitmap(ClassMark_BD);
		// Damit es an den X/Y der Stage gesetzt wird
		
			var targetPoint:Point = this.globalToLocal(new Point(OutAt_X,OutAt_Y)); 
			ClassMark_B.x= targetPoint.x;
			ClassMark_B.y= targetPoint.y;
			trace (OutAt_X + OutAt_Y+" zu "+ targetPoint.x+ targetPoint.y);
			addChild(ClassMark_B);
			ClassName = Text.text;
	}
			
		
/*		Gibt das Signal ab, dass der Assign Button gedrückt wurde Die 
		Ausführung der Markierung erfolgt von aussen damit vorher das PosArray
		durch ein aktuelles ersetzt werden kann*/
		
		private function assignClass(e:MouseEvent){
		dispatchEvent(new FISEvents(FISEvents.IMAGE_INIT));
		}
		
		public function switchVisibility(vis:Boolean){
			switch (vis){
				case true:
				addChild(ClassMark_B);
				break;
				case false:
				removeChild(ClassMark_B);
				break;
			}
		}
		
		private function updateText(e:FocusEvent){
			ClassName = Text.text;
		}
		
		private function callLabel(e:FocusEvent){
			//LabelText_mc.addChild(LabelText);
			LabelText_mc.addChild(Text);
		}
		
		/*Zieht einen Rahmen um das anvisierte Objekt*/
		
		private function showFrame(e:MouseEvent){
			trace (ColorPik_mc.x);
			var startX = e.currentTarget.x;
			var startY = e.currentTarget.y;
			var endX = e.currentTarget.width;
			var endY= e.currentTarget.height;
			Highligth_shp = new Shape();
			Highligth_shp.graphics.lineStyle(1,0xFFFFFF);
			Highligth_shp.graphics.drawRect(startX,startY,endX,endY);
			Group.addChild(Highligth_shp);
		}
		
		private function removeFrame(e:MouseEvent){
			Group.removeChild(Highligth_shp);
		}
		
			
	
	}// Class close
} // package close