﻿package com.utilities {
	
import flash.display.*;
import flash.geom.*;
import flash.utils.*;
import flash.text.*;
import flash.events.*;
import FISEvents;

	public class ColorPick extends Sprite{
		
		public 	var ColorList:Array;  		// Farben die im ColorPicker erscheinen sollen
		private var PICKER:Sprite;			// Container für alles
		private var Picker_BD:BitmapData;	// Bitmap Data trägt die Farbinformationen
		private var Picker_B:Bitmap;		// stellt Picker_BD dar
		private var Browse_BD:BitmapData;	// Das Farbfeld das beim browsen durch die Farben die momentane farbe anzeigt
		private var Browse_B:Bitmap;	//
		public 	var PickedValue:uint;		// gewählte Farbe
		private  var browseColor:uint;		// Farbe die beim auswählen aktuell unter dem Zeiger ist
		private var W:int					// wie viel Kästchen breit
		private var H:int					// wie viel Kästchen hoch
		private var EXT:int					// wie viel Pixeln pro Kästchen
		private var Rect:Rectangle;			// zum Füllen der Picker_BD für die Pickfläche
		private var Frames:Shape;			// Rahmen um die Flächen
		private var Headline:TextField;		// Beschriftung des Farbfläche
		public var HeadlineTXT:String;
		
		/* rein kommen: wie viel Kästchen breit (w) und hoch (h) ist der Picker 
		und wie breit/hoch (ext) ist ein kästchen in Pixeln sowie ein Array mit den Farbwerten*/
		
		public function ColorPick(...args){  
		
		W=args[0];
		H=args[1];
		EXT=args[2];
		
		if (args[3]){
			 ColorList = new Array();
			 ColorList = args[3];
		}
		else{
			ColorList = new Array();
			//ColorList = [0x000000,0xFFFFFFFF,0xF49AC1,0xF26522,0x8DC63F,0x009933,0x6DCFF6,0x00FFFF,0x0000FF,0x5050FF]
			}
		
		HeadlineTXT= "Farbe wählen!";
		
		PICKER = new Sprite();
		addChild(PICKER);
		createColors();
		createPickField();
		createFrames();
		
		}//constructor close
		
		private function createColors(){
			var R:int = 0xFF;
			var G:int= 0x00;
			var B:int = 0x00;
			var col = uint;
			
			var yval = 255;
			var xval = (W*H)/4
			var steig = 255/(xval);
			trace("xval "+xval);
			trace("steig "+steig);
			
			// Rot startet bei 255 und geht Richtung Gelb durch Erhöhung von grün
			for (var r = 0; r < xval; r++){
				G=r*steig;
				col= R<< 16 ^ G << 8 ^ B;
				ColorList.push(col);
				trace ("G "+G);
				
			}
			// Grün entsteht durch erniedrigung von rot
			for (var g = 0; g <xval; g++){
				R=255-g*steig;
				col= R<< 16 ^ G << 8 ^ B;
				ColorList.push(col);
				trace ("R "+R); 
			}
			
			// Blau entsteht durch Erhöung von blau 
			for (var b = 0; b <xval; b++){
				B=b*steig
				col= R<< 16 ^ G << 8 ^ B;
				ColorList.push(col);
				trace ("B "+B); 
			}
			// dunkel Blau/Violett entsteht durch erniedrigung von Grün 
			for (var v = 0; v <xval; v++){
				G=255-v*steig;
				col= R<< 16 ^ G << 8 ^ B;
				ColorList.push(col);
				trace ("G "+G); 
			}
			
		
		}
		
		// Das Picker Feld wird iniitiert
		public function createPickField(){
			var count = 0;
			Browse_BD = new BitmapData(EXT,H*EXT,false);
			Browse_BD.floodFill(1,1,0xFFFFFF);
			Browse_B = new Bitmap(Browse_BD);
			Browse_B.x=-1-EXT;
			Picker_BD = new BitmapData((W*EXT),(H*EXT),false,0xFF0000);
			trace(Picker_BD.width + " "+Picker_BD.height);
				for (var row=0; row<=H; row++){
					for (var col=0; col<=W; col++){
						Rect = new Rectangle(col*EXT,row*EXT,EXT,EXT);
						trace ("creating rect at ROW: "+row+" COL:"+col+" with color: "+ColorList[col+row]+"Rect :"+Rect.x +Rect.y+"count:" +count );
							if (count<ColorList.length){
								Picker_BD.fillRect(Rect,ColorList[count]);
							}
							else{
								Picker_BD.fillRect(Rect,0xFF000000);
							}
						count = count+1;
					}
				}
		Picker_B = new Bitmap(Picker_BD);
		}
		
		private function createFrames(){
		 Frames = new Shape();
		 Frames.graphics.lineStyle(2,0x000000);
		 Frames.graphics.drawRect(-0.5-EXT,0,EXT,H*EXT);
		 Frames.graphics.drawRect(0,0,W*EXT,H*EXT);
		
		}
		
		public function showPickField(){
			PICKER.addChild(Frames);
			PICKER.addChild(Picker_B);
			PICKER.addChild(Browse_B);
			//PICKER.addChild(Headline);
			addEventListener(MouseEvent.MOUSE_MOVE,browseColors,false, 0, true);
			addEventListener(MouseEvent.MOUSE_DOWN,chooseColor,false, 0, true);
			trace("showingn CP");
		}
		
		private function browseColors(e:MouseEvent){
			browseColor=Picker_BD.getPixel32(mouseX,mouseY);
			Browse_BD.floodFill(1,1,browseColor);
			trace (browseColor);
		}
		
		private function chooseColor(e:MouseEvent){
			PickedValue = browseColor;
			removeEventListener(MouseEvent.MOUSE_MOVE,browseColors);
			removeEventListener(MouseEvent.MOUSE_DOWN,chooseColor);
			PICKER.removeChild(Picker_B);
			PICKER.removeChild(Browse_B);
			PICKER.removeChild(Frames);
			//PICKER.removeChild(Headline);
		}
		
		
	
	}//Class close
}//Package close