﻿/*################################################################
# 				ExtClip										 	##
#														     	##
# Zur Repräsentation von extern geladenen Bildern oder Kanälen. ##
#															 	##
#														     	##
#(c) 2008, Henryk Hodam 										##
##################################################################*/


package com.utilities {
	
	import ClassifierBase;
	import SatCalculator;
	import Display;
	import ImageCalc;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.text.*;
	
	public class ExtClip extends Display {
		
	public var Type:String;
	public var clip:MovieClip;
	public var InBitmap:Bitmap; //Die Bitmap die an den Clip übergeben wurde
	public var InArray:Array; 	//Array das aus dem Clip übergeben wurde
	public var typeStored:String // Was wurde gesichert "Array" oder "Bitmap"
	public var XKoord:int;
	public var YKoord:int;
	public var Number_:int;
	public var Counter:String;		
	public var Name:String;
	public var datum:String;
	public var Type_:String;
	public var Resolution:int;
	public var Unit:String;
	public var kanal:String;

	public var Classes:Array;
	public var LinearFunct:Array; //Die Function nach der die Bilddaten umgeformt werden wenn das Bild ein Value Image ist
	public var ValueUnit:String; //Die Eiheit des ValueImage
	public var StretchFactor:Array; // ein Array für den minimalen und maximalen Factor der Standardabweichungsmultipliaktion beim Streching
	public var Methtext; // für compatibilität mit ImageClip
	public var DataWidth:int; // Abmessungen der übergebenen Daten
	public var DataHeight:int;
	public var Ghost_mc:MovieClip; // Eine MC als kopie des Clips
	public var Ghost:Bitmap; // Eine Bitmap als Kopie des Clips
	public var ColorScale:String;
	public var Deleteable:Boolean;
	private var ClassBase:ClassifierBase;// für Umrechnungen
	
	

	
	public function ExtClip(InData:Object,num:int=0,nam:String="empty",dat:String="empty",type_:String="empty",res:int=0,un:String="empty",ch:String="empty",w:int=500,h:int=500){
	
		super (w,h);
		
		DataWidth=w;
		DataHeight=h;
		
		if ( InData instanceof Bitmap){
			trace ("speichertBitmap");
			InBitmap = InData as Bitmap;
			typeStored = "Bitmap";
			trace ("checking colorscale");
			ColorScale = grayOrColor();
		}
		if ( InData instanceof Array){
			trace("speichertArray");
			typeStored = "Array";
			ColorScale = "grey";
			InArray = InData as Array;
		}
		
		StretchFactor = new Array(1,3.5);
		LinearFunct = new Array();
		Number_ = num;
		Counter = Name;
		Name = nam;
		datum = dat;
		Type_ = type_;
		Resolution = res;
		Unit = un;
		kanal = ch;
		Methtext = ch;
		clip = new ExtBild();
		// Ist ein RGB Bild eingefügt worden springt der ExtBild MovieClip  an die entsprechende Stelle
		switch (Type_){
		case "RGB":
			if (ColorScale == "color"){
			clip.gotoAndStop(2)
			}
			if (ColorScale == "grey"){
			clip.gotoAndStop(1)
			}
		break;
		case "Overlay":
			clip.gotoAndStop(2)
		break;
		case "SCREEN":
			clip.gotoAndStop(3)
		break;
		case "Classes":
			if (ColorScale == "color"){
			clip.gotoAndStop(2)
			}
			if (ColorScale == "grey"){
			clip.gotoAndStop(1)
			}
		break;
		}
		// Ist ein Channel Bild eingefügt worden springt der ExtBild MovieClip  an die entsprechende Stelle
		switch (kanal){
		case "RED":
			clip.gotoAndStop(3);
		break;
		case "GREEN":
			clip.gotoAndStop(4);
		break;
		case "BLUE":
			clip.gotoAndStop(5);
		break;
		
		Ghost_mc = new ExtBild();
		Ghost_mc.gotoAndStop(clip.currentFrame);
		
		}
		
		clip.buttonMode=true;
		
		clip.Date_text.text = datum;
		clip.Name_text.text = Name;
		clip.Type_text.text = kanal;
		//clip.Nummer_text.text = Number_.toString();
		addChild(clip);
		
		
		Ghost_mc = new ExtBild();
		Ghost_mc.Date_text.text = datum;
		Ghost_mc.Name_text.text = Name;
		Ghost_mc.Type_text.text = kanal;
		//Ghost_mc.Nummer_text.text = Number_.toString();
		Ghost_mc.gotoAndStop(clip.currentFrame);
		//addChild(Ghost_mc)
		//Ghost_mc.visible = false;
		
		var GhostBitmap:BitmapData = new BitmapData(clip.width,clip.height,true,0x00FFFFFF);
		GhostBitmap.draw(clip);
		Ghost = new Bitmap(GhostBitmap);
		
		Deleteable = false;
		
		
	
	}
	
	public function returnRGBat(X:int,Y:int):Array{
		var returnArray = new Array();
		var color;
		color = InBitmap.bitmapData.getPixel(X,Y);
		var R:int = (color & 0xff0000) >> 16;
		var G:int = (color & 0xff00) >> 8;
		var B:int = color & 0xff;
		returnArray.push(R);
		returnArray.push(G);
		returnArray.push(B);
		return returnArray;
	}
	
	// An getClass werden die Koordinaten aus dem Bild übergeben die Funktion sucht dann zum RGB Wert an dieser Stelle eine Klasse
	// aus dem Classes Array falls vorhanden.
	
	public function getClass(X:int,Y:int):String{
		var Value:Array = returnRGBat(X,Y);
		var returnValue:String;
		trace (Value);
			for (var i = 0; i<Classes.length;i++){
				if (Classes[i][1] == Value[0] && Classes[i][2] ==Value[1] && Classes[i][3] == Value[2]){
					trace (Classes[i][0]);
					returnValue=Classes[i][0];
				}
			}
		return returnValue ;
	}		
		
	
	
	public function returnArray(){
		return InArray;
	}
	
	public function returnDataArray(){
		return InArray;
	}
	
	public function returnDate(){
		return kanal;
	}
	
	
	// Soll feststellen ob es sich um ein Graustufen oder Farbbild handelt, damit das Icon entsprechend dargestellt wird.
	// Für 10 zufällig gewählte Punkte im Bitmap wird geprüft, ob die gleichen Werte auf RGB liegen stimmt am Ende die Anzahl mit 10 überein ist es ein Graustufenbild
	private function grayOrColor():String{
		var returnString:String;
		var RandPosArray:Array = new Array();
		var TestNumber:int=0;
		for (var i=0;i<10;i++){
			var tempArray:Array = new Array();
			tempArray.push(getRandomNum("x"),getRandomNum("y"));
			RandPosArray.push(tempArray);
		}
		
		for (var g=0;g<RandPosArray.length;g++){
			
			var Tool = new ClassifierBase();
			ColVal_RGB:Array;
			ColVal_RGB = Tool.colValueToRGB(InBitmap.bitmapData.getPixel(RandPosArray[g][0],RandPosArray[g][1]));
			trace (ColVal_RGB);
			if (ColVal_RGB[0] == ColVal_RGB[1] &&  ColVal_RGB[0] == ColVal_RGB[2]){
				TestNumber++;
			}
		}
		
		if (TestNumber == 10){
			returnString = "grey"
		}
		else{returnString = "color"}
		trace ("Farbe: " +returnString);
		return returnString;
	}
	
	
	// Gibt eine zufällige nummer zurück die im Bereich der Bimtap Koodinaten liegt
	private function getRandomNum(Direct:String):Number{
		var randomNum:Number;
		switch(Direct){
			case "x":
			 randomNum = Math.floor(Math.random() * (DataWidth - 1 + 1)) + 1;
   			break;
			case "y":
			 randomNum = Math.floor(Math.random() * (DataHeight - 1 + 1)) + 1;
   			break;
		}
		return randomNum;
	}
	
	// überführt das gespeicherte Array in ein Werte Array
	
	public function transformDataArray(){
		ClassBase = new ClassifierBase();
		InArray = ClassBase.linearArrayTransform(InArray,LinearFunct);
		ClassBase=null;
	}
	
	// ZusatzText anzeigen
	public function addText(addtext:String){
		clip.Additional_text.text = addtext;
		addChild(clip);
	}
	
	/*
	
	public function destroy(){
		trace("killing em all");
		ContentArray=null; 
		ContentDataArray=null;
		Method = null;
		XKoord=null
		YKoord=null
		KoordArray=null
	 	Komptext=null
	 	Methtext=null
	 	Counter=null
	 	Datum_out=null
		PreDef=null
		removeChild (clip); 
		clip=null;
		
		 
	}*/
		
		
	
		
	}	//Class close
}	// Package close