﻿

// Die Klasse ImageArray Lädt aus ihr als Array übergebenen URLS Bilder ein und speichert sie selbst als Array ab


package com.utilities {
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.text.*;
	import FISEvents;
	import ImageCalc;
	
	
	public class ImageArray extends Sprite {
		
		public var URL_Array:Array; // Ein String Array aus URLs die an das Object übergeben wurden und die Pfad der zu ladenden Bilder enthält
		public var TYPE_Array:Array;// enthält die typen der übergebenen Bilder
		public var CHAN_Array:Array;// enthält die typen der übergebenen Bilder
		public var CLASS_Array:Array;// enthält die typen der übergebenen Bilder
		public var BitmapArray:Array; // Beinhaltet die geladenen Bitmaps;
		public var ImageDimensions:Array; // Speichert die Dimensionen der Bilder (Als Array im Array[x,y];
		public var ImagesLoaded:int;	// zählte wie viel Bilder geladen wurden;
		private var ImageLoader:AutoImage;// Lädt Bilder
		public static var VersionDate:String ="11.11.2010"; 
		
		public function ImageArray(urlArray:Array,typeArray:Array,chanArray:Array){
			
			trace ("ImageArray Version: " +VersionDate);  
			
			
			ImagesLoaded = 0
			URL_Array=urlArray;
			TYPE_Array = typeArray;
			CHAN_Array = chanArray;
			trace ("BILDER ZU LADEN " + URL_Array);
			ImageDimensions = new Array(URL_Array.length);
			BitmapArray = new Array();
		 	loadImages();
		} // Constructor close
		
		private function loadImages(){
				
				trace ("TYP  " + TYPE_Array[ImagesLoaded]);
				
				if (TYPE_Array.length != URL_Array.length){
					ImageLoader = new AutoImage(URL_Array[ImagesLoaded],false);
					ImageLoader.addEventListener(FISEvents.IMAGE_INIT, pushToBitmapArray,false, 0, true);
				}
				if (TYPE_Array.length == URL_Array.length){
					if (TYPE_Array[ImagesLoaded] == "RGB"||TYPE_Array[ImagesLoaded] == "Classes"||TYPE_Array[ImagesLoaded] == "Overlay"){
						ImageLoader = new AutoImage(URL_Array[ImagesLoaded],false);
						ImageLoader.addEventListener(FISEvents.IMAGE_INIT, pushToBitmapArray,false, 0, true);
					}
					else if (TYPE_Array[ImagesLoaded] == "channel"||TYPE_Array[ImagesLoaded] == "ValueImage"){
						trace ("PUSHING AS ARRAY");
						ImageLoader = new AutoImage(URL_Array[ImagesLoaded],false);
						ImageLoader.addEventListener(FISEvents.IMAGE_INIT, pushAsArray,false, 0, true);
					}
					
				}
				
		}
		
		private function pushToBitmapArray(e:FISEvents){
			ImageLoader.removeEventListener(FISEvents.IMAGE_INIT, pushToBitmapArray);
			BitmapArray.push(ImageLoader.Image);
			ImageDimensions[ImagesLoaded] = [ImageLoader.Image.width,ImageLoader.Image.height];
			ImagesLoaded++;
			if (URL_Array.length > ImagesLoaded){
				loadImages();
				trace ( "zu laden : " + ImagesLoaded + "von" + URL_Array.length);
				dispatchEvent(new FISEvents(FISEvents.CALC_PROGRESS));
			}
			else{
				dispatchEvent(new FISEvents(FISEvents.CALC_PROGRESS));
				dispatchEvent(new FISEvents(FISEvents.IMAGE_INIT));
			}
			trace("ImageDimensions:  " + ImageDimensions[ImagesLoaded]);
		}
		
		
		
		private function pushAsArray(e:FISEvents){
			ImageLoader.removeEventListener(FISEvents.IMAGE_INIT, pushAsArray);
			var ContainBitmap:Bitmap = new Bitmap();
			var ContainArray:Array = new Array();
			var ChannelGetter:ImageCalc = new ImageCalc();
			ContainBitmap = ChannelGetter.extractChannel(ImageLoader.Image,CHAN_Array[ImagesLoaded]);
			ContainArray = ChannelGetter.BitmapToArray(ContainBitmap);
			
			ImageDimensions[ImagesLoaded] = [ContainBitmap.width,ContainBitmap.height];
			
			BitmapArray.push(ContainArray);
			ImagesLoaded++;
			if (URL_Array.length > ImagesLoaded){
				loadImages();
				trace ( "zu laden : " + ImagesLoaded + "von" + URL_Array.length);
				dispatchEvent(new FISEvents(FISEvents.CALC_PROGRESS));
			}
			else{
				dispatchEvent(new FISEvents(FISEvents.CALC_PROGRESS));
				dispatchEvent(new FISEvents(FISEvents.IMAGE_INIT));
			}
			
			trace("ImageDimensions:  " + ImageDimensions);
		}
		
		public function destroy(){
			trace("killing em all");
			BitmapArray=null; 
			TYPE_Array=null;
			CHAN_Array = null;
			URL_Array=null
			ImagesLoaded=null
			ImageLoader=null
			
		}
		
	
	}//public class close
} // package close