﻿

package com.utilities {
	
	import flash.net.FileReference;	
	import flash.display.*;
	import flash.net.*;
	import flash.utils.*;
 	import com.adobe.images.*;
	import flash.text.*;
	
	public class SaveMap extends Sprite{
		
		var LegendData:Array;			// 2D Array beinhaltet: Reihe: Name der Klasse Spalte:Farbe der Klasse
		var ImageSource_BD:BitmapData; 	// BitmapData nimmt den Inhalt des übergebenen Movieclips auf
		var ImageStream:ByteArray;		// ByteArray wird aus dem BitmapData des MC über JPGEncoder erzeugt
		var File:JPGEncoder;			// Encoder für das JPG
		var Header:URLRequestHeader;
		var ImageURLRequ:URLRequest;
		var ImageQual:int;				// Bildqualität 0-100
		var Layout_mc:MovieClip;		// MovieClip auf dem Legende und Karte zusammengeführt werden
		var LegendPos:Array;			//Position der Legende
		
		public function SaveMap(InMC:MovieClip,MetaData:Array,Qual:int=90,Legend:Boolean = true){
			
			Layout_mc = new MovieClip();
			LegendData = MetaData;
			LegendPos =[InMC.width+5,5];
			ImageQual = Qual;
			ImageSource_BD = new BitmapData (InMC.width+105, InMC.height);
			if (Legend == true){
			createLegend();
			}
			Layout_mc.addChild(InMC);
			ImageSource_BD.draw(Layout_mc);
			saveMap();
			
			
		
		}//Constructor close
		
		private function saveMap(){
			File = new JPGEncoder(ImageQual);
			
			ImageStream = File.encode(ImageSource_BD);
			Header = new URLRequestHeader("Content-type", "application/octet-stream");
			
			var ImageURLRequ:URLRequest = new URLRequest("jpg_encoder_download.php?name=Klassifikation.jpg");
			ImageURLRequ.requestHeaders.push(Header);
			
			ImageURLRequ.method = URLRequestMethod.POST;
			ImageURLRequ.data = ImageStream;
			navigateToURL(ImageURLRequ, "_blank");
			addChild(Layout_mc);
		}
		
		private function createLegend(){
			for (var i=0; i < LegendData.length;i++){
				var ColField_BD:BitmapData = new BitmapData(50,20,false,LegendData[i][1]);
				var ColField_B:Bitmap = new Bitmap(ColField_BD);
				ColField_B.y = LegendPos[1]+ (i*23);
				ColField_B.x = LegendPos[0];
				Layout_mc.addChild(ColField_B);
				var ClassName:TextField = new TextField();
				ClassName.text = LegendData[i][0];
				ClassName.y = LegendPos[1]+ (i*23);
				ClassName.x = LegendPos[0]+53;
				Layout_mc.addChild(ClassName);
			}	
		}
				
			
			
	
	}// Class close
}// package close