﻿package com.utilities{
	
import flash.display.*;
import flash.geom.*;
import flash.utils.*;
import flash.text.*;
import flash.events.*;


	public class TextLabel extends Sprite{
		public var InputField:TextField; 		//Das Textfeld in welches eingegeben wird
		public var InputText:String;			// Der eingegebene Text
		private var Background:Shape;			// Hintergrund
		private var CloseButt_mc:MovieClip;		// der Schliessen Button 
		private var CloseButt_shp:Shape;		// Grafik für den Close Button
		private var Comment_txt:TextField;		// Text der den inputKasten beschreibt
		public  var Comment:String;
		private var Container:Sprite; 			// Container für Alles
		private var X_Ext:int;					// Breite
		private var Y_Ext:int;					// Höhe
		public var TextSize:int;				// Schriftgrösse
		public var TextColor:int;				// Schriffarbe
		public var Format:TextFormat;			// Formatierung des Textes
		
		
		
		public function TextLabel(W:int = 100,H:int = 30,TS:int = 12,TC:int = 0x000000){  
			TextSize = TS
			X_Ext = W;
			Y_Ext = H;
			TextColor = TC;
			Format = new TextFormat();
			Format.size=TextSize;
			Format.font = "Arial";
			Format.bold = false;
			Format.align = TextFormatAlign.LEFT;
			Container = new Sprite();
			addChild(Container);
			layoutInputField();
			layoutCloseButton();
			
			Comment =  "Eingabe mit Return";
			
		}//constructor close
		
		public function layoutInputField(){
			//Rahmen anlegen
			
			Background = new Shape();
			Background.graphics.beginFill(0xFFFFFF);
			Background.graphics.lineStyle(0.5,TextColor);
			Background.graphics.drawRect(0,0,X_Ext,Y_Ext);
			Container.addChild(Background);
			
			//Textfeld anlegen
			
			trace ("creating input field")
			InputField = new TextField;
			InputField.setTextFormat(Format);
			InputField.type = TextFieldType.INPUT;
			InputField.height =Y_Ext;
			InputField.width = X_Ext;
			InputField.maxChars=20;
			InputField.textColor = TextColor;
			Container.addChild(InputField);
			InputField.addEventListener(KeyboardEvent.KEY_DOWN, confirmInput)
		}
		
		public function layoutCloseButton(){
			//Rahmen anlegen
			CloseButt_shp = new Shape();
			CloseButt_mc = new MovieClip();
			Comment_txt = new TextField();		
			//Comment_txt.text = Comment;
			CloseButt_shp.graphics.beginFill(0xFF0000);
			CloseButt_shp.graphics.lineStyle(0.5,TextColor);
			CloseButt_shp.graphics.drawRect(0,0-(Y_Ext/3),X_Ext,Y_Ext/3);
			Container.addChild(CloseButt_shp);	
		}
		
		/*Wenn Return gedrückt wird (keyCode = 13) beende die eingabe und update den Text*/
		
		private function confirmInput(e:KeyboardEvent){
			trace (e.keyCode);
			switch (e.keyCode){
				case 13 :
				InputText = InputField.text;
				closeInput();
				
				break;
			}
		}
		
		/*TextFeld wird geschlossen und ein Event wird
		abgegeben welches ausserhalb abgefangen werden kann*/
		
		public function closeInput(){
			dispatchEvent(new FISEvents(FISEvents.DATA_READY));
			removeChild(Container);
		}

		
		
		
		
	
	}//Class close
}//Package close