﻿
// Zum Auslesen von XML Formatierten MetaInformationen zu Bildaten in SatCalculator

package com.utilities {
	
	//import.flash.XML.*;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.net.*;
	import FISEvents;
	
	public class ToolsMetaXML extends Sprite {
		
		private var InitDataURL:String;
		private var InitDataRequest:URLRequest;	// Request zum Laden externer Variablen
		private var InitDataLoader:URLLoader;	// Loader zum Laden externer Variablen
		//private var InitData:URLVariables;	
		private var XMLData:XML;				// enthält die eingelesenen Metadaten
		private var XMLDataClass:XML;				// enthält die eingelesenen Metadaten
		public  var ToolsClasses:Array;
		public var NumberofTools:int;
		
		public  var MetaDataArray:Array;		// Mehrdimensionales Array, dass Alle Metadaten aufnimmt 
		private var MetaDataRow:Array
		
		public  var ConfigDataArray:Array;		// Mehrdimensionales Array, dass Alle Allgemeinen Konfigurationsdaten aufnimmt 
		private var ConfigDataRow:Array
		public var NumberofConfigs:int;
		
		private var RowsCreated:int;			// Wie viele Reihen wurden erstellt
		
		
		public function ToolsMetaXML(url:String){
			RowsCreated = 0;
			InitDataURL = url;
			InitDataRequest = new URLRequest(InitDataURL);
			InitDataLoader = new URLLoader();
			InitDataLoader.load(InitDataRequest);
			InitDataLoader.addEventListener(Event.COMPLETE, readExternalData);
			
		} // Constructor close
		
		
		private function readExternalData(e:Event){
    		
			XMLData = new XML(e.target.data);
			
			ToolsClasses = new Array();
			
			NumberofConfigs=XMLData.CONFIG.length();
			
			ConfigDataArray = new Array(NumberofConfigs);
			
			getConfigData();
			getMetaData();
			
			//getMetaData(0);
		}
		
		
		private function getConfigData(){
			var Nummer:int =XMLData.CONFIG.SaveData;
			ConfigDataArray[0] = StringToBool(XMLData.CONFIG.SaveData);
			ConfigDataArray[1] = StringToBool(XMLData.CONFIG.ColorPik);
			ConfigDataArray[2] = StringToBool(XMLData.CONFIG.Swipe);
			dispatchEvent(new FISEvents(FISEvents.DATA_READY,"CONFIG"));
		}
		
		//Legt die Tabelle für die Metadaten an

		private function getMetaData(){
			
			
			
			if (XMLData.TOOL){
				NumberofTools=XMLData.TOOL.length();
				MetaDataArray= new Array(NumberofTools);
				
				for (var i = 0; i < NumberofTools; i++){
					
					MetaDataRow = new Array();
					
					var Nummer:int =XMLData.TOOL[i].Count;
					var Name_:String = XMLData.TOOL[i].Name.toString();
					var Class_:String = XMLData.TOOL[i].Class_.toString();
					var VariablesArray:Array = returnVarArray(i);
					
					MetaDataRow[0] = Nummer;
					MetaDataRow[1] = Name_;
					MetaDataRow[2] = Class_;
					MetaDataRow[3] = VariablesArray;
		
					MetaDataArray[i] = MetaDataRow;
					
					var newClass:String = Class_;
					ToolsClasses.push(newClass);
							
					RowsCreated++; 
					
						if (NumberofTools==RowsCreated){
							trace (MetaDataArray);
							dispatchEvent(new FISEvents(FISEvents.DATA_READY,"TOOLS"));
							//getMetaData(RowsCreated);
						}
					
					
				}
			}
			
			
		}
		
		private function returnVarArray(pos:int):Array{
		var tempArray = new Array();
		var Variables:XMLList = XMLData.TOOL[pos].VarArray.children();
		trace ("VAR ARRAY Length: "+Variables.length());
			for (var i = 0; i < Variables.length();i++){;
				var tempVar =Variables[i];
				tempArray.push(tempVar);
				trace ("VAR ARRAY: "+tempArray);
			}
			return tempArray;
		}
		
		private function StringToBool(inString:String):Boolean{
			var returnBool:Boolean;
			switch(inString){
				case "true":
				returnBool = true;
				break;
				case "false":
				returnBool = false;
				break;
			}
			return returnBool;
		}
		

		
	}//public class close
} // package close